2002-06-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* COPYING[1.2]:
	Add exemption permitting use with OpenSSL.

2002-06-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/version.scm[14.208]:
	Update version for 7.7.1 release.

	* microcode/ntapi.h[1.13], microcode/ntsock.c[1.13],
	  microcode/version.h[11.184]:
	Implement server_channel_n_read, which is required by the runtime
	system to use server sockets.

2002-06-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/ntscreen.c[1.47]:
	Initialize "length" field of structure prior to call.  Thanks to
	Lawrence Wood for the bug fix.

2002-06-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-summary.scm[1.48]:
	Fix bug: expunge could generate errors due to mistaken overwriting of
	the summary-buffer mark for a deleted message.

2002-04-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/runtime.pkg[14.413], runtime/uenvir.scm[14.57]:
	Use lambda abstraction rather than bypassing it.

	* runtime/lambda.scm[14.17]:
	Implement LAMBDA-NAMES-VECTOR.

2002-04-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/ntsock.c[1.12]:
	Add missing call to transaction_begin.

2002-04-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/mit-syntax.scm[14.6]:
	Don't reserve names in top-level environments.  The revised report
	requires that top-level definitions act like assignments when the name
	is already bound.

	* runtime/syntactic-closures.scm[14.10]:
	Fix history procedures to specially handle null history.  This
	occasionally comes up with syntactic keywords.

2002-03-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/bchdmp.c[9.90.4.1], microcode/bchgcl.c[9.54.4.1],
	  microcode/bchmmg.c[9.98.8.1], microcode/boot.c[9.105.8.1],
	  microcode/confshared.h[11.3.2.1], microcode/const.h[9.46.8.1],
	  microcode/debug.c[9.53.8.1], microcode/fasl.h[9.38.12.1],
	  microcode/fasload.c[9.91.4.1], microcode/gccode.h[9.58.8.1],
	  microcode/gctype.c[9.34.12.1], microcode/interp.c[9.92.8.1],
	  microcode/lookup.h[9.55.8.1], microcode/memmag.c[9.66.8.1],
	  microcode/ppband.c[9.50.8.1], microcode/purify.c[9.61.4.1],
	  microcode/types.h[9.38.8.1], microcode/wabbit.c[1.9.4.1]:
	Eliminate references to TC_NULL in favor of TC_FALSE.  Add symbolic
	definitions for datum values of TC_CONSTANT.

2002-03-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-response.scm[1.45], imail/todo.txt[1.138]:
	If EOF encountered while reading server response, signal an error.
	This prevents the uninterruptible infinite loop when the network goes
	down while the connection is open.

2002-03-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-file.scm[1.81], imail/imail-rmail.scm[1.70],
	  imail/imail-top.scm[1.283], imail/imail-umail.scm[1.51],
	  imail/imail.pkg[1.96], imail/load.scm[1.39], imail/todo.txt[1.137]:
	Change M-o command to act like o if the output file is in a known
	format.

2002-03-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/fgopt/closan.scm[4.30]:
	Tweak comment.

2002-03-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/configure.in[11.16]:
	Broaden pattern used to match FreeBSD versions.

	* cref/toplev.scm[1.18]:
	Fix missed reference in last change.

2002-03-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* cref/redpkg.scm[1.26], cref/toplev.scm[1.17]:
	Allow end user to specify operating-system type, in order to do cross
	compilation.

	* runtime/packag.scm[14.40]:
	Change PACKAGE-SET-PATHNAME to accept an optional argument that
	specifies the operating-system type.  This is useful for
	cross-compilation.

2002-03-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/version.scm[14.207]:
	Update version number for release.

2002-03-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/cmpauxmd/i386.m4[1.57]:
	Use pushad/popad rather than pusha/popa.  Latter don't work properly
	on Windows, and former aren't implemented by GCC.

2002-03-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/buffer.scm[1.187]:
	Change the following to allow their BUFFER argument to be any object
	accepted by ->BUFFER:
	
		DEFINE-VARIABLE-LOCAL-VALUE!
		UNDEFINE-VARIABLE-LOCAL-VALUE!
		VARIABLE-LOCAL-VALUE?
		SET-VARIABLE-LOCAL-VALUE!

	* edwin/dos.scm[1.53], edwin/edwin.pkg[1.281], edwin/kilcom.scm[1.72],
	  edwin/os2.scm[1.51], edwin/xterm.scm[1.69]:
	Rewrite mechanism that controls whether PRIMARY or CLIPBOARD selection
	is used on X.  Now cut and paste are separately configurable, and the
	defaults are different for each.  This should provide better behavior
	on older systems while making the default more usable on newer ones.

2002-03-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/syntax-output.scm[14.5]:
	Don't output bare block declarations at top level; always wrap them in
	an open block.  Otherwise, SF won't act on the declarations, just
	passing them through to the compiler.

	* etc/compile.scm[1.4]:
	The "star-parser" directory must be compiled prior to the "imail"
	directory.

2002-03-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/syntactic-closures.scm[14.9],
	  runtime/syntax-output.scm[14.4]:
	Fix up various problems in the name management.  This now appears to
	work properly.

	* runtime/runtime.pkg[14.412], runtime/scomb.scm[14.20]:
	Add procedures to get a list of subexpressions of an scode combinator.

	* runtime/syntactic-closures.scm[14.8],
	  runtime/syntax-output.scm[14.3]:
	Rewrite renaming code to allocate temporary uninterned symbols during
	expansion, then map them to interned symbols in a post pass.  Mapping
	algorithm avoids renaming where possible, keeping original names of
	identifiers in outermost frames in cases of conflict.

	* runtime/make.scm[14.86], runtime/option.scm[14.41],
	  runtime/optiondb.scm[1.14], runtime/runtime.pkg[14.411]:
	Hash-table abstraction is now always loaded.  It's no longer necessary
	to use LOAD-OPTION prior to use.

	* runtime/mit-syntax.scm[14.5], runtime/syntax-output.scm[14.2]:
	Rewrite the declaration processor to make it reusable for alpha
	substitution.

2002-02-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/fileio.scm[1.157]:
	Fix another problem with NAME->VARIABLE being passed a string.

2002-02-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.282]:
	Show MIME message/delivery-status parts inline.  Simplify the MIME
	inline/outline decision logic.

	* imail/imail-top.scm[1.281]:
	Add alternate Unicode charsets from RFC-1641.

	* compiler/machines/alpha/instr1.scm[1.6],
	  compiler/machines/alpha/instr2.scm[1.4],
	  compiler/machines/alpha/instr3.scm[1.4],
	  compiler/machines/alpha/lapgen.scm[1.9],
	  compiler/machines/alpha/rules3.scm[1.10],
	  compiler/machines/alpha/rulflo.scm[1.6],
	  compiler/machines/bobcat/assmd.scm[1.39],
	  compiler/machines/bobcat/dassm1.scm[4.22],
	  compiler/machines/bobcat/dassm2.scm[4.25],
	  compiler/machines/bobcat/flinstr1.scm[1.4],
	  compiler/machines/bobcat/flinstr2.scm[1.4],
	  compiler/machines/bobcat/instr2.scm[1.21],
	  compiler/machines/bobcat/instr3.scm[1.20],
	  compiler/machines/bobcat/instr4.scm[1.6],
	  compiler/machines/bobcat/lapgen.scm[4.53],
	  compiler/machines/bobcat/machin.scm[4.34],
	  compiler/machines/bobcat/rules3.scm[4.43],
	  compiler/machines/mips/assmd.scm[1.5],
	  compiler/machines/mips/dassm1.scm[1.7],
	  compiler/machines/mips/dassm2.scm[1.7],
	  compiler/machines/mips/instr1.scm[1.9],
	  compiler/machines/mips/instr2a.scm[1.7],
	  compiler/machines/mips/instr2b.scm[1.6],
	  compiler/machines/mips/instr3.scm[1.5],
	  compiler/machines/mips/lapgen.scm[1.18],
	  compiler/machines/mips/mips.scm[1.4],
	  compiler/machines/mips/rules3.scm[1.20],
	  compiler/machines/mips/rulflo.scm[1.10],
	  compiler/machines/sparc/assmd.scm[1.4],
	  compiler/machines/sparc/instr1.scm[1.4],
	  compiler/machines/sparc/instr2a.scm[1.4],
	  compiler/machines/sparc/instr2b.scm[1.4],
	  compiler/machines/sparc/instr3.scm[1.4],
	  compiler/machines/sparc/lapgen.scm[1.5],
	  compiler/machines/sparc/rules3.scm[1.4],
	  compiler/machines/sparc/rulflo.scm[1.4],
	  compiler/machines/spectrum/assmd.scm[1.33],
	  compiler/machines/spectrum/dassm1.scm[4.22],
	  compiler/machines/spectrum/dassm2.scm[4.23],
	  compiler/machines/spectrum/instr1.scm[1.6],
	  compiler/machines/spectrum/instr3.scm[1.5],
	  compiler/machines/spectrum/lapgen.scm[4.50],
	  compiler/machines/spectrum/rules3.scm[4.44],
	  compiler/machines/spectrum/rulfix.scm[4.50],
	  compiler/machines/spectrum/rulflo.scm[4.42],
	  compiler/machines/vax/assmd.scm[4.9],
	  compiler/machines/vax/dassm1.scm[4.9],
	  compiler/machines/vax/dassm2.scm[4.15],
	  compiler/machines/vax/lapgen.scm[4.18],
	  compiler/machines/vax/rules3.scm[4.14],
	  compiler/machines/vax/rulfix.scm[1.8]:
	Eliminate non-hygienic macros.

	* runtime/syntactic-closures.scm[14.7]:
	If a synthetic identifier is bound at top level, rename it to a
	special name so that it doesn't conflict with other non-EQ?
	identifiers.

	* runtime/parser-buffer.scm[1.4], runtime/rgxcmp.scm[1.121],
	  sf/object.scm[4.15]:
	Don't close the identifier of a definition.

2002-02-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/info.scm[1.137]:
	Fix FIND-DIR-NODE-FILES, which was returning the pathname list in
	reverse order.

	* edwin/hlpcom.scm[1.123]:
	Update copyright statement.

2002-02-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/syntactic-closures.scm[14.6],
	  runtime/syntactic-closures.scm[14.5]:
	In STRIP-SYNTACTIC-CLOSURES, don't copy the argument unless it has
	embedded syntactic closures.

	* runtime/mit-syntax.scm[14.4]:
	Fix typo in previous change.

	* runtime/mit-syntax.scm[14.3]:
	Fix some missing syntax: FLUID-LET must allow (access ...) as LHS in
	binding.  Named LET must allow unassigned bindings.  RHS of syntax
	binding must allow arbitrary procedure-valued expression, which is
	treated as a non-hygienic macro expander.

	* imail/imail-top.scm[1.280]:
	Add "unknown-8bit" to list of known character sets.

2002-02-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/machines/C/lapgen.scm[1.14],
	  compiler/machines/C/rules3.scm[1.11],
	  compiler/machines/C/rulfix.scm[1.5],
	  compiler/machines/C/rulflo.scm[1.7],
	  compiler/machines/alpha/assmd.scm[1.4],
	  compiler/machines/alpha/dassm1.scm[1.4],
	  compiler/machines/alpha/dassm2.scm[1.4],
	  compiler/machines/spectrum/instr2.scm[1.11],
	  compiler/machines/vax/dsyn.scm[1.12],
	  compiler/machines/vax/insmac.scm[1.17],
	  compiler/machines/vax/instr1.scm[1.10],
	  compiler/machines/vax/instr2.scm[1.11],
	  compiler/machines/vax/instr2.scm[1.10],
	  compiler/machines/vax/instr3.scm[1.14]:
	Eliminate non-hygienic macros.

2002-02-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/back/asmmac.scm[1.17], compiler/back/syntax.scm[1.29],
	  compiler/machines/alpha/insmac.scm[1.6],
	  compiler/machines/bobcat/insmac.scm[1.132],
	  compiler/machines/i386/insmac.scm[1.17],
	  compiler/machines/mips/insmac.scm[1.6],
	  compiler/machines/sparc/insmac.scm[1.5],
	  compiler/machines/spectrum/insmac.scm[1.6],
	  compiler/machines/vax/insmac.scm[1.16]:
	Change most instruction-set macros to use reverse syntactic closure
	style, and propagate changes down through the maze of supporting
	procedures.

	* edwin/hlpcom.scm[1.122]:
	Fix bug: name->foo procedures no longer accept string arguments.

	* compiler/back/asmmac.scm[1.16], compiler/back/asmmac.scm[1.15],
	  compiler/base/macros.scm[4.28], compiler/base/pmpars.scm[1.7],
	  compiler/machines/bobcat/insmac.scm[1.131],
	  compiler/machines/i386/insmac.scm[1.16]:
	Make sure that all expressions are properly closed.

2002-02-13  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/machines/i386/insmac.scm[1.15]:
	Make sure that all expressions are properly closed.

	* compiler/machines/alpha/insmac.scm[1.5],
	  compiler/machines/bobcat/insmac.scm[1.130]:
	Eliminate non-hygienic macros.

	* edwin/clsmac.scm[1.10]:
	Fix bug: WITH-INSTANCE-VARIABLES should have used
	MAKE-UNMAPPED-MACRO-REFERENCE-TRAP rather than
	MAKE-MACRO-REFERENCE-TRAP.

	* runtime/mit-syntax.scm[14.2]:
	Modify CASE syntactic keyword to generate better code for tests.

	* compiler/etc/disload.scm[1.12], edwin/intmod.scm[1.116],
	  imail/fake-env.scm[1.6], runtime/option.scm[14.40],
	  runtime/runtime.pkg[14.410], runtime/uenvir.scm[14.56],
	  runtime/xeval.scm[1.10], swat/scheme/load.scm[1.9]:
	Rename MAKE-NULL-TOP-LEVEL-ENVIRONMENT to MAKE-ROOT-TOP-LEVEL-ENVIRONMENT.
	Eliminate alias for EXTEND-INTERPRETER-ENVIRONMENT.

2002-02-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/syntactic-closures.scm[14.4], runtime/uenvir.scm[14.55]:
	Don't signal error from ENVIRONMENT-LOOKUP-MACRO if name is unbound.

	* runtime/runtime.pkg[14.409], runtime/uenvir.scm[14.54]:
	Add aliases:
	
	interpreter-environment?          => top-level-environment?
	extend-interpreter-environment    => extend-top-level-environment
	make-null-interpreter-environment => make-null-top-level-environment

	* win32/ffimacro.scm[1.8]:
	Don't close the identifier of a definition.

	* runtime/make.scm[14.85], runtime/runtime.pkg[14.408],
	  runtime/syntactic-closures.scm[14.3]:
	Implement REVERSE-SYNTACTIC-ENVIRONMENTS.  Add bindings for
	SYSTEM-GLOBAL-SYNTAX-TABLE and EXTEND-IC-ENVIRONMENT to ease upgrading.

	* compiler/back/asmmac.scm[1.14], compiler/base/macros.scm[4.27],
	  compiler/base/pmpars.scm[1.6], compiler/base/pmpars.scm[1.5],
	  compiler/machines/i386/assmd.scm[1.6],
	  compiler/machines/i386/dassm1.scm[1.13],
	  compiler/machines/i386/dassm2.scm[1.12],
	  compiler/machines/i386/dassm3.scm[1.10],
	  compiler/machines/i386/insmac.scm[1.14],
	  compiler/machines/i386/instr1.scm[1.16],
	  compiler/machines/i386/instr2.scm[1.10],
	  compiler/machines/i386/instrf.scm[1.18],
	  compiler/machines/i386/lapgen.scm[1.31],
	  compiler/machines/i386/rules3.scm[1.38],
	  compiler/machines/i386/rulfix.scm[1.34],
	  compiler/machines/i386/rulflo.scm[1.25]:
	Eliminate non-hygienic macros.

2002-02-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/defstr.scm[14.40], runtime/sysmac.scm[14.10]:
	Don't close the identifier of a definition.

2002-02-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/arith.scm[1.10], edwin/buffer.scm[1.186],
	  edwin/calias.scm[1.25], edwin/dosproc.scm[1.9],
	  edwin/macros.scm[1.72], edwin/search.scm[1.155],
	  edwin/tterm.scm[1.34], edwin/xcom.scm[1.21], runtime/arith.scm[1.50],
	  runtime/graphics.scm[1.21], runtime/infstr.scm[1.15],
	  runtime/parse.scm[14.37], runtime/port.scm[1.23],
	  runtime/rgxcmp.scm[1.120], runtime/starbase.scm[1.17],
	  runtime/sysmac.scm[14.9], runtime/vector.scm[14.21],
	  sf/object.scm[4.14]:
	Don't close the identifier of a definition.

	* compiler/base/macros.scm[4.26], edwin/clsmac.scm[1.9],
	  runtime/defstr.scm[14.39], sf/toplev.scm[4.24], sos/macros.scm[1.14]:
	Use CLOSE-SYNTAX where possible.

2002-02-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/syntactic-closures.scm[14.2]:
	Change renaming algorithm to treat synthetic identifiers differently
	from symbols.  The new algorithm implements an EQ?-isomorphic map
	between identifiers and renamed symbols.

	* compiler/base/cfg1.scm[4.7]:
	Eliminate instances of FALSE.

	* compiler/machines/C/compiler.pkg[1.14],
	  compiler/machines/alpha/compiler.pkg[1.17],
	  compiler/machines/bobcat/compiler.pkg[1.54],
	  compiler/machines/mips/compiler.pkg[1.24],
	  compiler/machines/spectrum/compiler.pkg[1.54],
	  compiler/machines/vax/compiler.pkg[1.26]:
	Add missing macro imports.

	* compiler/back/asmmac.scm[1.13], compiler/back/asmmac.scm[1.12],
	  compiler/base/cfg1.scm[4.6], compiler/base/macros.scm[4.25],
	  compiler/base/macros.scm[4.24], compiler/base/scode.scm[4.14],
	  compiler/base/utils.scm[4.24], compiler/etc/comcmp.scm[1.11],
	  compiler/fggen/canon.scm[1.22], compiler/fggen/canon.scm[1.21],
	  compiler/fggen/fggen.scm[4.37], compiler/fggen/fggen.scm[4.36],
	  compiler/machines/C/compiler.pkg[1.13],
	  compiler/machines/alpha/compiler.pkg[1.16],
	  compiler/machines/bobcat/compiler.pkg[1.53],
	  compiler/machines/i386/compiler.pkg[1.29],
	  compiler/machines/mips/compiler.pkg[1.23],
	  compiler/machines/spectrum/compiler.pkg[1.53],
	  compiler/machines/vax/compiler.pkg[1.25],
	  compiler/rtlbase/rtlcfg.scm[4.10], compiler/rtlbase/rtlreg.scm[4.9],
	  compiler/rtlbase/valclass.scm[1.5]:
	Eliminate non-hygienic macros.

	* runtime/syntax-check.scm[14.2]:
	Fix error message in PARSE-MIT-LAMBDA-LIST.

2002-02-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/back/asmmac.scm[1.11], compiler/back/lapgn3.scm[4.15],
	  compiler/base/crsend.scm[1.13], compiler/base/lvalue.scm[4.25]:
	Eliminate non-hygienic macros.

2002-02-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/utabmd.scm[9.84]:
	Fix bug: top-level syntax definition was being loaded into global
	environment.

2002-02-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* win32/ffimacro.scm[1.7]:
	Fix fatal bug in previous revision.

2002-02-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/make.scm[15.34], compiler/base/make.scm[4.117],
	  cref/make.scm[1.25], edwin/make.scm[3.114], imail/load.scm[1.38],
	  sos/load.scm[1.11], win32/make.scm[1.10], xml/load.scm[1.5]:
	Update version to reflect changes for new syntax engine.

	* 6001/arith.scm[1.9], compiler/base/constr.scm[1.4],
	  compiler/base/macros.scm[4.23],
	  compiler/machines/i386/compiler.pkg[1.28], edwin/buffer.scm[1.185],
	  edwin/buffrm.scm[1.59], edwin/bufwin.scm[1.310],
	  edwin/calias.scm[1.24], edwin/clscon.scm[1.8], edwin/clsmac.scm[1.8],
	  edwin/comman.scm[1.86], edwin/comwin.scm[1.147],
	  edwin/dosproc.scm[1.8], edwin/edtfrm.scm[1.91],
	  edwin/edwin.pkg[1.280], edwin/macros.scm[1.71],
	  edwin/modes.scm[1.35], edwin/modwin.scm[1.42],
	  edwin/regexp.scm[1.78], edwin/schmod.scm[1.59],
	  edwin/search.scm[1.154], edwin/syntax.scm[1.89],
	  edwin/tterm.scm[1.33], edwin/utils.scm[1.51], edwin/utlwin.scm[1.60],
	  edwin/window.scm[1.160], edwin/xcom.scm[1.20], edwin/xform.scm[1.12],
	  microcode/cmpintmd/i386.h[1.35], microcode/os2pm.scm[1.11],
	  microcode/utabmd.scm[9.83], runtime/Attic/illdef.scm[1.6],
	  runtime/Attic/macros.scm[1.7], runtime/Attic/syntab.scm[14.10],
	  runtime/Attic/syntax.scm[14.53], runtime/apply.scm[1.5],
	  runtime/arith.scm[1.49], runtime/debug.scm[14.43],
	  runtime/defstr.scm[14.38], runtime/ed-ffi.scm[1.32],
	  runtime/error.scm[14.57], runtime/graphics.scm[1.20],
	  runtime/infstr.scm[1.14], runtime/list.scm[14.30],
	  runtime/make.scm[14.84], runtime/mit-syntax.scm[14.1],
	  runtime/os2winp.scm[1.18], runtime/parse.scm[14.36],
	  runtime/parser-buffer.scm[1.3], runtime/port.scm[1.22],
	  runtime/recslot.scm[1.7], runtime/rgxcmp.scm[1.119],
	  runtime/runtime.pkg[14.407], runtime/scomb.scm[14.19],
	  runtime/starbase.scm[1.16], runtime/string.scm[14.47],
	  runtime/syntactic-closures.scm[14.1], runtime/syntax-check.scm[14.1],
	  runtime/syntax-output.scm[14.1], runtime/syntax-rules.scm[14.1],
	  runtime/syntax-transforms.scm[14.1], runtime/sysmac.scm[14.8],
	  runtime/unsyn.scm[14.28], runtime/vector.scm[14.20],
	  runtime/version.scm[14.206], sf/make.scm[4.41], sf/object.scm[4.13],
	  sf/sf.pkg[4.17], sf/toplev.scm[4.23], sos/class.scm[1.12],
	  sos/instance.scm[1.14], sos/macros.scm[1.13],
	  star-parser/Attic/synchk.scm[1.2], star-parser/compile.scm[1.5],
	  star-parser/load.scm[1.12], star-parser/matcher.scm[1.29],
	  star-parser/parser.pkg[1.18], star-parser/parser.scm[1.32],
	  star-parser/shared.scm[1.23],
	  swat/scheme/control-floating-errors.scm[1.4],
	  swat/scheme/load.scm[1.8], swat/scheme/mit-xhooks.scm[1.5],
	  swat/scheme/scc-macros.scm[1.4], wabbit/test-wabbit.scm[1.4],
	  win32/ffimacro.scm[1.6], win32/win32.sf[1.9], win32/win_ffi.scm[1.9]:
	Merge hygienic-macros branch into trunk.

2002-02-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/macros.scm[1.70.2.1],
	  swat/scheme/control-floating-errors.scm[1.3.2.1],
	  swat/scheme/load.scm[1.7.2.1], swat/scheme/mit-xhooks.scm[1.4.2.1],
	  swat/scheme/scc-macros.scm[1.3.2.1], wabbit/test-wabbit.scm[1.3.2.1]:
	Eliminate non-hygienic macros.

	* edwin/comman.scm[1.85.6.3], edwin/comman.scm[1.85.6.2]:
	Extend MAKE-VARIABLE to accept arguments that initialize the remaining
	record fields.

	* edwin/comman.scm[1.85.6.1], edwin/edwin.pkg[1.279.2.2],
	  edwin/modes.scm[1.34.6.1]:
	Eliminate CANONICALIZE-NAME.

2002-02-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* sf/sf.pkg[4.16.2.2], sf/toplev.scm[4.22.2.2],
	  win32/win32.sf[1.8.2.1]:
	Rip out remaining pathname-map stuff.  It's nearly impossible to make
	this work right.

	* 6001/arith.scm[1.8.2.1], edwin/buffer.scm[1.184.2.1],
	  edwin/calias.scm[1.23.2.1], edwin/dosproc.scm[1.7.2.1],
	  edwin/regexp.scm[1.77.2.1], edwin/search.scm[1.153.2.1],
	  edwin/syntax.scm[1.88.2.1], edwin/tterm.scm[1.32.2.1],
	  edwin/utils.scm[1.50.2.1], edwin/xcom.scm[1.19.2.1],
	  microcode/os2pm.scm[1.10.2.1], microcode/utabmd.scm[9.82.2.1],
	  runtime/apply.scm[1.4.2.1], runtime/arith.scm[1.48.2.1],
	  runtime/debug.scm[14.42.2.1], runtime/error.scm[14.56.2.1],
	  runtime/graphics.scm[1.19.2.1], runtime/infstr.scm[1.13.2.1],
	  runtime/list.scm[14.29.2.1], runtime/make.scm[14.83.2.5],
	  runtime/os2winp.scm[1.17.2.1], runtime/parse.scm[14.35.2.1],
	  runtime/parser-buffer.scm[1.2.2.1], runtime/port.scm[1.21.2.1],
	  runtime/recslot.scm[1.6.2.1], runtime/rgxcmp.scm[1.118.2.1],
	  runtime/scomb.scm[14.18.2.1], runtime/starbase.scm[1.15.2.1],
	  runtime/string.scm[14.46.2.1], runtime/sysmac.scm[14.7.2.1],
	  runtime/vector.scm[14.19.2.1], sf/object.scm[4.12.2.1],
	  win32/ffimacro.scm[1.5.2.1], win32/win_ffi.scm[1.8.2.1]:
	Eliminate non-hygienic macros.

2002-01-31  Chris Hanson <cph@zurich.ai.mit.edu>

	* sos/macros.scm[1.12.2.2]:
	Fix thinko with reversed arguments to IDENTIFIER=?.

	* star-parser/Attic/synchk.scm[1.1.6.1],
	  star-parser/compile.scm[1.4.6.1], star-parser/load.scm[1.11.6.1],
	  star-parser/matcher.scm[1.28.2.1], star-parser/parser.pkg[1.17.2.1],
	  star-parser/parser.scm[1.31.2.1], star-parser/shared.scm[1.22.2.1]:
	Update for new syntax engine.

	* runtime/syntax-output.scm[1.1.2.8],
	  runtime/syntax-output.scm[1.1.2.7]:
	Add back optimization that renames LAMBDA expressions bound by
	top-level definitions.

2002-01-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/makegen/Makefile.in.in[1.17.2.3],
	  microcode/makegen/Makefile.in.in[1.20],
	  microcode/makegen/Makefile.in.in[1.17.2.2],
	  microcode/makegen/Makefile.in.in[1.19], microcode/utabmd.sh[1.1.2.2],
	  microcode/utabmd.sh[1.2], microcode/utabmd.sh[1.1.2.1],
	  microcode/utabmd.sh[1.1]:
	Use SCHEME_COMPILER variable to allow end-user override.

	* microcode/configure.in[11.13.2.2], microcode/configure.in[11.15]:
	In socklen_t test, must include <sys/types.h> also.

	* microcode/tterm.c[1.12.2.1], microcode/tterm.c[1.13]:
	Undefine false and true prior to including <curses.h>, to work around
	bug in recent versions of ncurses.

	* microcode/confshared.h[11.1.2.2], microcode/confshared.h[11.3]:
	Don't use <stdbool.h>; it is incompatible with older versions of
	ncurses.

	* microcode/configure.in[11.13.2.1], microcode/configure.in[11.14],
	  microcode/confshared.h[11.1.2.1], microcode/confshared.h[11.2]:
	Fix problem: don't define true and false if <stdbool.h> exists,
	because the GNU version of <stdbool.h> breaks in that case.  Instead
	just use <stdbool.h> to make the definitions.

	* edwin/xterm.scm[1.68]:
	Add support for cut/paste to "clipboard", which seems to be new standard.

	* Makefile.in[1.19], Makefile.in[1.18.2.1], etc/compile.sh[1.2],
	  etc/compile.sh[1.1.2.1]:
	Add shell script with environment variable that can be used to
	override the default Scheme compiler.

	* etc/compile.sh[1.1]:
	file compile.sh was initially added on branch release-7-6.

2002-01-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/version.scm[14.205]:
	Update release version to reflect that next release will be 7.7.0
	rather than 7.6.1.

2002-01-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* win32/dibutils/makefile.msc[1.3.2.1],
	  win32/dibutils/makefile.msc[1.4],
	  win32/dibutils/makefile.wcc[1.3.2.1],
	  win32/dibutils/makefile.wcc[1.4]:
	Fix typo.

	* etc/optiondb.scm[1.8.2.1]:
	Fix bug: package name for SOS was wrong.

	* runtime/version.scm[14.202.2.1]:
	Update version number for release.

2002-01-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/defstr.scm[14.37.2.5], runtime/runtime.pkg[14.406.2.9],
	  runtime/syntactic-closures.scm[1.1.2.13]:
	Rename GENERATE-SYNTHETIC-IDENTIFIER to MAKE-SYNTHETIC-IDENTIFIER.

	* runtime/syntactic-closures.scm[1.1.2.12]:
	Don't elide syntactic closure when the form being closed is an
	identifier, because the closure might be a synthetic identifier.

2002-01-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* etc/optiondb.scm[1.8.6.1], etc/optiondb.scm[1.9]:
	Fix bug: package name for SOS was wrong.

	* sos/class.scm[1.11.2.1], sos/instance.scm[1.13.2.1],
	  sos/macros.scm[1.12.2.1]:
	Initial rewrite of macros to use syntactic closures.  Code compiles
	and a few simple expressions have been tested.

	* runtime/runtime.pkg[14.406.2.8]:
	Export PARSE-MIT-LAMBDA-LIST.

	* runtime/syntactic-closures.scm[1.1.2.11]:
	Change MAKE-SYNTACTIC-CLOSURE to avoid closing more things.  This will
	reduce consing and simplify debugging of macros.

	* runtime/runtime.pkg[14.406.2.7],
	  runtime/syntactic-closures.scm[1.1.2.10]:
	Delete unused definition of MAKE-SYNTACTIC-CLOSURE-LIST.  Add new
	procedure CLOSE-SYNTAX.  Change STRIP-SYNTACTIC-CLOSURES; it doesn't
	need to traverse vectors.

	* runtime/syntax-check.scm[1.1.2.2]:
	Allow arbitrary pattern-matching elements in SYNTAX-MATCH?.

2002-01-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/ed-ffi.scm[1.31.2.1]:
	Change list to delete old files and add new ones.

	* runtime/syntax-output.scm[1.1.2.6]:
	Enhance OUTPUT/TOP-LEVEL-SEQUENCE to avoid making open blocks for
	simple expressions.

	* runtime/syntactic-closures.scm[1.1.2.9]:
	Simplify structure of top-level entry points to syntax engine.

	* edwin/bufwin.scm[1.309.6.2]:
	Fix bug: BUFFER-WINDOW/SET-BUFFER! must not call SET-NEW-COORDINATES!
	unless the window has a known size.

	* edwin/clscon.scm[1.7.6.2], edwin/clscon.scm[1.7.6.1]:
	Mak sure that structure-type names are in the numerical order.

2002-01-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/buffrm.scm[1.58.6.1], edwin/bufwin.scm[1.309.6.1],
	  edwin/clsmac.scm[1.7.2.2], edwin/comwin.scm[1.146.6.1],
	  edwin/edtfrm.scm[1.90.6.1], edwin/edwin.pkg[1.279.2.1],
	  edwin/modwin.scm[1.41.6.1], edwin/utlwin.scm[1.59.6.1],
	  edwin/window.scm[1.159.6.1], edwin/xform.scm[1.11.2.1]:
	Implement WITH-INSTANCE-VARIABLES as a compiler item, using internal
	features of the syntax engine.  Rename => to ==> to avoid conflict
	with => keyword used by COND; rename USUAL=> to USUAL==> for
	consistency.

	* runtime/defstr.scm[14.37.2.4]:
	Fix thinko in NAMED option.

	* runtime/runtime.pkg[14.406.2.6]:
	Export ILL-FORMED-SYNTAX.

	* runtime/syntax-rules.scm[1.1.2.2]:
	Add declarations to prevent compiler warnings.

	* edwin/clsmac.scm[1.7.2.1]:
	Mostly rewrite this using new syntax.  But WITH-INSTANCE-VARIABLES not
	rewritten -- it is a terrible kludge and pretty hopeless.

	* edwin/schmod.scm[1.58.2.1]:
	Add indentation rules for new syntax.

	* runtime/runtime.pkg[14.406.2.5],
	  runtime/syntactic-closures.scm[1.1.2.8],
	  runtime/syntax-output.scm[1.1.2.5]:
	Export CALL-WITH-SYNTAX-ERROR-PROCEDURE, and generalize the argument
	structure to the error procedure.

	* runtime/runtime.pkg[14.406.2.4]:
	Export SYNTAX-MATCH? for use in macros.

	* runtime/make.scm[14.83.2.4], runtime/mit-syntax.scm[1.1.2.11],
	  runtime/syntactic-closures.scm[1.1.2.7],
	  runtime/syntax-transforms.scm[1.1.2.2]:
	Fix runtime code generated for top-level macro transformers.  These
	were being stored in the environment as procedures when they were
	supposed to be stored as expander items.

	* compiler/base/macros.scm[4.22.2.3]:
	Fix typo in DEFINE-EXPORT.

	* runtime/mit-syntax.scm[1.1.2.10]:
	Fix thinko in binding of syntactic keywords.

	* runtime/unsyn.scm[14.27.2.1]:
	Fix broken unsyntaxing of DEFINE-SYNTAX.

	* compiler/base/macros.scm[4.22.2.2]:
	Convert the PACKAGE macro to RSC format.

	* compiler/base/constr.scm[1.3.6.1]:
	Add USUAL-INTEGRATIONS declaration.

	* runtime/mit-syntax.scm[1.1.2.9]:
	Allow INTEGRATE-EXTERNAL declaration to take pathname objects as well
	as strings.

2002-01-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/defstr.scm[14.37.2.3]:
	Make sure that the ACCESS keyword is closed in the right environment.

	* runtime/syntax-transforms.scm[1.1]:
	file syntax-transforms.scm was initially added on branch hygienic-macros.

	* runtime/make.scm[14.83.2.3], runtime/mit-syntax.scm[1.1.2.8],
	  runtime/runtime.pkg[14.406.2.3],
	  runtime/syntax-transforms.scm[1.1.2.1]:
	Move the TRANSFORMER->EXPANDER procedures into a separate file that is
	loaded early during the cold load.  These are needed by any top-level
	macro definitions in the runtime system.

	* runtime/make.scm[14.83.2.2]:
	Eliminate use of CASE in cold load.  New syntaxer expands this into
	calls to MEMV, which isn't available.

	* runtime/mit-syntax.scm[1.1.2.7],
	  runtime/syntactic-closures.scm[1.1.2.6],
	  runtime/syntax-output.scm[1.1.2.4],
	  runtime/syntax-output.scm[1.1.2.3]:
	Rework the handling of definitions, LAMBDA bodies, and LETREC.  This
	now emits code using open blocks and internal definitions, because the
	compiler (and SF) expect it to be in that form.

	* runtime/mit-syntax.scm[1.1.2.6],
	  runtime/syntactic-closures.scm[1.1.2.5]:
	Fix harmless typo.

	* runtime/syntax-output.scm[1.1.2.2]:
	Fix thinko in generation of LETREC code.

	* runtime/mit-syntax.scm[1.1.2.5],
	  runtime/syntactic-closures.scm[1.1.2.4]:
	Rework the handling of LET-SYNTAX and LETREC-SYNTAX so that
	definitions appearing in their bodies are defined in the enclosing
	definition environment rather than internally.

	* runtime/mit-syntax.scm[1.1.2.4]:
	Allow INTEGRATE-EXTERNAL declaration to specify multiple files.

	* runtime/mit-syntax.scm[1.1.2.3],
	  runtime/syntactic-closures.scm[1.1.2.3]:
	Add delay to processing of declaration texts, so that they can contain
	forward references to definitions.

2002-01-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/macros.scm[4.22.2.1],
	  compiler/machines/i386/compiler.pkg[1.27.2.1]:
	Eliminate dependence of DEFINE-EXPORT on now-obsolete
	PARSE-DEFINE-SYNTAX.

	* runtime/mit-syntax.scm[1.1.2.2], runtime/runtime.pkg[14.406.2.2],
	  runtime/syntactic-closures.scm[1.1.2.2]:
	Rework handling of bodies to prevent premature reference to internal
	definitions.  Add bootstrapping kludge that converts old-style macro
	transformers into items on the fly.  Implement "reversed"
	syntactic-closure transformers.

	* runtime/defstr.scm[14.37.2.2]:
	Fix bugs: Slot default wasn't being closed right; type-name and
	tag-expression were being reversed.

2002-01-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/cmpintmd/i386.h[1.34.2.1]:
	Eliminate unneeded declaration of `ia32_cpuid_needed'.

	* sf/make.scm[4.40.2.1], sf/sf.pkg[4.16.2.1], sf/toplev.scm[4.22.2.1]:
	Changes needed to support new syntax engine.

	* runtime/syntactic-closures.scm[1.1]:
	file syntactic-closures.scm was initially added on branch hygienic-macros.

	* runtime/syntax-check.scm[1.1]:
	file syntax-check.scm was initially added on branch hygienic-macros.

	* runtime/syntax-output.scm[1.1]:
	file syntax-output.scm was initially added on branch hygienic-macros.

	* runtime/syntax-rules.scm[1.1]:
	file syntax-rules.scm was initially added on branch hygienic-macros.

	* runtime/Attic/illdef.scm[1.5.2.1], runtime/Attic/macros.scm[1.6.2.1],
	  runtime/Attic/syntab.scm[14.9.2.1],
	  runtime/Attic/syntax.scm[14.52.2.1], runtime/defstr.scm[14.37.2.1],
	  runtime/make.scm[14.83.2.1], runtime/mit-syntax.scm[1.1.2.1],
	  runtime/runtime.pkg[14.406.2.1],
	  runtime/syntactic-closures.scm[1.1.2.1],
	  runtime/syntax-check.scm[1.1.2.1],
	  runtime/syntax-output.scm[1.1.2.1],
	  runtime/syntax-rules.scm[1.1.2.1], runtime/version.scm[14.204.2.1]:
	Initial integration of new syntax engine.  Complete rewrite of
	DEFINE-STRUCTURE expander.

	* runtime/mit-syntax.scm[1.1]:
	file mit-syntax.scm was initially added on branch hygienic-macros.

2002-01-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/makegen/Makefile.in.in[1.17.2.1]:
	Fix default target; it wasn't including everything.

	* microcode/cmpauxmd/i386.m4[1.50.6.1]:
	Add explicit cache synchronization support to work around a bug in the
	Athlon.  Remove support for DOS and HACK_SEGMENT_REGS.

	* compiler/base/make.scm[4.115.2.1],
	  compiler/machines/i386/dassm3.scm[1.6.2.1],
	  compiler/machines/i386/instr1.scm[1.11.2.1],
	  compiler/machines/i386/lapgen.scm[1.27.2.1],
	  compiler/machines/i386/rules3.scm[1.34.2.1],
	  microcode/cmpintmd/i386.h[1.32.2.1], microcode/version.h[11.181.2.1]:
	Add explicit cache synchronization support to work around a bug in the
	Athlon.

2002-01-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.136]:
	Add note about Hal's suggestion to overload o to subsume M-o.

	* runtime/defstr.scm[14.37], runtime/make.scm[14.83],
	  runtime/record.scm[1.29], runtime/runtime.pkg[14.406]:
	Move runtime support for DEFINE-STRUCTURE into "record.scm", in order
	to simplify the boot sequence.  This allows "defstr.scm" to move late
	into the boot sequence and to use the record abstraction without
	complicated tricks.

2002-01-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* sf/sf.pkg[4.16], sf/toplev.scm[4.22]:
	Change remaining "syntax-table" references to "environment".  Delete
	unused procedure SF/SET-FILE-SYNTAX-TABLE!.

2002-01-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/urtrap.scm[14.13]:
	Fix naming issue right (?).

	* runtime/urtrap.scm[14.12]:
	If reference trap has no name, print its number.

2002-01-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/uenvir.scm[14.53]:
	Must do reference-trap mapping when looking things up in compiled-code
	environments.

	* edwin/debug.scm[1.62]:
	Don't ever list bindings for packages.

	* edwin/debug.scm[1.61]:
	Fix problem: only one of the places that prints bindings knew about
	syntactic keywords.

	* runtime/urtrap.scm[14.11]:
	Change representation of reference trap to show kind name rather than
	number.

	* edwin/debug.scm[1.60]:
	Use new environment-abstraction design to clean up debugger access to
	environments.

	* runtime/error.scm[14.56], runtime/runtime.pkg[14.405],
	  runtime/uenvir.scm[14.52]:
	Redesign way that macros are integrated into environments.  Syntactic
	keywords are now considered bound, but ordinary variable-reference
	operations signal errors on those bindings; but each of the definition
	operations can be used to modify either kind of binding.
	
	New procedure ENVIRONMENT-DEFINABLE? can be used to determine if a
	definition is allowed on a particular environment; currently it is
	false on compiled-code environments.
	
	New procedures ENVIRONMENT-REFERENCE-TYPE and ENVIRONMENT-SAFE-LOOKUP
	provide very flexible mechanisms for determining what is contained in
	an environment or binding without generating errors.

2002-01-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/dbgutl.scm[14.21]:
	Handle case where binding is a syntactic keyword.

	* runtime/xeval.scm[1.9], runtime/xeval.scm[1.8]:
	Rename ENVIRONMENT-WHICH-BINDS to ENVIRONMENT-THAT-BINDS.

	* runtime/unpars.scm[14.50]:
	Don't unparse environments specially.

2002-01-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/runtime.pkg[14.404], runtime/uenvir.scm[14.51]:
	New procedure GUARANTEE-ENVIRONMENT.

2001-12-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/Attic/syntax.scm[14.52]:
	Oops... last revision deleted a little too much.

2001-12-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/Attic/syntax.scm[14.51]:
	Eliminate deep-binding FLUID-LET.

	* compiler/etc/comcmp.scm[1.10], runtime/Attic/syntax.scm[14.50],
	  runtime/unsyn.scm[14.27]:
	Eliminate references to UNASSIGNED?.

2001-12-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/lookprm.c[1.19], microcode/lookprm.c[1.18]:
	Fix missing string line terminators.

	* 6001/arith.scm[1.8], compiler/back/asmmac.scm[1.10],
	  compiler/back/lapgn3.scm[4.14], compiler/base/crsend.scm[1.12],
	  compiler/base/lvalue.scm[4.24], compiler/base/macros.scm[4.22],
	  compiler/base/scode.scm[4.13], compiler/base/utils.scm[4.23],
	  compiler/etc/comcmp.scm[1.9], compiler/fggen/canon.scm[1.20],
	  compiler/fggen/fggen.scm[4.35],
	  compiler/machines/alpha/inerly.scm[1.6],
	  compiler/machines/alpha/insmac.scm[1.4],
	  compiler/machines/bobcat/inerly.scm[1.11],
	  compiler/machines/bobcat/insmac.scm[1.129],
	  compiler/machines/i386/assmd.scm[1.5],
	  compiler/machines/i386/dassm1.scm[1.12],
	  compiler/machines/i386/dassm2.scm[1.11],
	  compiler/machines/i386/dassm3.scm[1.9],
	  compiler/machines/i386/inerly.scm[1.7],
	  compiler/machines/i386/insmac.scm[1.13],
	  compiler/machines/i386/instr1.scm[1.15],
	  compiler/machines/i386/instr2.scm[1.9],
	  compiler/machines/i386/instrf.scm[1.17],
	  compiler/machines/i386/lapgen.scm[1.30],
	  compiler/machines/i386/rules3.scm[1.37],
	  compiler/machines/i386/rulfix.scm[1.33],
	  compiler/machines/i386/rulflo.scm[1.24],
	  compiler/machines/mips/inerly.scm[1.6],
	  compiler/machines/mips/insmac.scm[1.5],
	  compiler/machines/sparc/inerly.scm[1.6],
	  compiler/machines/sparc/insmac.scm[1.4],
	  compiler/machines/spectrum/inerly.scm[1.6],
	  compiler/machines/spectrum/insmac.scm[1.5],
	  compiler/machines/spectrum/instr2.scm[1.10],
	  compiler/machines/vax/dsyn.scm[1.11],
	  compiler/machines/vax/inerly.scm[1.10],
	  compiler/machines/vax/insmac.scm[1.15],
	  compiler/machines/vax/instr1.scm[1.9],
	  compiler/machines/vax/instr2.scm[1.9],
	  compiler/machines/vax/instr3.scm[1.13],
	  compiler/rtlbase/rtlreg.scm[4.8], compiler/rtlbase/valclass.scm[1.4],
	  edwin/buffer.scm[1.184], edwin/calias.scm[1.23],
	  edwin/clsmac.scm[1.7], edwin/dosproc.scm[1.7],
	  edwin/macros.scm[1.70], edwin/regexp.scm[1.77],
	  edwin/search.scm[1.153], edwin/syntax.scm[1.88],
	  edwin/tterm.scm[1.32], edwin/utils.scm[1.50], edwin/xcom.scm[1.19],
	  microcode/os2pm.scm[1.10], microcode/utabmd.scm[9.82],
	  runtime/apply.scm[1.4], runtime/arith.scm[1.48],
	  runtime/debug.scm[14.42], runtime/defstr.scm[14.36],
	  runtime/error.scm[14.55], runtime/graphics.scm[1.19],
	  runtime/infstr.scm[1.13], runtime/list.scm[14.29],
	  runtime/make.scm[14.82], runtime/os2winp.scm[1.17],
	  runtime/parse.scm[14.35], runtime/parser-buffer.scm[1.2],
	  runtime/port.scm[1.21], runtime/recslot.scm[1.6],
	  runtime/rgxcmp.scm[1.118], runtime/runtime.pkg[14.403],
	  runtime/scomb.scm[14.18], runtime/starbase.scm[1.15],
	  runtime/string.scm[14.46], runtime/sysmac.scm[14.7],
	  runtime/vector.scm[14.19], sf/object.scm[4.12], sos/class.scm[1.11],
	  sos/instance.scm[1.13], sos/load.scm[1.10], sos/macros.scm[1.12],
	  sos/sos.pkg[1.11], star-parser/matcher.scm[1.28],
	  star-parser/parser.pkg[1.17], star-parser/parser.scm[1.31],
	  swat/scheme/control-floating-errors.scm[1.3],
	  swat/scheme/load.scm[1.7], swat/scheme/mit-xhooks.scm[1.4],
	  swat/scheme/scc-macros.scm[1.3], swat/scheme/uitk-macros.scm[1.2],
	  wabbit/test-wabbit.scm[1.3], win32/dib.scm[1.5],
	  win32/ffimacro.scm[1.5], win32/make.scm[1.9], win32/win32.pkg[1.15],
	  win32/win32.sf[1.8], win32/win_ffi.scm[1.8], win32/wingdi.scm[1.3],
	  win32/winnt.scm[1.3], win32/winuser.scm[1.3], win32/wt_user.scm[1.6]:
	Eliminate all references to SYNTAX-TABLE/DEFINE.  Wrap all macros with
	new procedure NON-HYGIENIC-MACRO-TRANSFORMER; this will serve as a
	marker for identifying macros that need to be rewritten.

2001-12-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/macros.scm[4.21],
	  compiler/machines/i386/compiler.pkg[1.27],
	  compiler/machines/i386/compiler.sf[1.18], edwin/edwin.ldr[1.73],
	  edwin/macros.scm[1.69]:
	Store macro definitions in environments rather than in syntax tables.

	* runtime/Attic/syntax.scm[14.49], runtime/runtime.pkg[14.402],
	  runtime/unsyn.scm[14.26], runtime/urtrap.scm[14.10]:
	Fix problem: DEFINE-SYNTAX was expanding into a fixed reference trap
	in which the SCode lambda was inserted; it must instead expand into an
	expression that evaluates the lambda and wraps it in a reference trap.

2001-12-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* sf/toplev.scm[4.21]:
	Eliminate reference to SYNTAX-TABLE?.

	* compiler/base/toplev.scm[4.62]:
	Eliminate reference to GUARANTEE-SYNTAX-TABLE.

	* sf/toplev.scm[4.20]:
	Eliminate references to MAKE-SYNTAX-TABLE.

	* compiler/machines/vax/dsyn.scm[1.10], edwin/clsmac.scm[1.6],
	  edwin/edwin.pkg[1.279], edwin/macros.scm[1.68],
	  runtime/Attic/macros.scm[1.6], runtime/Attic/syntab.scm[14.9],
	  runtime/Attic/syntax.scm[14.48], runtime/defstr.scm[14.35],
	  runtime/make.scm[14.81], runtime/make.scm[14.80],
	  runtime/runtime.pkg[14.401], runtime/runtime.pkg[14.400],
	  runtime/sysmac.scm[14.6], runtime/uenvir.scm[14.50],
	  runtime/unsyn.scm[14.25], runtime/urtrap.scm[14.9],
	  sf/pardec.scm[4.14], sf/sf.pkg[4.15]:
	Store macro definitions in environments rather than in syntax tables.

	* microcode/lookup.c[9.68]:
	Fix bug: looking up a macro returns the trap, not the transformer.

	* runtime/Attic/syntax.scm[14.47], runtime/make.scm[14.79],
	  runtime/runtime.pkg[14.399], runtime/uenvir.scm[14.49]:
	Change DEFINE-SYNTAX so that it emits code to define the macro at run
	time when written at top level.

	* microcode/errors.h[9.44], microcode/lookprm.c[1.17],
	  microcode/lookup.c[9.67], microcode/sdata.h[9.39],
	  microcode/trap.h[9.49], microcode/utabmd.scm[9.81],
	  microcode/version.h[11.183], runtime/error.scm[14.54],
	  runtime/runtime.pkg[14.398], runtime/uenvir.scm[14.48],
	  runtime/uerror.scm[14.50], runtime/urtrap.scm[14.8]:
	Implement support for storing macro transformers in environments.

	* runtime/make.scm[14.78], runtime/runtime.pkg[14.397]:
	Fix problem: this file was being syntaxed in the (RUNTIME) package but
	loaded into the () package; it needed on the macros in (RUNTIME).
	Also add this file to the package description, so that its bindings
	are visible.

	* runtime/global.scm[14.57]:
	Fix comment.

2001-12-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/arith.scm[1.7], compiler/back/lapgn3.scm[4.13],
	  compiler/base/crsend.scm[1.11], compiler/base/lvalue.scm[4.23],
	  compiler/base/scode.scm[4.12], compiler/base/utils.scm[4.22],
	  compiler/fggen/canon.scm[1.19], compiler/fggen/fggen.scm[4.34],
	  compiler/machines/C/lapgen.scm[1.13],
	  compiler/machines/C/rules3.scm[1.10],
	  compiler/machines/C/rulfix.scm[1.4],
	  compiler/machines/C/rulflo.scm[1.6],
	  compiler/machines/alpha/assmd.scm[1.3],
	  compiler/machines/alpha/dassm1.scm[1.3],
	  compiler/machines/alpha/dassm2.scm[1.3],
	  compiler/machines/alpha/instr1.scm[1.5],
	  compiler/machines/alpha/instr2.scm[1.3],
	  compiler/machines/alpha/instr3.scm[1.3],
	  compiler/machines/alpha/lapgen.scm[1.8],
	  compiler/machines/alpha/rules3.scm[1.9],
	  compiler/machines/alpha/rulflo.scm[1.5],
	  compiler/machines/bobcat/assmd.scm[1.38],
	  compiler/machines/bobcat/dassm1.scm[4.21],
	  compiler/machines/bobcat/dassm2.scm[4.24],
	  compiler/machines/bobcat/flinstr1.scm[1.3],
	  compiler/machines/bobcat/flinstr2.scm[1.3],
	  compiler/machines/bobcat/instr2.scm[1.20],
	  compiler/machines/bobcat/instr3.scm[1.19],
	  compiler/machines/bobcat/instr4.scm[1.5],
	  compiler/machines/bobcat/lapgen.scm[4.52],
	  compiler/machines/bobcat/machin.scm[4.33],
	  compiler/machines/bobcat/rules3.scm[4.42],
	  compiler/machines/i386/assmd.scm[1.4],
	  compiler/machines/i386/dassm1.scm[1.11],
	  compiler/machines/i386/dassm2.scm[1.10],
	  compiler/machines/i386/dassm3.scm[1.8],
	  compiler/machines/i386/instr1.scm[1.14],
	  compiler/machines/i386/instr2.scm[1.8],
	  compiler/machines/i386/instrf.scm[1.16],
	  compiler/machines/i386/lapgen.scm[1.29],
	  compiler/machines/i386/rules3.scm[1.36],
	  compiler/machines/i386/rulfix.scm[1.32],
	  compiler/machines/i386/rulflo.scm[1.23],
	  compiler/machines/mips/assmd.scm[1.4],
	  compiler/machines/mips/dassm1.scm[1.6],
	  compiler/machines/mips/dassm2.scm[1.6],
	  compiler/machines/mips/instr1.scm[1.8],
	  compiler/machines/mips/instr2a.scm[1.6],
	  compiler/machines/mips/instr2b.scm[1.5],
	  compiler/machines/mips/instr3.scm[1.4],
	  compiler/machines/mips/lapgen.scm[1.17],
	  compiler/machines/mips/mips.scm[1.3],
	  compiler/machines/mips/rules3.scm[1.19],
	  compiler/machines/mips/rulflo.scm[1.9],
	  compiler/machines/sparc/assmd.scm[1.3],
	  compiler/machines/sparc/instr1.scm[1.3],
	  compiler/machines/sparc/instr2a.scm[1.3],
	  compiler/machines/sparc/instr2b.scm[1.3],
	  compiler/machines/sparc/instr3.scm[1.3],
	  compiler/machines/sparc/lapgen.scm[1.4],
	  compiler/machines/sparc/rules3.scm[1.3],
	  compiler/machines/sparc/rulflo.scm[1.3],
	  compiler/machines/spectrum/assmd.scm[1.32],
	  compiler/machines/spectrum/dassm1.scm[4.21],
	  compiler/machines/spectrum/dassm2.scm[4.22],
	  compiler/machines/spectrum/instr1.scm[1.5],
	  compiler/machines/spectrum/instr2.scm[1.9],
	  compiler/machines/spectrum/instr3.scm[1.4],
	  compiler/machines/spectrum/lapgen.scm[4.49],
	  compiler/machines/spectrum/rules3.scm[4.43],
	  compiler/machines/spectrum/rulfix.scm[4.49],
	  compiler/machines/spectrum/rulflo.scm[4.41],
	  compiler/machines/vax/assmd.scm[4.8],
	  compiler/machines/vax/dassm1.scm[4.8],
	  compiler/machines/vax/dassm2.scm[4.14],
	  compiler/machines/vax/instr2.scm[1.8],
	  compiler/machines/vax/instr3.scm[1.12],
	  compiler/machines/vax/lapgen.scm[4.17],
	  compiler/machines/vax/rules3.scm[4.13],
	  compiler/machines/vax/rulfix.scm[1.7],
	  compiler/rtlbase/rtlreg.scm[4.7], edwin/buffer.scm[1.183],
	  edwin/calias.scm[1.22], edwin/dosproc.scm[1.6],
	  edwin/schmod.scm[1.58], edwin/search.scm[1.152],
	  edwin/tterm.scm[1.31], runtime/Attic/syntax.scm[14.46],
	  runtime/apply.scm[1.3], runtime/arith.scm[1.47],
	  runtime/graphics.scm[1.18], runtime/infstr.scm[1.12],
	  runtime/list.scm[14.28], runtime/scomb.scm[14.17],
	  runtime/starbase.scm[1.14], runtime/vector.scm[14.18],
	  sf/object.scm[4.11], sos/class.scm[1.10],
	  swat/scheme/mit-xhooks.scm[1.3], wabbit/test-wabbit.scm[1.2]:
	Eliminate MACRO special form.

	* compiler/base/utils.scm[4.21], compiler/etc/comcmp.scm[1.8],
	  compiler/machines/i386/instr1.scm[1.13],
	  compiler/machines/i386/instr2.scm[1.7],
	  compiler/machines/i386/instrf.scm[1.15],
	  compiler/machines/spectrum/instr2.scm[1.8],
	  compiler/machines/vax/instr1.scm[1.8],
	  compiler/machines/vax/instr2.scm[1.7],
	  compiler/machines/vax/instr3.scm[1.11], edwin/regexp.scm[1.76],
	  edwin/search.scm[1.151], edwin/syntax.scm[1.87],
	  edwin/utils.scm[1.49], microcode/os2pm.scm[1.9],
	  microcode/utabmd.scm[9.80], runtime/Attic/syntax.scm[14.45],
	  runtime/arith.scm[1.46], runtime/debug.scm[14.41],
	  runtime/error.scm[14.53], runtime/os2winp.scm[1.16],
	  runtime/parse.scm[14.34], runtime/recslot.scm[1.5],
	  runtime/rgxcmp.scm[1.117], sos/instance.scm[1.12],
	  star-parser/matcher.scm[1.27], star-parser/parser.scm[1.30],
	  swat/scheme/control-floating-errors.scm[1.2], win32/win_ffi.scm[1.7]:
	Eliminate DEFINE-MACRO special form.

	* runtime/Attic/syntax.scm[14.44]:
	Eliminate definition of SCODE-QUOTE.

	* runtime/unsyn.scm[14.24]:
	Fix over-long lines.

	* compiler/back/syntax.scm[1.28], runtime/make.scm[14.77],
	  runtime/make.scm[14.76], sf/usiexp.scm[4.41]:
	Eliminate references to THE-ENVIRONMENT.

	* compiler/etc/disload.scm[1.11], compiler/fggen/canon.scm[1.18],
	  edwin/schmod.scm[1.57], runtime/Attic/macros.scm[1.5],
	  runtime/Attic/syntax.scm[14.43], runtime/infutl.scm[1.66],
	  runtime/runtime.pkg[14.396], runtime/unsyn.scm[14.23],
	  sf/gconst.scm[4.27]:
	Eliminate references to MAKE-ENVIRONMENT.

	* 6001/make.scm[15.33], compiler/base/scode.scm[4.11],
	  compiler/fggen/canon.scm[1.17], compiler/fggen/fggen.scm[4.33],
	  compiler/rtlopt/rdebug.scm[1.4], cref/anfile.scm[1.7],
	  edwin/artdebug.scm[1.30], edwin/debug.scm[1.59],
	  edwin/kmacro.scm[1.44], edwin/schmod.scm[1.56],
	  imail/fake-env.scm[1.5], pcsample/load.scm[1.6],
	  runtime/Attic/illdef.scm[1.5], runtime/Attic/syntax.scm[14.42],
	  runtime/codwlk.scm[14.4], runtime/pp.scm[14.43],
	  runtime/prgcop.scm[1.7], runtime/runtime.pkg[14.395],
	  runtime/runtime.pkg[14.394], runtime/scode.scm[14.17],
	  runtime/thread.scm[1.35], runtime/unsyn.scm[14.22],
	  runtime/xeval.scm[1.7], sf/cgen.scm[4.5], sf/chtype.scm[4.4],
	  sf/copy.scm[4.6], sf/free.scm[4.4], sf/object.scm[4.10],
	  sf/sf.sf[4.11], sf/subst.scm[4.17], sf/xform.scm[4.11],
	  sos/macros.scm[1.11], star-parser/shared.scm[1.22],
	  swat/scheme/load.scm[1.6], swat/scheme/mit-xhooks.scm[1.2],
	  win32/wt_user.scm[1.5]:
	Eliminate IN-PACKAGE and USING-SYNTAX special forms.

	* runtime/Attic/syntab.scm[14.8], runtime/Attic/syntax.scm[14.41],
	  runtime/runtime.pkg[14.393], sicp/studen.scm[1.11]:
	Eliminate references to SYNTAX-TABLE-DEFINE and SYNTAX-TABLE-REF.

	* rcs/compile.scm[1.4], runtime/Attic/macros.scm[1.4],
	  runtime/Attic/syntax.scm[14.40], runtime/defstr.scm[14.34],
	  runtime/runtime.pkg[14.392], sf/pardec.scm[4.13],
	  sf/toplev.scm[4.19], sicp/strmac.scm[1.3], sos/load.scm[1.9],
	  star-parser/ed-ffi.scm[1.5], star-parser/matcher.scm[1.26],
	  star-parser/parser.pkg[1.16], star-parser/parser.scm[1.29],
	  swat/scheme/scc-macros.scm[1.2], win32/ffimacro.scm[1.4],
	  xml/ed-ffi.scm[1.4], xml/xml.pkg[1.9]:
	Eliminate references to SYSTEM-GLOBAL-SYNTAX-TABLE.

	* compiler/machines/i386/compiler.sf[1.17]:
	Fix bug: compiler was being syntaxed in wrong environment.

	* compiler/base/macros.scm[4.20]:
	Fix missing bindings for UCODE-PRIMITIVE and UCODE-TYPE.

	* compiler/base/macros.scm[4.19], compiler/base/macros.scm[4.18]:
	Fix problem caused by SCode-manipulating macro being closed in
	compiler environment.

	* cref/cref.sf[1.15]:
	Fix dangling reference to SF/SET-DEFAULT-SYNTAX-TABLE!.

	* 6001/6001.pkg[1.14], 6001/6001.sf[1.13], 6001/pic-ops.scm[1.6],
	  6001/pic-read.scm[1.6], 6001/pic-reco.scm[1.8],
	  6001/picture.scm[1.30], sos/instance.scm[1.11],
	  win32/win32.pkg[1.14]:
	Eliminate references to SYNTAX-TABLE/SYSTEM-INTERNAL.

	* compiler/base/switch.scm[4.26],
	  compiler/machines/C/compiler.pkg[1.12],
	  compiler/machines/C/decls.scm[1.6],
	  compiler/machines/alpha/compiler.pkg[1.15],
	  compiler/machines/alpha/compiler.sf[1.10],
	  compiler/machines/alpha/decls.scm[1.8],
	  compiler/machines/bobcat/compiler.pkg[1.52],
	  compiler/machines/bobcat/compiler.sf[1.22],
	  compiler/machines/bobcat/decls.scm[4.39],
	  compiler/machines/i386/compiler.pkg[1.26],
	  compiler/machines/i386/compiler.sf[1.16],
	  compiler/machines/i386/decls.scm[1.11],
	  compiler/machines/mips/compiler.pkg[1.22],
	  compiler/machines/mips/compiler.sf-big[1.12],
	  compiler/machines/mips/compiler.sf-little[1.12],
	  compiler/machines/mips/decls.scm[1.12],
	  compiler/machines/sparc/decls.scm[1.6],
	  compiler/machines/spectrum/compiler.pkg[1.52],
	  compiler/machines/spectrum/compiler.sf[1.22],
	  compiler/machines/spectrum/decls.scm[4.37],
	  compiler/machines/vax/compiler.pkg[1.24],
	  compiler/machines/vax/compiler.sf[1.13],
	  compiler/machines/vax/decls.scm[4.15]:
	Eliminate COMPILER:ENABLE-EXPANSION-DECLARATIONS? and the associated
	early-expansion macros.  This hasn't been used in a while and there's
	no clear way to make it work when environments and syntax tables are
	unified.

	* compiler/back/syerly.scm[1.12],
	  compiler/machines/alpha/inerly.scm[1.5],
	  compiler/machines/bobcat/inerly.scm[1.10],
	  compiler/machines/i386/inerly.scm[1.6],
	  compiler/machines/mips/inerly.scm[1.5],
	  compiler/machines/sparc/inerly.scm[1.5],
	  compiler/machines/spectrum/inerly.scm[1.5],
	  compiler/machines/vax/inerly.scm[1.9]:
	Remove unused definitions of DEFINE-EARLY-TRANSFORMER.  Move bindings
	for EARLY-TRANSFORMERS and EARLY-INSTRUCTIONS to "back/syerly.scm".

	* compiler/machines/alpha/inerly.scm[1.4],
	  compiler/machines/i386/inerly.scm[1.5],
	  compiler/machines/mips/inerly.scm[1.4],
	  compiler/machines/sparc/inerly.scm[1.4],
	  compiler/machines/spectrum/inerly.scm[1.4]:
	Remove unused EQ-SUBSET? definitions.

2001-12-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/back/asmmac.scm[1.9], compiler/base/macros.scm[4.17],
	  compiler/machines/C/compiler.pkg[1.11],
	  compiler/machines/C/compiler.sf[1.9],
	  compiler/machines/C/decls.scm[1.5],
	  compiler/machines/alpha/compiler.pkg[1.14],
	  compiler/machines/alpha/compiler.sf[1.9],
	  compiler/machines/alpha/decls.scm[1.7],
	  compiler/machines/alpha/inerly.scm[1.3],
	  compiler/machines/alpha/insmac.scm[1.3],
	  compiler/machines/alpha/lapgen.scm[1.7],
	  compiler/machines/alpha/rules1.scm[1.4],
	  compiler/machines/alpha/rules2.scm[1.3],
	  compiler/machines/alpha/rules3.scm[1.8],
	  compiler/machines/alpha/rules4.scm[1.4],
	  compiler/machines/alpha/rulfix.scm[1.5],
	  compiler/machines/alpha/rulflo.scm[1.4],
	  compiler/machines/bobcat/compiler.pkg[1.51],
	  compiler/machines/bobcat/compiler.sf[1.21],
	  compiler/machines/bobcat/decls.scm[4.38],
	  compiler/machines/bobcat/inerly.scm[1.9],
	  compiler/machines/bobcat/insmac.scm[1.128],
	  compiler/machines/i386/compiler.pkg[1.25],
	  compiler/machines/i386/compiler.sf[1.15],
	  compiler/machines/i386/decls.scm[1.10],
	  compiler/machines/i386/inerly.scm[1.4],
	  compiler/machines/i386/insmac.scm[1.12],
	  compiler/machines/mips/compiler.pkg[1.21],
	  compiler/machines/mips/compiler.sf-big[1.11],
	  compiler/machines/mips/compiler.sf-little[1.11],
	  compiler/machines/mips/decls.scm[1.11],
	  compiler/machines/mips/inerly.scm[1.3],
	  compiler/machines/mips/insmac.scm[1.4],
	  compiler/machines/sparc/decls.scm[1.5],
	  compiler/machines/sparc/inerly.scm[1.3],
	  compiler/machines/sparc/insmac.scm[1.3],
	  compiler/machines/spectrum/compiler.pkg[1.51],
	  compiler/machines/spectrum/compiler.sf[1.21],
	  compiler/machines/spectrum/decls.scm[4.36],
	  compiler/machines/spectrum/inerly.scm[1.3],
	  compiler/machines/spectrum/insmac.scm[1.4],
	  compiler/machines/vax/compiler.pkg[1.23],
	  compiler/machines/vax/compiler.sf[1.12],
	  compiler/machines/vax/decls.scm[4.14],
	  compiler/machines/vax/dsyn.scm[1.9],
	  compiler/machines/vax/inerly.scm[1.8],
	  compiler/machines/vax/insmac.scm[1.14]:
	Remove explicit references to syntax tables.

	* 6001/6001.sf[1.12], pcsample/pcs.sf[1.3], runtime/option.scm[14.39],
	  runtime/runtime.pkg[14.391], runtime/runtime.sf[14.17],
	  runtime/sysmac.scm[14.5], sf/sf.sf[4.10], sos/compile.scm[1.5],
	  sos/ed-ffi.scm[1.3], sos/instance.scm[1.10], sos/sos.pkg[1.10],
	  swat/scheme/other/unhash-testing.scm[1.2], swat/scheme/swat.cbf[1.2],
	  swat/scheme/swat.sf[1.4], wabbit/wabbit.sf[1.4], win32/win32.sf[1.7],
	  win32/win32.sf[1.6]:
	Eliminate references to SYNTAX-TABLE/SYSTEM-INTERNAL.

	* microcode/cmpauxmd/i386.m4[1.56], microcode/cmpintmd/i386.h[1.34]:
	Change cache serialization to do condition testing once when Scheme is
	started rather each time a closure is created.

	* sf/sf.pkg[4.14], sf/toplev.scm[4.18]:
	Delete SF/SET-DEFAULT-SYNTAX-TABLE!.

	* 6001/nodefs.scm[1.12], edwin/artdebug.scm[1.29],
	  edwin/comred.scm[1.123], edwin/debug.scm[1.58],
	  edwin/editor.scm[1.253], edwin/evlcom.scm[1.65],
	  edwin/filcom.scm[1.223], edwin/intmod.scm[1.115],
	  edwin/schmod.scm[1.55], runtime/Attic/syntax.scm[14.39],
	  runtime/error.scm[14.52], runtime/load.scm[14.60],
	  runtime/packag.scm[14.39], runtime/rep.scm[14.57],
	  runtime/runtime.pkg[14.390], runtime/usrint.scm[1.17]:
	Excise syntax tables from the REPL.

	* runtime/uenvir.scm[14.47]:
	Reimplement EXTEND-INTERPRETER-ENVIRONMENT and
	MAKE-NULL-INTERPRETER-ENVIRONMENT so that they don't use EVAL, and so
	that they take optional arguments specifying bindings to be defined in
	the newly-allocated environment.

	* runtime/Attic/syntax.scm[14.38], runtime/Attic/syntax.scm[14.37],
	  runtime/global.scm[14.56], runtime/runtime.pkg[14.389],
	  sf/sf.pkg[4.13]:
	Move SYNTAXER/DEFAULT-ENVIRONMENT into the syntaxer.

	* edwin/autold.scm[1.62]:
	Use default syntax table for LOAD.

	* cref/redpkg.scm[1.25]:
	Change order of names in renaming export declaration; now first name
	is always the destination and second is always the source.

	* compiler/etc/disload.scm[1.10], edwin/autold.scm[1.61],
	  edwin/debug.scm[1.57], edwin/evlcom.scm[1.64],
	  edwin/macros.scm[1.67], runtime/unpars.scm[14.49],
	  sf/usicon.scm[4.5], sos/load.scm[1.8], swat/scheme/load.scm[1.5],
	  xml/compile.scm[1.8]:
	Change references to LOCAL-ASSIGNMENT and LEXICAL-* to instead use
	procedures in the environment abstraction.

	* edwin/edwin.pkg[1.278], edwin/rename.scm[1.8], edwin/winren.scm[1.6]:
	Rename references to SCode variable abstraction.  Eliminate special
	hack in "rename.scm"; instead use new packaging feature to link
	different names.

	* edwin/dired.scm[1.190]:
	Eliminate unnecessary use of LEXICAL-UNREFERENCEABLE?.

	* edwin/clsmac.scm[1.5], edwin/xform.scm[1.11]:
	Rename references to SCode variable abstraction.

	* runtime/uerror.scm[14.49]:
	Use ENVIRONMENT-DEFINE in place of LOCAL-ASSIGNMENT.

	* runtime/Attic/syntab.scm[14.7], runtime/Attic/syntax.scm[14.36],
	  runtime/runtime.pkg[14.388], runtime/uenvir.scm[14.46]:
	Implement ENVIRONMENT-DEFINE and ENVIRONMENT-ASSIGNED?.  Change
	ENVIRONMENT-LOOKUP to signal an error if the variable is unassigned.
	Move ENVIRONMENT-SYNTAX-TABLE and SET-ENVIRONMENT-SYNTAX-TABLE! into
	the syntax-table abstraction.

2001-12-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/edwin.pkg[1.277], edwin/xform.scm[1.10]:
	Rename references to SCode variable abstraction.

	* runtime/load.scm[14.59]:
	Allow syntax table to be explicitly defaulted.

	* edwin/autold.scm[1.60], edwin/autold.scm[1.59]:
	Use default syntax table for LOAD.

	* edwin/c-mode.scm[1.60], edwin/htmlmode.scm[1.5],
	  edwin/javamode.scm[1.11], edwin/midas.scm[1.22],
	  edwin/pasmod.scm[1.51], edwin/schmod.scm[1.54],
	  edwin/syntax.scm[1.86], edwin/texcom.scm[1.46],
	  edwin/tximod.scm[1.25], edwin/verilog.scm[1.9], edwin/vhdl.scm[1.9]:
	Use MAKE-CHAR-SYNTAX-TABLE rather than MAKE-SYNTAX-TABLE.

	* edwin/edwin.sf[1.29]:
	Eliminate reference to SYNTAX-TABLE/SYSTEM-INTERNAL.

	* runtime/sysmac.scm[14.4]:
	Attach syntax table to (RUNTIME) environment.

	* imail/imail.pkg[1.95]:
	(RUNTIME URL) package must inherit from (RUNTIME).

	* edwin/autold.scm[1.58], edwin/clsmac.scm[1.4], edwin/decls.scm[1.71],
	  edwin/dosshell.scm[1.5], edwin/ed-ffi.scm[1.52],
	  edwin/edwin.pkg[1.276], edwin/edwin.sf[1.28],
	  edwin/filcom.scm[1.222], edwin/fileio.scm[1.156],
	  edwin/macros.scm[1.66]:
	Eliminate references to EDWIN-SYNTAX-TABLE and CLASS-SYNTAX-TABLE.

	* imail/compile.scm[1.16], imail/ed-ffi.scm[1.18]:
	Eliminate references to syntax tables.

	* runtime/load.scm[14.58]:
	Default syntax table must be ENVIRONMENT-SYNTAX-TABLE of load
	environment.

	* edwin/intmod.scm[1.114], runtime/runtime.pkg[14.387],
	  runtime/uenvir.scm[14.45]:
	Rename EXTEND-IC-ENVIRONMENT to EXTEND-INTERPRETER-ENVIRONMENT.

	* runtime/uenvir.scm[14.44]:
	Don't generate syntax tables automatically in EXTEND-IC-ENVIRONMENT.

	* runtime/Attic/syntab.scm[14.6]:
	Extend syntax-table abstraction so that it works on environments as
	well as syntax tables.

	* compiler/base/toplev.scm[4.61], runtime/Attic/syntax.scm[14.35]:
	Use GUARANTEE-SYNTAX-TABLE.

	* runtime/urtrap.scm[14.7]:
	Create procedures to generate unassigned and unbound objects.

	* runtime/symbol.scm[1.7]:
	Replace magic code by reference to MAKE-UNMAPPED-UNBOUND-REFERENCE-TRAP.

	* runtime/packag.scm[14.38], runtime/runtime.pkg[14.386]:
	Create procedure to generate unassigned objects.

	* runtime/packag.scm[14.37]:
	Guarantee that source binding of an import is defined.  Source binding
	of an export is always defined by the package description.

	* cref/redpkg.scm[1.24]:
	Don't ever mark the source binding of a link as new.  This was an
	attempt to work around problems with the linker, but the problem is in
	the linker and not here; the linker should automatically generate the
	source binding if it is missing.

	* runtime/Attic/syntax.scm[14.34], runtime/bitstr.scm[14.4],
	  runtime/blowfish.scm[1.24], runtime/boole.scm[14.4],
	  runtime/boot.scm[14.13], runtime/ed-ffi.scm[1.31],
	  runtime/equals.scm[14.9], runtime/fixart.scm[1.8],
	  runtime/global.scm[14.55], runtime/lambdx.scm[14.10],
	  runtime/make.scm[14.75], runtime/msort.scm[14.9],
	  runtime/ntprm.scm[1.37], runtime/os2prm.scm[1.48],
	  runtime/qsort.scm[14.5], runtime/queue.scm[14.5],
	  runtime/runtime.pkg[14.385], runtime/sfile.scm[14.32],
	  runtime/symbol.scm[1.6], runtime/udata.scm[14.21],
	  runtime/unxprm.scm[1.62], runtime/vector.scm[14.17]:
	Restructure packaging so that all runtime-system packages inherit from
	the (RUNTIME) package.  We will use the latter as a place to attach
	the syntax from SYNTAX-TABLE/SYSTEM-INTERNAL.

	* runtime/make.scm[14.74]:
	Fix typo in comment.

2001-12-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/cmpauxmd/i386.m4[1.55]:
	Athlon model 2 is OK as well.

	* microcode/cmpauxmd/i386.m4[1.54]:
	Fine tune the code that decides when to use CPUID.  For now, use it
	only for Athlon model 1, 2, 3, or 4 processors.  According to AMD, the
	model 6 is OK, and perhaps the model 7 as well.  The model 4 is known
	to be bad, and models 1, 2, and 3 are probably bad too.  No Intel
	processors are known to be bad.

	* microcode/cmpauxmd/i386.m4[1.53]:
	Fix: ia32_cache_synchronize is supposed to be an ordinary C procedure,
	not an "entry point" for "cmpint.c".

	* microcode/cmpauxmd/i386.m4[1.52]:
	Use ".586p" rather than ".386p"; otherwise the CPUID instruction isn't
	recognized.

	* microcode/makegen/Makefile.in.in[1.18]:
	Fix default target; it wasn't including everything.

	* 6001/6001.pkg[1.13], compiler/machines/C/compiler.sf[1.8],
	  compiler/machines/alpha/compiler.sf[1.8],
	  compiler/machines/bobcat/compiler.sf[1.20],
	  compiler/machines/i386/compiler.sf[1.14],
	  compiler/machines/mips/compiler.sf-big[1.10],
	  compiler/machines/mips/compiler.sf-little[1.10],
	  compiler/machines/spectrum/compiler.sf[1.20],
	  compiler/machines/vax/compiler.sf[1.11], cref/Makefile.in[1.2],
	  cref/cref.sf[1.14], cref/make.scm[1.24], cref/redpkg.scm[1.23],
	  cref/toplev.scm[1.16], edwin/Clean.sh[1.5], edwin/edwin.sf[1.27],
	  edwin/make.scm[3.113], imail/Makefile.in[1.3], imail/clean.sh[1.4],
	  imail/imail.pkg[1.94], runtime-check/Clean.sh[1.3],
	  runtime-check/Setup.sh[1.5], runtime/make.scm[14.73],
	  runtime/packag.scm[14.36], runtime/runtime.pkg[14.384],
	  runtime/sfile.scm[14.31], runtime/version.scm[14.204],
	  sf/butils.scm[4.11], sf/make.scm[4.40], sf/sf.pkg[4.12],
	  sos/Makefile.in[1.3], star-parser/Makefile.in[1.2],
	  xml/Makefile.in[1.2]:
	Change package system to conditionalize everything according to the
	operating-system type.  All output files are now OS-specific, e.g.
	"runtime.pkg" produces output files "runtime-unx.{pkd,fre,crf}".
	Package files can now use the conditionalization variable OS-TYPE.

	* edwin/filcom.scm[1.221], edwin/make.scm[3.112]:
	Allow syntax-table information to be left out of FFI tables.  This
	simplifies transition to new system in which syntax information is
	stored in environments.

	* runtime/version.scm[14.203]:
	Update to reflect that things have changed since the 7.6.0 release.

2001-12-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/make.scm[4.116], compiler/base/make.scm[4.115.4.1],
	  compiler/machines/i386/dassm3.scm[1.7],
	  compiler/machines/i386/instr1.scm[1.12],
	  compiler/machines/i386/lapgen.scm[1.28],
	  compiler/machines/i386/rules3.scm[1.35], microcode/bchdmp.c[9.90],
	  microcode/bchgcl.c[9.54], microcode/bintopsb.c[9.74],
	  microcode/cmpauxmd/i386.m4[1.51], microcode/cmpgc.h[1.32],
	  microcode/cmpint.c[1.95], microcode/cmpintmd/alpha.h[1.6],
	  microcode/cmpintmd/i386.h[1.33], microcode/fasdump.c[9.66],
	  microcode/fasload.c[9.91], microcode/gcloop.c[9.49],
	  microcode/nttrap.c[1.19], microcode/os2xcpt.c[1.9],
	  microcode/purify.c[9.61], microcode/purutl.c[9.52],
	  microcode/uxtrap.c[1.31], microcode/version.h[11.182],
	  microcode/version.h[11.181.4.2], microcode/wabbit.c[1.9]:
	Add explicit cache synchronization support to work around a bug in the
	Athlon.

	* compiler/machines/i386/rules3.scm[1.34.4.3]:
	Use new compiled-code hook to executes the CPUID instruction out of
	line only on those processors that need it.

	* compiler/machines/i386/lapgen.scm[1.27.4.1],
	  microcode/cmpauxmd/i386.m4[1.50.8.2],
	  microcode/cmpintmd/i386.h[1.32.4.2]:
	Add asm_conditionally_serialize, a compiled-code hook that executes
	the CPUID instruction for some processors.

	* compiler/machines/i386/rules3.scm[1.34.4.2]:
	Use a different code sequence for CPUID; see if it gets better
	performance.

	* compiler/machines/i386/dassm3.scm[1.6.4.1]:
	Add CPUID instruction.

2001-12-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/version.h[11.181.4.1]:
	Update version number for IA-32 cache synchronization.

	* microcode/bchdmp.c[9.89.4.1], microcode/bchgcl.c[9.53.4.1],
	  microcode/bintopsb.c[9.73.4.1], microcode/cmpgc.h[1.31.4.1],
	  microcode/cmpint.c[1.94.4.1], microcode/cmpintmd/alpha.h[1.5.8.1],
	  microcode/fasdump.c[9.65.4.1], microcode/fasload.c[9.90.4.1],
	  microcode/gcloop.c[9.48.4.1], microcode/nttrap.c[1.18.4.1],
	  microcode/os2xcpt.c[1.8.4.1], microcode/purify.c[9.60.4.1],
	  microcode/purutl.c[9.51.4.1], microcode/uxtrap.c[1.30.4.1],
	  microcode/wabbit.c[1.8.4.1]:
	Eliminate stupid -1 offset in MANIFEST_CLOSURE_END.

	* compiler/machines/i386/rules3.scm[1.34.4.1]:
	Invoke CPUID instruction after allocating a closure, in order to
	synchronize the I/D caches.  This is a temporary kludge for proof of
	concept; it will be replaced by more efficient code.

	* compiler/machines/i386/instr1.scm[1.11.4.1]:
	Add support for CPUID instruction.

	* microcode/cmpintmd/i386.h[1.32.4.1]:
	Add support for cache synchronization.

	* microcode/cmpauxmd/i386.m4[1.50.8.1]:
	Add support for CPUID instruction.
	Remove support for DOS and HACK_SEGMENT_REGS.

2001-12-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/switch.scm[4.25.2.1],
	  compiler/fggen/canon.scm[1.16.2.1]:
	Eliminate COMPILER:AVOID-SCODE?.

	* sicp/genenv.scm[1.3.2.1]:
	Eliminate use of MAKE-ENVIRONMENT.

2001-12-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/intmod.scm[1.113.2.1], imail/fake-env.scm[1.4.2.2]:
	Rename EXTEND-IC-ENVIRONMENT to EXTEND-INTERPRETER-ENVIRONMENT.

	* compiler/base/utils.scm[4.20.2.1], edwin/schmod.scm[1.53.2.1],
	  runtime/Attic/macros.scm[1.3.2.1], runtime/infutl.scm[1.65.2.1],
	  runtime/unsyn.scm[14.21.2.1]:
	Eliminate rule for MAKE-ENVIRONMENT.

	* compiler/etc/disload.scm[1.9.2.1], imail/fake-env.scm[1.4.2.1]:
	Eliminate use of MAKE-ENVIRONMENT.

2001-12-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/lookup.c[9.66]:
	Must call MAP_TO_UNASSIGNED on value of definition when creating a new
	binding.

2001-12-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/config.guess[11.2], microcode/config.sub[11.2]:
	Update autoconf config.* files.

2001-12-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.279], imail/load.scm[1.37]:
	Change imail-forward to (by default) ask whether to forward all
	headers.

2001-11-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/Makefile.in[1.6]:
	URL support no longer in runtime system; remove reference.

	* microcode/makegen/Makefile.in.in[1.17]:
	Change default target so that it doesn't try to generate "utabmd.bin".
	The "all" target remains unchanged.

	* cref/redpkg.scm[1.22]:
	Make another attempt to fix the problem with imports.  The previous
	fix didn't work when the analysis information was absent.

2001-11-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/msort.scm[14.8]:
	Tweak merge sort to be stable.

2001-11-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/unicode.scm[1.2]:
	Change WELL-FORMED-CODE-POINTS-LIST? to require that the argument be a
	proper list.

2001-11-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/shared.scm[1.21]:
	Optimizer wasn't deleting unused procedure-valued bindings if the
	procedure had side-effects.  The bug fix to make top-level failure
	continuations do backtracking prevented them from being substituted
	properly; the substitution predicate was extended to allow this.
	Also, some valuable substitutions weren't being seen because the
	optimizers were being run in a fixed order.  After the peephole
	optimization is done, it reveals more possibilities for substitution.
	So now the optimizers are re-run until nothing more can be done.

	* star-parser/matcher.scm[1.25], star-parser/parser.scm[1.28]:
	Top-level failure continuations must do backtracking.

2001-11-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.195]:
	Change imap-url-mailbox to always be a string.  The root "mailbox" is
	"", and the root container is "/".  Both of these are handled
	specially when converting the URL to a string.
	
	This fixes the bug that allowed the malformed container URL
	"imap://localhost//".

2001-11-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.194], imail/imail-imap.scm[1.193]:
	Change file naming for cache files, so that it satisfies more
	stringent Windows requirements.  Make sure that directory structure
	exists before locking a folder.

2001-11-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* cref/redpkg.scm[1.21]:
	Fix bug: imported bindings in package extensions weren't being
	constructed.

2001-11-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/version.scm[14.202]:
	Update version number for 7.6.0 release.

	* star-parser/matcher.scm[1.24], star-parser/parser.scm[1.27],
	  star-parser/shared.scm[1.20], star-parser/shared.scm[1.19]:
	Fix some problems in the pointer optimization: pointers were being
	incorrect elided across lambda expressions, and external pointer
	bindings were being elided.  The latter is fixed by introducing a
	mechanism to distinguish internal identifiers, which eliminates the
	need for the WITH-POINTER kludge.

	* star-parser/matcher.scm[1.23], star-parser/parser.scm[1.26],
	  star-parser/shared.scm[1.18], star-parser/shared.scm[1.17]:
	Change naming of peephole optimizer.  Fold all optimization into
	GENERATE-EXTERNAL-PROCEDURE.

	* star-parser/shared.scm[1.16]:
	Add optimizer to elide unnecessary buffer-pointer assignments.

2001-11-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/load.scm[1.36], xml/load.scm[1.4]:
	Runtime support for *PARSER now integrated into the runtime system.

	* runtime/ed-ffi.scm[1.30], runtime/runtime.pkg[14.383],
	  runtime/unicode.scm[1.1], star-parser/Attic/buffer.scm[1.12],
	  star-parser/Attic/unicode.scm[1.7], star-parser/compile.scm[1.4],
	  star-parser/ed-ffi.scm[1.4], star-parser/parser.pkg[1.15]:
	Move unicode support into runtime system.

	* runtime/rexp.scm[1.18]:
	Fix typo.

	* runtime/ed-ffi.scm[1.29], runtime/parser-buffer.scm[1.1],
	  runtime/runtime.pkg[14.382]:
	Move parser-buffer abstraction into runtime system.

	* star-parser/shared.scm[1.15]:
	Reorganize code for presentation style -- no change in function.  Add
	comments explaining how new optimizer works.  Split up some large
	procedures into smaller focused pieces.  Reorder code to improve
	readability.

2001-11-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/matcher.scm[1.22], star-parser/parser.scm[1.25]:
	Add comment explaining the WITH-POINTER kludge.

2001-11-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/load.scm[1.11], star-parser/matcher.scm[1.21],
	  star-parser/matcher.scm[1.20], star-parser/parser.scm[1.24],
	  star-parser/parser.scm[1.23], star-parser/shared.scm[1.14]:
	Implement substitution optimizer, which does a kind of data-flow
	analysis to eliminate unnecessary lambda expressions.

	* xml/compile.scm[1.7]:
	Need SOS loaded for proper compilation.

2001-11-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.192], imail/imail-imap.scm[1.191],
	  imail/imail-top.scm[1.278], imail/imail.pkg[1.93],
	  imail/todo.txt[1.135]:
	Add locking mechanism for the IMAP folder cache.  There is one lock
	per folder, and the lock is held only while the folder cache is being
	read and/or written.  IMAIL will try three times to obtain the lock,
	waiting one second between retries; thereafter it ignores the cache
	until the lock becomes available.

2001-11-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/load.scm[1.35], imail/url.scm[1.11]:
	Make sure *PARSER is loaded for IMAIL.  It's not necessary to load it
	just for the URL file.

	* imail/compile.scm[1.15], imail/ed-ffi.scm[1.17],
	  imail/imail.pkg[1.92], imail/imail.pkg[1.91], imail/load.scm[1.34],
	  runtime/Attic/url.scm[1.11], runtime/ed-ffi.scm[1.28],
	  runtime/optiondb.scm[1.13], runtime/runtime.pkg[14.381],
	  runtime/version.scm[14.201]:
	Move URL support back to IMAIL from the runtime system.

	* imail/url.scm[1.10]:
	Move this back to IMAIL from the runtime system.  Unlike anything else
	in the runtime system, it requires *PARSER to compile, and I'm not
	ready to add that dependency.

	* xml/load.scm[1.3]:
	Add missing option dependencies.

	* compiler/base/make.scm[4.115]:
	Many changes to closure analysis require incrementing version number.

	* compiler/fgopt/closan.scm[4.29]:
	Add long explanation of the analysis.

	* compiler/fgopt/closan.scm[4.28]:
	Stylistic changes.

	* compiler/fgopt/closan.scm[4.27]:
	Three fixes that together resolve the problem of compiling the XML
	parser.  (1) FOR-EACH-CALLEE! claimed to examine all of the callees,
	but it wasn't looking at procedures called from descendant blocks that
	had been disowned.  (2) When removing dependent constraints, due to
	closure, constraints that had indirect dependencies on the now-closed
	procedure weren't being removed.  (3) When adding undrifting
	constraints due to closure contagion, it's wrong to constrain the
	invocation block of a trivial closure.

2001-11-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/fgopt/closan.scm[4.26]:
	Use new names for LIST-TRANSFORM- procedures; eliminate private
	definition for LIST-TRANSFORM-NEGATIVE!.  Open up definition of
	FOR-EACH-CALLEE! so that it can be experimented with.  Change
	implementation of undrifting conditions so that they can have multiple
	dependencies.

2001-11-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/schmod.scm[1.53]:
	Add indentation bindings for new names in runtime system.

	* runtime/uenvir.scm[14.43], runtime/uenvir.scm[14.42]:
	Fix bug: ENVIRONMENT-BOUND? wasn't examining ancestors of
	compiled-code environment frames.

	* compiler/fgopt/closan.scm[4.25]:
	Rearrange code to separate out manipulation of constraints list.

	* compiler/fgopt/closan.scm[4.24]:
	Add explicit CONDITION datatype to track the conditions that tag
	undrifting constraints.  This simplifies the code and clarifies what
	is happening.
	
	Also change PENDING-UNDRIFTING? to examine the conditions for validity
	in the same way that UNDRIFT-PROCEDURES! does.

	* compiler/fgopt/closan.scm[4.23]:
	Guarantee that empty constraint entries are entirely removed.

	* runtime/list.scm[14.27], runtime/runtime.pkg[14.380]:
	Change names:
	
	    list-transform-positive => keep-matching-items
	    list-transform-negative => delete-matching-items
	    list-search-positive    => find-matching-item
	
	Implement new procedures:
	
	    keep-matching-items!
	    delete-matching-items!

2001-11-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/fgopt/closan.scm[4.22]:
	Add hooks to generate debugging info about constraints.

	* compiler/fgopt/closan.scm[4.21]:
	Use RVALUE/TRUE-PROCEDURE? where appropriate.

	* compiler/fgopt/closan.scm[4.20], compiler/fgopt/envopt.scm[1.10]:
	Rewrite for style.

	* compiler/fgopt/closan.scm[4.19], compiler/fgopt/envopt.scm[1.9]:
	Change value of PROCEDURE-FREE-CALLEES so that it contains sets of
	blocks rather than lists of variables.

2001-10-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.277]:
	Change M-x imail-file-message to default to the last output file.

	* edwin/filcom.scm[1.220]:
	Use PROMPT-OPTIONS-DEFAULT-STRING to determine default prompt.  This
	allows caller to specify that history is to be used.

	* edwin/edwin.pkg[1.275], edwin/prompt.scm[1.198]:
	Implement PROMPT-OPTIONS-DEFAULT-STRING to determine whether a set of
	options specifies a default prompt string.

2001-10-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/uxtrap.h[1.30]:
	Modern GNU/Linux implementations provide full siginfo and sigcontext
	support, so use that instead of kludging our own.

	* microcode/uxsig.c[1.37]:
	Add code to reinitialize the floating-point control word on IA-32
	machines when SIGFPE is received.  When this isn't done, all of the
	traps are disabled.

	* imail/imail-top.scm[1.276]:
	Add workaround for non-standard MIME encoding types used by Microsoft.

2001-10-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/proced.scm[4.23]:
	Implement RVALUE/TRUE-PROCEDURE?.

2001-10-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/prmhash.c[11.4]:
	Fix problem: I was interpreting the meaning of mhash_count
	incorrectly.

2001-10-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/blocks.scm[4.15], compiler/base/lvalue.scm[4.22],
	  compiler/base/proced.scm[4.22], compiler/base/proced.scm[4.21],
	  compiler/base/rvalue.scm[4.8], compiler/fgopt/desenv.scm[4.5]:
	Update for style.

	* runtime/fixart.scm[1.7]:
	Add FLO:FINITE?.

2001-10-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/base/debug.scm[4.16]:
	Fix newline convention of debugging tools to match current convention.

2001-10-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* xml/xml-parser.scm[1.11]:
	Fix problem in declaration parser.

	* etc/optiondb.scm[1.8]:
	Add *PARSER and XML options.

	* star-parser/matcher.scm[1.19], star-parser/parser.scm[1.22],
	  star-parser/shared.scm[1.13]:
	Add code to reuse existing buffer pointers where possible.

	* star-parser/matcher.scm[1.18], star-parser/parser.scm[1.21],
	  star-parser/shared.scm[1.12]:
	OK, this time it's right.  I've gone through all the combinations, and
	everything makes sense.  There are some minor efficiency issues which
	will be resolved in the next revision.

	* compiler/base/make.scm[4.114], compiler/fgopt/conect.scm[4.6]:
	Fix bug: don't avoid coloring part of the graph just because it is
	going to be inlined later.  There is probably a subtle bug here, but
	finding it will require too much thought, and this fix appears to
	work.

	* star-parser/matcher.scm[1.17], star-parser/parser.scm[1.20],
	  star-parser/shared.scm[1.11]:
	Rewrite control structures again.  These seem correct, after many
	hours of thought and testing.  Also make new top-level wrapper for
	code generators, and eliminate a couple of unused definitions.

2001-10-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/load.scm[1.10], star-parser/matcher.scm[1.16],
	  star-parser/parser.scm[1.19], star-parser/shared.scm[1.10]:
	Complete rewrite of output control structure.  New structure supports
	backtracking properly, doing greedy matching until a failure occurs,
	then backtracking arbitrarily deeply to find a way forward.

2001-10-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.190]:
	Fix bug: large message-body parts were being stored in the cache as
	zero-length strings.

2001-10-13  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-syntax.scm[1.18]:
	Rewrite so we don't depend on matchers lifting complex expressions
	upwards.

2001-10-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/option.scm[14.38]:
	Fix LOAD-OPTION so that a loading option can load any other option.

	* imail/Attic/parser.scm[1.5], imail/compile.scm[1.14],
	  imail/ed-ffi.scm[1.16], imail/imail-imap.scm[1.189],
	  imail/imail.pkg[1.90], imail/imap-response.scm[1.44],
	  imail/imap-syntax.scm[1.17], imail/load.scm[1.33],
	  runtime/Attic/url.scm[1.10], runtime/runtime.pkg[14.379]:
	The parser language developed for IMAIL has been replaced by the
	newer *PARSER facility.

2001-10-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* etc/Stage.sh[1.3]:
	Fix quoting problem.

	* runtime/optiondb.scm[1.12]:
	Fix case of symbol.

	* star-parser/matcher.scm[1.15]:
	Interpret bare string or char as self.

	* star-parser/parser.scm[1.18]:
	Interpret bare string or char to be noise.

2001-10-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/Attic/rexp.scm[1.16], imail/compile.scm[1.13],
	  imail/ed-ffi.scm[1.15], imail/imail.pkg[1.89], imail/load.scm[1.32],
	  imail/url.scm[1.9]:
	Remove URL and rexp support, which are now in the runtime system.

	* etc/compile.scm[1.3]:
	Don't forget to compile *parser and xml support.

	* runtime/savres.scm[14.34]:
	Don't clear the screen on restore.

	* runtime/Makefile.in[1.5], runtime/ed-ffi.scm[1.27],
	  runtime/optiondb.scm[1.11], runtime/runtime.pkg[14.378]:
	Add URL-encoding support.

	* runtime/Attic/url.scm[1.9]:
	Fix copyright.  Guarantee regular-expression is loaded.  Fix bug in
	URL:SUBSTRING-ENCODED?.

	* runtime/rexp.scm[1.17]:
	Fix copyright dates.

	* runtime/ed-ffi.scm[1.26]:
	Add missing file: ntdir.

	* runtime/Makefile.in[1.4], runtime/ed-ffi.scm[1.25],
	  runtime/optiondb.scm[1.10], runtime/runtime.pkg[14.377]:
	Add rexp abstraction.

	* runtime/rexp.scm[1.16]:
	Update copyright.  Add comment explaining contents of file.  Change
	logic since character sets are no longer represented as strings.  If
	character set is argument to CASE-FOLD, then case-fold it.

2001-10-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* Makefile.in[1.18], Setup.sh[1.7], configure.in[1.5]:
	Integrate *PARSER and XML support into system.

	* star-parser/Attic/buffer.scm[1.11],
	  star-parser/Attic/unicode.scm[1.6]:
	Fix typo.

	* star-parser/Makefile.in[1.1], star-parser/load.scm[1.9],
	  star-parser/load.scm[1.8], star-parser/parser.pkg[1.14],
	  xml/Makefile.in[1.1], xml/compile.scm[1.6], xml/load.scm[1.2],
	  xml/xml.pkg[1.8]:
	Integrate into MIT Scheme.

	* star-parser/Attic/unicode.scm[1.5], star-parser/parser.pkg[1.13]:
	Implement READ-UTF8-CODE-POINT and WRITE-UTF8-CODE-POINT.

	* microcode/string.c[9.47], microcode/string.c[9.46],
	  microcode/string.c[9.45]:
	Don't unnecessarily change the length of a string when altering its
	maximum length.

	* star-parser/Attic/buffer.scm[1.10], star-parser/parser.pkg[1.12],
	  star-parser/parser.pkg[1.11]:
	Move MATCH-UTF8-CHAR-IN-ALPHABET into parser-buffer abstraction.

	* star-parser/Attic/unicode.scm[1.4], star-parser/parser.pkg[1.10]:
	Remove all references to parser buffers.

	* star-parser/Attic/buffer.scm[1.9]:
	Optimize code to read and match characters from the buffer.

2001-10-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/global.scm[14.54]:
	Add binding for UNBIND-VARIABLE.

2001-10-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* cref/redpkg.scm[1.20]:
	Fix bug that was causing some variables to erroneously have multiple
	bindings.

	* imail/imail-top.scm[1.275]:
	Leave attachment markers in the output message.  The result will be an
	exact copy of the buffer contents.

	* star-parser/compile.scm[1.3], xml/compile.scm[1.5]:
	Update for new CREF.

2001-09-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.134]:
	Make changes related to new cache mechanism.

2001-09-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.274]:
	START-PROBE-FOLDER-THREAD is being called whenever a message is
	selected, but unfortunately if there was already a thread, it was
	being killed and a new one started, which generated network traffic on
	an IMAP folder.  Now it doesn't do anything if there is already a
	thread.

	* imail/imail-imap.scm[1.188]:
	Don't generate "Reading ..." messages unless actually going to the
	network.  Remove debugging code inadvertently left in last revision.

	* imail/todo.txt[1.133]:
	Add disk cache for IMAP folders.

2001-09-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.187], imail/imail-imap.scm[1.186],
	  imail/load.scm[1.31]:
	Add disk cache for IMAP folders.

	* imail/imail-top.scm[1.273]:
	Implement new command M-x imail-file-message, which writes message to
	a file in a human-readable format.

	* imail/imail-file.scm[1.80], imail/imail-rmail.scm[1.69],
	  imail/imail-top.scm[1.272], imail/imail-umail.scm[1.50],
	  imail/imail.pkg[1.88], imail/load.scm[1.30]:
	Change handling of file folders so that their type is determined
	solely by their contents rather than their names.

	* cref/conpkg.scm[1.14], cref/forpkg.scm[1.10], cref/redpkg.scm[1.19]:
	Fix bug: package parent can sometimes be the symbol UNKNOWN.

2001-09-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* Makefile.in[1.17], configure.in[1.4], cref/Makefile.in[1.1]:
	CREF should now be included in the install directory.

	* compiler/Clean.sh[1.5], edwin/Clean.sh[1.4], edwin/Clean.sh[1.3]:
	Update to reflect changes to packaging.

	* sf/gconst.scm[4.26]:
	Remove four more definitions that are no longer bound to primitives.

	* edwin/prompt.scm[1.197]:
	Fix bug: documentation string for M-x repeat-complex-command was
	referring to repeat-complex-command mode, which no longer exists.

	* microcode/utabmd.scm[9.79]:
	Eliminate calls to IMPLEMENTED-PRIMITIVE-PROCEDURE? which were causing
	trouble in the boot load.  This was due to rewriting of string
	support.

	* compiler/rtlgen/opncod.scm[4.70]:
	Fix typo in previous change.

	* compiler/rtlopt/rinvex.scm[1.10]:
	Eliminate use of DEFINE-METHOD syntactic keyword.

	* compiler/rtlgen/opncod.scm[4.69]:
	Don't open-code any of the cell primitives.

	* runtime/runtime.pkg[14.376], runtime/string.scm[14.45]:
	Extensive rewriting to make type-checking more uniform, and to
	eliminate cases where it was being performed twice.  Eliminate even
	more primitives, and speed up the procedures as much as possible.

	* runtime/char.scm[14.13]:
	Split off unchecked character comparisons, for inclusion in
	"string.scm".

	* runtime/chrset.scm[14.16]:
	Add type checking to all procedures, and rewrite some of the loops for
	speed.

	* runtime/chrsyn.scm[1.5]:
	Fix bug in previous change.

	* runtime/runtime.sf[14.16]:
	The file "char.scm" must now be compiled early as it is integrated
	into "string.scm".

	* runtime/packag.scm[14.35]:
	Fix thinko.

	* sf/gconst.scm[4.25], sf/make.scm[4.39]:
	Eliminate a large number of inlined primitives.  Some of these are
	necessary due to changes in the runtime system.  Others are eliminated
	because I don't want their names reserved, or because it's
	inappropriate to inline them.

	* runtime/list.scm[14.26]:
	Change LENGTH to be a Scheme procedure rather than a primitive.  New
	procedure now checks its argument for circularity and signals an error.

	* runtime/utabs.scm[14.14]:
	Write private version of INTERN, which is needed early in the boot
	sequence before all of the necessary mechanism is initialized.

	* runtime/rgxcmp.scm[1.116]:
	Fix bugs in character-set compilation.  This code was confusing ASCII
	fixnums and characters, which works only in compiled code.

	* runtime/random.scm[14.24]:
	Initialization sequence for RNG was depending on fact that
	REAL-TIME-CLOCK was inline-coded.

	* edwin/calias.scm[1.21]:
	Fix bug: EMACS-KEY-NAME wasn't able to handle a button as an argument.

2001-09-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/char.scm[14.12], runtime/runtime.pkg[14.375],
	  runtime/string.scm[14.44]:
	Make ISO-8859-1 changes to string code, which involved rewriting all
	of the case-aware procedures.  Many of these were inherited from
	primitives, so it was necessary to write Scheme versions of the
	primitives.

	* runtime/chrset.scm[14.15]:
	Extend alphabetic predicates to know about ISO-8859-1 letters.

	* runtime/char.scm[14.11]:
	Eliminate use of all character primitives except for CHAR?,
	CHAR->INTEGER, and INTEGER->CHAR.  It is probably faster to write them
	in Scheme.
	
	Extend CHAR-UPCASE and CHAR-DOWNCASE to know about ISO-8859-1 letters.

	* runtime/chrsyn.scm[1.4]:
	Add ISO-8859-1 syntax to standard table.

	* runtime/mime-codec.scm[14.11]:
	Update copyright statement.

2001-09-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/process.scm[1.60]:
	Add prompt history for M-x shell-command.

	* edwin/edwin.pkg[1.274]:
	Add missing variable exports.

2001-09-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-summary.scm[1.47]:
	Put up message while generating summary buffer.  Use fixnum arithmetic
	here to speed things up slightly.

	* imail/imail-summary.scm[1.46]:
	To each message shown in a summary buffer, attach a mark pointing at
	the line on which the message is shown.  Use this in the code that
	maps from messages to marks, changing it from (slow) linear time in
	the number of messages to constant time.

	* imail/imail-summary.scm[1.45]:
	Fix problem with IMAIL-SUMMARY-MATCH-LINE: messages with malformed
	dates were not being matched.

2001-09-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.271]:
	M-x imail-sort-by-subject should do a case-insensitive sort.

	* imail/imail-top.scm[1.270]:
	Add key binding for M-x imail-sort-by-arrival.

	* imail/imail-top.scm[1.269], imail/todo.txt[1.132]:
	Implement folder-sorting commands.

	* imail/imail-core.scm[1.146], imail/imail-summary.scm[1.44]:
	Change names: new functionality is not a permutation but an order.

	* imail/imail-core.scm[1.145], imail/imail-file.scm[1.79],
	  imail/imail-imap.scm[1.185], imail/imail-summary.scm[1.43],
	  imail/load.scm[1.29]:
	Add mechanism to permute the message order of a folder.

2001-09-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/mime-codec.scm[14.10]:
	Work around bug in "Microsoft Outlook IMO, Build 9.0.2416
	(9.0.2910.0)" -- it sends documents of type application/octet-stream
	with embedded hard line breaks, which is illegal according to RFC
	2045, page 20:
	
		Since the canonical representation of media types other than
		text do not generally include the representation of line
		breaks as CRLF sequences, no hard line breaks (i.e. line
		breaks that are intended to be meaningful and to be displayed
		to the user) can occur in the quoted-printable encoding of
		such types.

2001-08-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/lookprm.c[1.16]:
	Fix problem with multi-line primitive documentation.

2001-08-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* cref/conpkg.scm[1.13], cref/object.scm[1.14], cref/redpkg.scm[1.18],
	  cref/triv.pkg[1.7], runtime/packag.scm[14.34]:
	More changes to .pkd files: now the information about loading and
	initialization is separated from the information about environments
	and bindings.  The load/initialization sequence as written in the .pkg
	file is preserved in the .pkd file.

	* cref/conpkg.scm[1.12], cref/object.scm[1.13], cref/redpkg.scm[1.17],
	  cref/triv.pkg[1.6], runtime/packag.scm[14.33]:
	Change .pkd file to have clearly defined exports and imports that
	directly correspond to those written by the programmer in the .pkg
	file.  This eliminates the duplicate links that were present in the
	previous design.

2001-08-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/6001.pkg[1.12], 6001/make.scm[15.32],
	  compiler/base/make.scm[4.113], cref/conpkg.scm[1.11],
	  cref/make.scm[1.23], cref/object.scm[1.12], cref/redpkg.scm[1.16],
	  cref/triv.pkg[1.5], runtime/packag.scm[14.32], win32/make.scm[1.8],
	  win32/win32.pkg[1.13]:
	Add additional information to .pkd file to support automatic evaluation
	of package-initialization expressions.  Major problems cropped up with
	package extensions, which necessitated some redesign of CREF.

2001-08-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/make.scm[15.31], compiler/base/make.scm[4.112],
	  cref/make.scm[1.22], edwin/make.scm[3.111], imail/load.scm[1.28],
	  rcs/load.scm[1.3], runtime/make.scm[14.72],
	  runtime/packag.scm[14.31], runtime/runtime.pkg[14.374],
	  sf/make.scm[4.38], sos/load.scm[1.7], win32/make.scm[1.7]:
	Rename PACKAGE/SYSTEM-LOADER to LOAD-PACKAGE-SET.  That will allow us
	to have an operation named UNLOAD-PACKAGE-SET.

	* win32/win32.sf[1.5]:
	Update for changes to package system.

2001-08-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* cref/Attic/Clean.sh[1.3]:
	No longer needed.

	* cref/cref.pkg[1.10], cref/redpkg.scm[1.15], cref/redpkg.scm[1.14],
	  cref/toplev.scm[1.15]:
	Eliminate use of ".glo" files; ".pkd" files have all the information
	needed.

	* etc/Clean.sh[1.6]:
	Update to correspond to packaging changes.

	* cref/conpkg.scm[1.10], cref/triv.pkg[1.4], cref/triv.pkg[1.3],
	  cref/triv.pkg[1.2], runtime/packag.scm[14.30]:
	Change "parent-name" field of package description to contain the names
	of every ancestor of the package.  This is necessary so that we can
	replace the use of ".glo" files with ".pkd" files.

	* compiler/machines/C/compiler.sf[1.7],
	  compiler/machines/alpha/compiler.sf[1.7],
	  compiler/machines/bobcat/compiler.sf[1.19],
	  compiler/machines/i386/compiler.sf[1.13],
	  compiler/machines/mips/compiler.sf-big[1.9],
	  compiler/machines/mips/compiler.sf-little[1.9],
	  compiler/machines/spectrum/compiler.sf[1.19],
	  compiler/machines/vax/compiler.sf[1.10]:
	Synchronize "compiler.sf" on all the back ends.

	* compiler/machines/i386/compiler.sf[1.12], edwin/edwin.sf[1.26]:
	Don't use ACCESS to reference CREF/GENERATE-TRIVIAL-CONSTRUCTOR.  It's
	now exported to the global environment.

2001-08-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/6001.sf[1.11], compiler/machines/i386/compiler.sf[1.11],
	  cref/Attic/triv.con[1.6], cref/Attic/triv.ldr[1.5],
	  cref/conpkg.scm[1.9], cref/cref.pkg[1.9], cref/cref.sf[1.13],
	  cref/make.scm[1.21], cref/object.scm[1.11], cref/toplev.scm[1.14],
	  cref/triv.pkg[1.1], edwin/edwin.sf[1.25], edwin/make.scm[3.110],
	  imail/Makefile.in[1.2], imail/clean.sh[1.3], imail/compile.scm[1.12],
	  rcs/compile.scm[1.3], runtime-check/Clean.sh[1.2],
	  runtime-check/Setup.sh[1.4], runtime/dragon4.scm[1.15],
	  runtime/list.scm[14.25], runtime/make.scm[14.71],
	  runtime/packag.scm[14.29], runtime/runtime.pkg[14.373],
	  runtime/runtime.sf[14.15], runtime/vector.scm[14.16],
	  runtime/version.scm[14.200], sf/sf.sf[4.9], sos/Makefile.in[1.2],
	  sos/compile.scm[1.4]:
	Implement completely new format for compiled package descriptions.
	Old format was code to build the packages and load files into them.
	New format is a summary description of the packages, which is
	interpreted at run time to provide the same functionality.
	
	The purpose of this change is to support uninstallation and
	replacement of packages.  The new compiled package descriptions are
	general enough for this purpose.

2001-08-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/lookup.c[9.65]:
	Add optimization to link_variables so that it does nothing if the
	variables are already linked.

2001-08-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/Stage.sh[1.2]:
	Fix bug: "${S}/*" -> "${S}"/*.

	* compiler/base/asstop.scm[1.12], compiler/base/make.scm[4.111],
	  compiler/base/toplev.scm[4.60], compiler/etc/comcmp.scm[1.7],
	  compiler/machines/bobcat/dassm1.scm[4.20],
	  compiler/machines/i386/dassm1.scm[1.10],
	  compiler/machines/mips/dassm1.scm[1.5],
	  compiler/machines/spectrum/dassm1.scm[4.20],
	  runtime/conpar.scm[14.39], runtime/infstr.scm[1.11],
	  runtime/infutl.scm[1.65], runtime/runtime.pkg[14.372]:
	Redesign compiled-code debugging information so that it is keyed.  The
	key in the .com file and the key in the .bci file must match, or the
	.bci file will be ignored.

	* runtime/chrset.scm[14.14]:
	Fix type error.

	* microcode/interp.c[9.92]:
	Make sure that value of evaluating definition is the name being
	defined.

2001-08-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* 6001/edextra.scm[1.33], compiler/etc/disload.scm[1.9],
	  swat/scheme/load.scm[1.4]:
	Replace usage of ENVIRONMENT-LINK-NAME with new LINK-VARIABLES.

	* cref/conpkg.scm[1.8], cref/make.scm[1.20], cref/redpkg.scm[1.13]:
	Replace usage of ENVIRONMENT-LINK-NAME with new LINK-VARIABLES.
	Extend package-file language to allow linking variables with different
	names.

	* cref/cref.pkg[1.8]:
	Fix packaging error.

	* runtime/global.scm[14.53], runtime/make.scm[14.70],
	  runtime/uerror.scm[14.48]:
	Replace usage of ENVIRONMENT-LINK-NAME with new LINK-VARIABLES.
	
	This change requires microcode 14.5 or later.

2001-08-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/bchdmp.c[9.89], microcode/bchgcl.c[9.53],
	  microcode/bintopsb.c[9.73], microcode/cmpint.c[1.94],
	  microcode/fasdump.c[9.65], microcode/fasload.c[9.90],
	  microcode/gccode.h[9.58], microcode/gcloop.c[9.48],
	  microcode/lookprm.c[1.15], microcode/lookup.c[9.64],
	  microcode/lookup.h[9.55], microcode/psbmap.h[9.45],
	  microcode/psbtobin.c[9.59], microcode/purify.c[9.60],
	  microcode/sdata.h[9.38], microcode/trap.h[9.48],
	  microcode/types.h[9.38]:
	Implement primitive to allow linking variables that have different
	names.  (Previously, linked variables were required to have the same
	name.)  This requires a major redesign of the cache data structures,
	and since the garbage collector knows about these structures, all of
	the garbage-collector files are affected too.  The new data structures
	have slightly different space requirements: a cache with no references
	uses one word less than previously, while a cache with references uses
	three words more than previously (independent of the number of
	references).
	
	This change requires Runtime 14.190 or later.

2001-08-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/snr.scm[1.61]:
	Fix bug: news posting hasn't worked since the MIME attachment changes
	went in some time ago.

2001-08-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/lookup.c[9.63]:
	Fix bugs in unbind_variable.

	* runtime/dbgutl.scm[14.20]:
	Fix formatting of environments.

2001-08-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/runtime.pkg[14.371], runtime/uenvir.scm[14.41],
	  runtime/urtrap.scm[14.6], runtime/version.scm[14.199]:
	Rewrite interpreter-environment abstraction to account for new
	primitive that unbinds variables.  This works with the old microcode.

2001-08-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/version.h[11.181]:
	Update version to reflect changes to variable reference.

	* microcode/lookup.c[9.62]:
	In-line code flush_cache, which had one reference.

	* microcode/lookprm.c[1.14], microcode/lookup.c[9.61],
	  microcode/lookup.h[9.54], microcode/sdata.h[9.37]:
	Implement unlink_variable and associated primitive, which is not yet
	tested.
	
	Also, more cleanups to "lookup.c", particularly in code that accesses
	cache reference lists.  Increased abstraction in this area is being
	prompted by potential design changes to allow linking variables with
	different names.

	* microcode/trap.h[9.47]:
	Eliminate unused TRAP_RECACHE.  Add updated comment explaining where
	TRAP_UNBOUND is allowed to occur.

2001-08-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/sdata.h[9.36]:
	Don't access a cache value as a cell.

	* microcode/lookup.c[9.60]:
	Simplify logic in a few places.

2001-07-31  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/boot.c[9.105], microcode/cmpint.c[1.93],
	  microcode/debug.c[9.53], microcode/extern.h[9.60],
	  microcode/fasload.c[9.89], microcode/hooks.c[9.60],
	  microcode/interp.c[9.91], microcode/lookprm.c[1.13],
	  microcode/lookup.c[9.59], microcode/lookup.h[9.53],
	  microcode/object.h[9.51], microcode/os2.h[1.8],
	  microcode/scode.h[9.27], microcode/sdata.h[9.35],
	  microcode/trap.h[9.46], microcode/utils.c[9.79]:
	Completely rewrite the variable-reference code.  New design is
	considerably simpler, having discarded all the legacy code from the
	Butterfly.  Furthermore, two hacks to speed up the interpreter,
	caching of variable locations and in-line variable reference, have
	been removed.  This makes the interpreter slower, but has no effect on
	compiled code, and has several important benefits.  One benefit is
	that we can now implement undefine.
	
	New design allows ENVIRONMENT-LINK-NAME to link to a variable that is
	already bound (previous signalled an error in this case).
	
	Eliminate "in-line" variable references in the interpreter.  All
	reference machinery is now defined in "lookup.c".
	
	Define THE_GLOBAL_ENV and THE_NULL_ENV, and predicates to detect
	them.  Eliminate GO_TO_GLOBAL and END_OF_CHAIN definitions.  Latter
	was a name conflict under OS/2.  Change definition of ENVIRONMENT_P
	so that it is false for THE_NULL_ENV.
	
	Define lots of macros to provide abstract access to the data
	structures used for variable references.  Change terminology, so
	that instead of "trap extension" we now use "cache", and so on for
	the substructures of the cache.
	
	Add "guards" to allow .h files to be loaded more than once.
	
	Remove variable-access procedures from "extern.h"; new procedures
	are now defined in "lookup.h".
	
	Eliminate all unused trap kinds.

2001-07-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/makegen/makegen.scm[1.3]:
	When generating dependencies, pass -DMIT_SCHEME to compiler.

2001-07-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/comred.scm[1.122], edwin/editor.scm[1.252],
	  edwin/kmacro.scm[1.43], edwin/make.scm[3.109]:
	Fix problem: errors during keyboard-macro execution were leaving the
	editor in the command reader that was spawned to execute the keyboard
	macro, rather than returning to the reader that was in control when
	the keyboard-macro execution was initiated.
	
	Some of the keyboard-macro state was being mismanaged by unnecessary
	calls to KEYBOARD-MACRO-DISABLE.  This was exacerbated because
	KEYBOARD-MACRO-DISABLE was setting *KEYBOARD-MACRO-EXECUTING?* to #F
	when it should have been left alone.

	* imail/imail-imap.scm[1.184]:
	Change UPDATE-IMAP-FOLDER-LENGTH! back to its original design.
	The bug I was seeing had nothing to do with this code.

	* imail/imail-imap.scm[1.183]:
	Change UPDATE-IMAP-FOLDER-LENGTH! so that it always signals a
	modification event.

2001-07-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/version.scm[14.198], runtime/version.scm[14.197]:
	Update for post-release changes.

	* sf/make.scm[4.37], sf/pardec.scm[4.12]:
	Fix bug: when multiple USUAL-INTEGRATIONS declarations are given, the
	excluded names should be the union of all of the declarations, but
	instead were the intersection.  This situation arises when using
	COMPILE-FILE, which forces an additional USUAL-INTEGRATIONS
	declarations on each file.

	* microcode/os2sock.c[1.18]:
	Fix typo.  Supply definition for (surprisingly) missing INADDR_LOOPBACK.

	* microcode/ntutl/makefile[1.28]:
	A few more tweaks to get this working right.

	* microcode/ntsock.c[1.11], microcode/os2fs.c[1.14]:
	Fix typo.

	* microcode/ntutl/makefile[1.27], microcode/ntutl/makefile.wcc[1.17]:
	Disable crypto and gdbm support by default, since it relies on
	libraries not commonly available.

2001-07-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/ntutl/makefile[1.26]:
	Add code for using Microsoft's assembler.

	* microcode/ntutl/makefile[1.25]:
	Update to have hand-written dependencies as does the watcom makefile.

	* runtime/version.scm[14.196]:
	Change version for release 7.5.17.

2001-07-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/sfile.scm[14.30]:
	Fix name of WIN32-NAMED-PIPE, which had underscore instead of hyphen.
	Also add alias FILE-SOFT-LINK?.

2001-07-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* xml/compile.scm[1.4], xml/ed-ffi.scm[1.3], xml/test-parser.scm[1.5],
	  xml/xml-output.scm[1.1], xml/xml.pkg[1.7], xml/xml.pkg[1.6]:
	Add code to write XML structures.

	* xml/xml-parser.scm[1.10]:
	Fix a number of bugs that were revealed during testing of the output
	code.

	* xml/xml-parser.scm[1.9]:
	Tweak format of !ELEMENT content type to be a little easier to
	disassemble.

	* xml/xml-struct.scm[1.5], xml/xml.pkg[1.5]:
	Delete now-unused entity-reference structures.

	* microcode/uxsig.c[1.36]:
	Must unblock all signals at start.  A recent example that has caused
	problems is that GNOME can sometimes cause Scheme to be started with
	SIGCHLD blocked.

2001-07-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* xml/compile.scm[1.3]:
	Use new parser/matcher macro environments.

	* xml/xml-struct.scm[1.4], xml/xml.pkg[1.4]:
	Export type descriptors for each of the XML data structure types.

	* star-parser/load.scm[1.7], star-parser/matcher.scm[1.14],
	  star-parser/parser.pkg[1.9], star-parser/parser.scm[1.17],
	  star-parser/shared.scm[1.9]:
	Add environment mechanism so that parser/matcher macros from one
	program don't interfere with those from another.

2001-07-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/schmod.scm[1.52]:
	Duh; DEFINE-STRUCTURE has one distinguished expression, not two.

	* edwin/schmod.scm[1.51]:
	Add indentation rule for DEFINE-STRUCTURE.  I think maybe the standard
	indentation for definitions isn't right.

	* xml/xml-parser.scm[1.8]:
	A bunch of simple edits resulting from reading over the code.

	* xml/test-parser.scm[1.4]:
	Rename RUN-VALIDITY-TESTS to RUN-XML-TESTS, and change it to run all
	the tests in the xmltest directory.

	* star-parser/Attic/unicode.scm[1.3]:
	Fix some bugs.

	* xml/compile.scm[1.2], xml/ed-ffi.scm[1.2], xml/parser-macro.scm[1.4],
	  xml/xml-chars.scm[1.1], xml/xml-parser.scm[1.7], xml/xml.pkg[1.3]:
	Update to use new Unicode support in the parser language.  This should
	improve the conformance.

	* star-parser/Attic/unicode.scm[1.2], star-parser/parser.pkg[1.8]:
	Flesh out unicode support.  Fix bugs.

2001-07-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/Attic/unicode.scm[1.1], star-parser/compile.scm[1.2],
	  star-parser/ed-ffi.scm[1.3], star-parser/load.scm[1.6],
	  star-parser/matcher.scm[1.13], star-parser/parser.pkg[1.7]:
	Add unicode support.

	* star-parser/Attic/buffer.scm[1.8], star-parser/load.scm[1.5],
	  star-parser/parser.pkg[1.6]:
	New procedure PARSER-BUFFER-REF.

2001-07-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* xml/xml-parser.scm[1.6]:
	Reorganize for presentation.

	* xml/parser-macro.scm[1.3], xml/test-parser.scm[1.3],
	  xml/xml-parser.scm[1.5]:
	Another round of changes.  Now passes all of the valid tests, and most
	of the not-well-formed tests.

	* xml/parser-macro.scm[1.2], xml/test-parser.scm[1.2],
	  xml/xml-parser.scm[1.4], xml/xml-struct.scm[1.3], xml/xml.pkg[1.2]:
	Extensive reworking to get entity references done more or less right.
	There remains a problem with recursive entity expansion -- there is a
	mismatch between the tests and my reading of the specification.

	* star-parser/matcher.scm[1.12]:
	Add COMPLETE keyword.

2001-07-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/parser.scm[1.16], star-parser/test-parser.scm[1.3]:
	Rename ELEMENT-TRANSFORM to MAP.

2001-07-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.182]:
	Change DISCONNECT-FOLDER to close the connection immediately, rather
	than deferring.  This is what the end-user expects to see happen.

2001-07-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* xml/test-parser.scm[1.1]:
	Initial revision.

	* edwin/fileio.scm[1.155]:
	When file is written for the first time, mark the buffer as having
	been backed up.

	* xml/compile.scm[1.1], xml/ed-ffi.scm[1.1], xml/load.scm[1.1],
	  xml/parser-macro.scm[1.1], xml/xml-parser.scm[1.3],
	  xml/xml-struct.scm[1.2], xml/xml.pkg[1.1]:
	Package the code.  Move parser macros to their own file so that they
	can be loaded during compilation.
	
	Restructure the top-level parser to allow passing the DTD down to the
	element parser for entity expansion.
	
	Implement attribute-value normalization.
	
	Add restrictions required for rejection of non-wf documents: no "--"
	in comments; no duplicate attribute names.
	
	Change names of DTD structures to reflect their keywords.
	
	Fix various minor bugs, discovered either by the test suite or by the
	compiler.

2001-07-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* xml/xml-parser.scm[1.2], xml/xml-struct.scm[1.1]:
	Move data structures to separate file.

	* xml/xml-parser.scm[1.1]:
	Initial revision.

	* star-parser/Attic/buffer.scm[1.7]:
	Fix typo.

2001-07-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/matcher.scm[1.11], star-parser/parser.scm[1.15]:
	Don't lift Scheme expressions up to the top of the procedure; evaluate
	them in place.  Eliminate DEFAULT in favor of new VALUES.

	* runtime/pp.scm[14.42]:
	Fix bug: pretty printer was getting SIGSEGV when printing very deeply
	nested named let.

	* star-parser/load.scm[1.4], star-parser/matcher.scm[1.10],
	  star-parser/parser.pkg[1.5], star-parser/parser.scm[1.14]:
	Completely reorganize the language preprocessors, so that they are no
	longer monolithic procedures.  Also lay the code out differently so
	that it is broken into two major segments: the preprocessor and the
	code generator.

	* star-parser/shared.scm[1.8]:
	Fix bug: unfinished change to BACKTRACK-TO.

	* star-parser/matcher.scm[1.9], star-parser/parser.scm[1.13],
	  star-parser/shared.scm[1.7]:
	Replace WITH-CURRENT-POINTER and NO-POINTERS with new procedure
	CALL-WITH-UNKNOWN-POINTER.  Change all references from "pointers" to
	"pointer", since it's better to think of this as a single pointer.
	(The delayed backtracking feature is an implementation detail, so it
	shouldn't be reflected in the name.)  Rename NEW-BACKTRACK-POINTER to
	BACKTRACK-TO.  Rename CURRENT-POINTER to POINTER-REFERENCE.

	* star-parser/matcher.scm[1.8], star-parser/parser.scm[1.12],
	  star-parser/shared.scm[1.6]:
	Rework handling of the pointers.  There were some subtle bugs in the
	implementation that could have caused incorrect code generation.  This
	code looks good but is still a bit confusing; I may not have it right
	yet.  This code isn't yet tested.

	* microcode/x11base.c[1.77]:
	Implement new primitive X-SET-DEFAULT-FONT.

	* edwin/edwin.pkg[1.273], edwin/xcom.scm[1.18]:
	Add new command M-x set-default-font.

	* microcode/configure.in[11.13]:
	Restructure crypto, gdbm, and curses tests to depend on existence of
	appropriate header files as well as the library files.  The presence
	of the library file is no guarantee that we have the headers.

2001-06-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/load.scm[1.3], star-parser/matcher.scm[1.7],
	  star-parser/parser.scm[1.11]:
	Add ability to specify macros that are symbols rather than forms.
	These expand to fixed parser sequences.

	* star-parser/load.scm[1.2], star-parser/matcher.scm[1.6],
	  star-parser/parser.pkg[1.4], star-parser/parser.scm[1.10],
	  star-parser/shared.scm[1.5]:
	Add WITH-POINTER to both parser and matcher languages.  Also implement
	macros for both languages.

	* star-parser/Attic/buffer.scm[1.6]:
	Make sure that line number is properly updated.

2001-06-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/Attic/buffer.scm[1.5], star-parser/Attic/buffer.scm[1.4],
	  star-parser/Attic/buffer.scm[1.3], star-parser/Attic/buffer.scm[1.2],
	  star-parser/ed-ffi.scm[1.2], star-parser/parser.pkg[1.3]:
	* Track the line number of the current buffer position, so that error
	  messages can refer to the line.  Change representation of buffer
	  pointers to include the line number.  Add operation to generate a
	  string that shows the line number and character number of either a
	  given pointer or the current position.
	
	* Eliminate DECREMENT-PARSER-BUFFER-POINTER, which was unused and
	  makes implementing the line number more difficult.
	
	* Add -NO-ADVANCE versions of procedures that match single characters.
	
	* Change terminology: the index of the current character in the buffer
	  is called a "position".  The word "pointer" is reserved to refer to
	  pointer objects that are handed to the users, which themselves refer
	  to positions.

2001-06-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/matcher.scm[1.5], star-parser/parser.scm[1.9]:
	Eliminate compiler warnings.

	* star-parser/parser.scm[1.8]:
	Fix code-generation bug in MATCH element.

2001-06-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* star-parser/parser.scm[1.7]:
	Fix a couple of code-generation bugs.

	* star-parser/shared.scm[1.4]:
	Add some more optimizers.

	* star-parser/parser.scm[1.6], star-parser/parser.scm[1.5]:
	Fix two compiler warnings.

	* star-parser/matcher.scm[1.4], star-parser/matcher.scm[1.3],
	  star-parser/parser.scm[1.4], star-parser/parser.scm[1.3],
	  star-parser/shared.scm[1.3]:
	Lots of hair to allow explicit character-set specifications to be
	compiled at load time rather than at run time.

	* star-parser/matcher.scm[1.2], star-parser/parser.scm[1.2]:
	Change name of language-shifting expression to SEXP.

	* star-parser/test-parser.scm[1.2]:
	Must attempt to parse number before attempting identifier.  Otherwise,
	the number's sign might be parsed as an identifier.

	* star-parser/shared.scm[1.2]:
	Fix problem with optimizer: needed to add notion of default rules that
	are used when a more specific pattern isn't available.  Also,
	generalize OPTIMIZE-GROUP-EXPRESSION so that it can be used by
	VECTOR-APPEND.

	* star-parser/parser.pkg[1.2]:
	Add missing bindings.

	* star-parser/Attic/buffer.scm[1.1], star-parser/Attic/synchk.scm[1.1],
	  star-parser/compile.scm[1.1], star-parser/ed-ffi.scm[1.1],
	  star-parser/load.scm[1.1], star-parser/matcher.scm[1.1],
	  star-parser/parser.pkg[1.1], star-parser/parser.scm[1.1],
	  star-parser/shared.scm[1.1], star-parser/test-parser.scm[1.1]:
	Initial revision.

2001-06-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/schmod.scm[1.50]:
	Define SCHEME-INDENT-METHOD to simplify definition of indentation.

2001-06-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.181]:
	Don't attempt to set arbitrary flags unless the server says it's OK.

2001-06-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/rgxcmp.scm[1.115], runtime/runtime.pkg[14.370]:
	Fix bug: regular-expression compiler is breaking the character-set
	abstraction.

	* runtime/chrset.scm[14.13], runtime/runtime.pkg[14.369],
	  runtime/runtime.sf[14.14], runtime/string.scm[14.43],
	  runtime/symbol.scm[1.5], runtime/unpars.scm[14.48]:
	Change representation of character sets so that they do not satisfy
	STRING?.  Unfortunately, this requires a complete recompilation of the
	system, since the primitives SUBSTRING-FIND-NEXT-CHAR-IN-SET and
	SUBSTRING-FIND-PREVIOUS-CHAR-IN-SET were being hard-coded by the
	syntaxer.

	* sf/gconst.scm[4.24]:
	Don't integrate the primitives SUBSTRING-FIND-NEXT-CHAR-IN-SET and
	SUBSTRING-FIND-PREVIOUS-CHAR-IN-SET.

2001-06-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.268], imail/imail-top.scm[1.267],
	  imail/todo.txt[1.131]:
	Start the folder-probe thread only when the folder is ONLINE, and stop
	the thread when the folder is OFFLINE.  Make sure that the buffer is
	disassociated from it's folder when the buffer is killed.

	* imail/imail-core.scm[1.144], imail/imail-file.scm[1.78],
	  imail/imail-imap.scm[1.180], imail/imail-rmail.scm[1.68],
	  imail/imail-umail.scm[1.49]:
	Change OPEN-RESOURCE and CLOSE-RESOURCE so that all of their behavior
	is pushed down into the type-dependent modules.  (Previously, they had
	some type-independent code.)  This, plus one explicit call, now means
	that the STATUS modification event is now consistently signalled
	whenever the connection status changes.

2001-06-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/runtime.pkg[14.368]:
	Forgot to export HANDLE-SUBPROCESS-STATUS-CHANGE to the socket code.

	* runtime/io.scm[14.64]:
	INPUT-BUFFER/READ-SUBSTRING must use generic arithmetic for indexes
	into the substring, because it might be an xstring that is larger than
	the fixnum range.

	* imail/imail-util.scm[1.39]:
	READ-SUBSTRING! can return less than the requested number of bytes.
	Deal with it.

2001-06-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/filcom.scm[1.219]:
	LOAD-FIND-FILE-INITIALIZATION must be re-run when the buffer's
	pathname or major mode is changed.

	* edwin/vc.scm[1.79], edwin/vc.scm[1.78]:
	VC's state is wiped out when the workfile's buffer has it's mode
	changed.  Use new event EVENT:SET-BUFFER-MAJOR-MODE to reset it at
	that time.

	* edwin/buffer.scm[1.182]:
	Add new event EVENT:SET-BUFFER-MAJOR-MODE.

2001-06-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/socket.scm[1.17]:
	Fix bug: TCP-SERVER-CONNECTION-ACCEPT was blocking on the server
	socket, rather than registering it for management by select.

2001-06-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-browser.scm[1.8]:
	When reverting buffer, preserve selected resource, marked resources,
	and expanded containers.  When initializing buffer, select first
	resource line.

	* imail/imail-top.scm[1.266], imail/todo.txt[1.130]:
	Select first unseen message when invoking M-x imail on a folder that
	is already online.

	* imail/imail.pkg[1.87]:
	Rename commands to match current Dired usage.

	* imail/todo.txt[1.129]:
	More new notes.

	* imail/imail-browser.scm[1.7]:
	Implement M-x imail-browser-do-copy.  Consolidate code used for copy
	and rename.  Write documentation strings for all commands and for the
	major mode.

	* imail/imail-top.scm[1.265], imail/imail-top.scm[1.264]:
	Simplify usage of COPY-FOLDER.

	* imail/imail-core.scm[1.143]:
	Implement WITH-OPEN-RESOURCE.

	* edwin/dired.scm[1.189]:
	Fix minor wording problem in documentation string.

2001-06-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-browser.scm[1.6], imail/imail-top.scm[1.263],
	  imail/imail.pkg[1.86], imail/todo.txt[1.128]:
	Change commands used to enter browser.  Now the primary command is M-x
	imail-browser-view-container (bound to ^ in all IMAIL buffers), which
	browses the container of the resource being viewed in the current
	buffer.  This command will prompt for a container URL if given a
	prefix argument.

	* imail/imail-imap.scm[1.179]:
	Fix bug: the container URL "imap://localhost/" had an associated
	"folder" URL with the same string representation.  This confused the
	URL interning mechanism, which uses the string rep as the key.
	Consequently only one of the URLs existed.  Now, the "folder" is
	represented by "imap://localhost".

	* edwin/dired.scm[1.188]:
	When processing marked files in a Dired buffer, update screens after
	each file is processed so that the mark is appropriately removed.

	* imail/imail-core.scm[1.142], imail/imail-file.scm[1.77],
	  imail/imail-imap.scm[1.178]:
	Change CLOSE-RESOURCE so that second argument is required rather than
	optional.

	* imail/imail-browser.scm[1.5], imail/imail-imap.scm[1.177],
	  imail/todo.txt[1.127]:
	Associate a connection with an open IMAP container.  Add code to
	browser to guarantee that the resource is closed at appropriate times.

	* imail/todo.txt[1.126]:
	*** empty log message ***

	* imail/imail-top.scm[1.262]:
	Change M-x imail-quit to use the new NO-DEFER? argument to
	CLOSE-RESOURCE.

	* imail/imail-core.scm[1.141], imail/imail-file.scm[1.76],
	  imail/imail-imap.scm[1.176]:
	Add optional argument NO-DEFER? to CLOSE-RESOURCE.  If this argument
	is true, it tells the operation that the resource must be closed
	immediately.  Otherwise, the operation may defer the closure.

2001-06-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.125]:
	Add a few notes.

	* edwin/dirunx.scm[1.13]:
	Add commented-out stubs for commands to do file linking.

	* edwin/xterm.scm[1.67]:
	Add logic to GET-X-DISPLAY to test for existence of X primitives, and
	to make sure that a display variable exists.  This is necessary so
	that Edwin will work on a system that doesn't have X support.

	* edwin/filcom.scm[1.218]:
	PROMPT-FOR-DIRECTORY should not always perform PATHNAME-AS-DIRECTORY
	on its result; if the REQUIRE-MATCH? option isn't given, the result
	might not be a directory.  For example, Dired uses this prompt, and an
	input with a wildcard file part is permissible.

	* edwin/dired.scm[1.187]:
	Update doc string for dired-do-copy to match Emacs.

	* edwin/dired.scm[1.186], edwin/edwin.pkg[1.272]:
	Eliminate variable dired-copy-preserve-time which wasn't doing anything.

	* runtime/sfile.scm[14.29], runtime/sfile.scm[14.28],
	  runtime/sfile.scm[14.27]:
	New procedures HARD-LINK-FILE and SOFT-LINK-FILE.

	* imail/imail-browser.scm[1.4], imail/imail.pkg[1.85]:
	Implement marked files for D and R commands (stub for C command needs
	to be written).  Change name of x command to M-x
	imail-browser-do-flagged-delete to correspond to new name given
	corresponding Emacs dired command.

	* imail/imail-top.scm[1.261]:
	In M-x imail-rename-folder and M-x imail-copy-folder, allow user to
	specify a container for the target.

	* imail/imail-top.scm[1.260]:
	Add new procedure PROMPT-FOR-URL.

	* runtime/socket.scm[1.16]:
	Add optional HOST argument to OPEN-TCP-SERVER-SOCKET, and new
	procedures HOST-ADDRESS-ANY and HOST-ADDRESS-LOOPBACK.  This allows
	the user to specify the network interface(s) being listened to.

	* microcode/ntsock.c[1.10], microcode/os2sock.c[1.17],
	  microcode/uxsock.c[1.28]:
	Provide missing htonl calls.

	* microcode/pruxsock.c[1.20]:
	Oops, that should have been CREATE-TCP-SERVER-SOCKET.

	* microcode/ntsock.c[1.9], microcode/os2sock.c[1.16],
	  microcode/pruxsock.c[1.19], microcode/uxsock.c[1.27],
	  microcode/uxsock.h[1.10]:
	Implement new primitives to allow finer control over how TCP server
	sockets are configured:
	
	    HOST-ADDRESS-ANY
	    HOST-ADDRESS-LOOPBACK
	    CREATE_TCP_SERVER_SOCKET
	    BIND-TCP-SERVER-SOCKET
	    LISTEN-TCP-SERVER-SOCKET

2001-06-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.175], imail/todo.txt[1.124]:
	Defer closing of connection when it is the last connection open to a
	particular server.  This prevents a pattern of opening and closing
	that occurs when IMAIL starts up (due to probes performed prior to
	opening the folder).  It also allows the user to do completion in the
	folder space without occurring the same penalty.  The downside is that
	the connection remains open for about a minute after the user "closes"
	it, which will be remedied in a future revision.

2001-05-31  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.174]:
	First draft of a mechanism to defer closing of connections.  This
	suffers from a fault: the background probe-folder thread is re-opening
	the connection while it is in the deferred state.

	* edwin/editor.scm[1.251], edwin/notify.scm[1.20],
	  imail/imail-top.scm[1.259], imail/imail-top.scm[1.258]:
	Implement START-STANDARD-POLLING-THREAD and
	STOP-STANDARD-POLLING-THREAD to capture standard method of using
	background thread to poll for output or events.

	* edwin/editor.scm[1.250]:
	Add interrupt locking to REGISTER-INFERIOR-THREAD! and
	DEREGISTER-INFERIOR-THREAD!.  Change DEREGISTER-INFERIOR-THREAD! to
	delete the entry from the list of inferior threads.

2001-05-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.173]:
	Change how connections are allocated; when looking for a connection
	for a folder, we'll now take over an existing compatible connection if
	it's not being used by another folder.  This will be useful after the
	next change, which will cause connections to stay open a short while
	after their last reference is dropped; when that happens, there will
	be open connections lying around that can usefully be adopted.

2001-05-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.172], imail/imail-imap.scm[1.171],
	  imail/todo.txt[1.123]:
	Eliminate IMAP-FOLDER-N-MESSAGES in favor of FOLDER-LENGTH.

	* imail/imail-browser.scm[1.3], imail/imail-core.scm[1.140],
	  imail/imail-file.scm[1.75], imail/imail-imap.scm[1.170]:
	Rename URL-IS-CONTAINER? to URL-CORRESPONDING-CONTAINER.  Eliminate
	requirement that the result be #F if the resource doesn't exist.

	* imail/imail-imap.scm[1.169]:
	Cache information returned by the IMAP LIST command.  This should help
	to reduce traffic on the wire.

	* imail/imail.pkg[1.84]:
	Don't use my private "$bscm" environment variable in public code.

	* cref/cref.sf[1.12], cref/cref.sf[1.11]:
	Don't use LOAD-OPTION to load cref; it probably doesn't exist on the
	host system (outside of MIT), and this will cause an error if the user
	has MITSCHEME_INF_DIRECTORY set.

	* imail/imail-top.scm[1.257]:
	Change M-x imail so that it only runs M-x imail-get-new-mail if the
	folder status is OFFLINE.

	* imail/imail-imap.scm[1.168]:
	Restructure IMAP URLs so that each container URL has a corresponding
	folder URL.  The container URL inherits the components of the folder
	URL rather than keeping its own copies.  This sharing will be
	important when we add caching of the IMAP server's LIST info.

2001-05-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.167]:
	In IMAP-MAILBOX-DELIMITER, use the probed root as the table key;
	previous strategy make no sense.

	* imail/imail-imap.scm[1.166]:
	Fix bug: IMAP-MAILBOX-DELIMITER was calling the LIST command on a
	mailbox with a trailing slash; now the slash is omitted.

2001-05-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.165]:
	Cache result of URL-IS-CONTAINER?, to prevent going back to network
	each time it's needed.  This might not actually work, since the
	definition of URL-IS-CONTAINER? specifies that the corresponding
	mailbox must exist.

	* imail/todo.txt[1.122]:
	Delete entries for things that are now implemented.

	* imail/todo.txt[1.121]:
	Note problem that connection to IMAP server is being opened and closed
	too much.

2001-05-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.256]:
	Fix error message of SELECTED-URL so that it makes more sense to the
	end user.

	* imail/imail-browser.scm[1.2]:
	Eliminate compiler warning.

	* imail/compile.scm[1.11], imail/ed-ffi.scm[1.14],
	  imail/imail-browser.scm[1.1], imail/imail.pkg[1.83],
	  imail/print.sh[1.9]:
	Add first working draft of folder browser.

	* imail/imail-top.scm[1.255]:
	Change IMAIL-DEFAULT-CONTAINER to use selected URL if any.  This sets
	default correctly in the folder browser when point is inside an
	expanded subfolder.

	* imail/imail-top.scm[1.254]:
	Implement SELECTED-CONTAINER-URL.

	* imail/imail-core.scm[1.139]:
	Change external representation of URL to use content name rather than
	presentation name.

	* imail/imail-top.scm[1.253]:
	Fix indentation.

2001-05-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.138], imail/imail-file.scm[1.74],
	  imail/imail-imap.scm[1.164], imail/imail-top.scm[1.252]:
	Cache CONTAINER-URL of every URL when it is created, so that the
	heirarchy can be quickly traversed.
	
	Rename URL-IS-SELECTABLE? as FOLDER-URL-IS-SELECTABLE?.
	
	Implement new operation URL-IS-CONTAINER?  which returns the
	equivalent container URL of a URL (which may be a folder URL).

	* imail/imail-core.scm[1.137], imail/imail-file.scm[1.73],
	  imail/imail-imap.scm[1.163], imail/imail-top.scm[1.251]:
	Change noun "child", used to refer to something in a container, to
	"content".

2001-05-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/buffer.scm[1.181]:
	Generalize WITH-READ-ONLY-DEFEATED to accept anything that ->BUFFER
	can resolve to a buffer.

	* imail/imail-imap.scm[1.162]:
	Don't echo server's mailbox name to the user.

	* edwin/dired.scm[1.185]:
	Include full key bindings in mode help.

	* imail/imail-imap.scm[1.161]:
	Fix CONTAINER-URL-CONTENTS to return container URLs when appropriate.

	* edwin/struct.scm[1.95]:
	Fix bug in previous change: was using procedures that returned marks
	when I expected indexes.

	* imail/imail-core.scm[1.136]:
	Add some more resource->URL reflectors.

	* imail/imail-core.scm[1.135], imail/imail-file.scm[1.72],
	  imail/imail-imap.scm[1.160], imail/imail-top.scm[1.250]:
	Simplify meaning of CONTAINER-URL; it no longer does anything special
	for IMAP URLs.  Define new operation CONTAINER-URL-FOR-PROMPT that has
	the behavior that CONTAINER-URL used to.
	
	Implement new operation URL-CHILD-NAME which is now the complement to
	CONTAINER-URL.  These operations now return compatible halves of the
	URL, which may be recombined using MAKE-CHILD-URL to obtain the
	original URL.
	
	Change implementation of URL-PRESENTATION-NAME; it now just calls
	URL-CHILD-NAME, stripping a slash off the end if present.
	
	Clarify definition of URL-BASE-NAME.
	
	Revert CONTAINER-CONTENTS back to CONTAINER-URL-CONTENTS.  Maybe
	tomorrow I'll change my mind again.

	* imail/imail-top.scm[1.249]:
	Regularize the names of the procedures that manage the selected
	container and selected URL.  Move these and SELECT-FOLDER to the same
	page.

	* imail/imail-core.scm[1.134]:
	Change GET-MEMOIZED-RESOURCE to accept an optional argument specifying
	that it is an error if there is no associated resource.

	* imail/imail-core.scm[1.133], imail/imail-core.scm[1.132],
	  imail/imail-core.scm[1.131], imail/imail-file.scm[1.71],
	  imail/imail-imap.scm[1.159], imail/imail-rmail.scm[1.67],
	  imail/imail-top.scm[1.248], imail/imail-umail.scm[1.48]:
	Rename the following server operations, then add methods to them to
	support containers as well as folders:
	
	    create-folder	=>	create-resource
	    delete-folder	=>	delete-resource
	    rename-folder	=>	rename-resource

	* imail/imail-core.scm[1.130]:
	Add a handful of methods to allow containers to be used in place of
	container URLs in operations where it seems useful.

	* imail/imail-top.scm[1.247]:
	Don't use history value as default for source of M-x
	imail-rename-folder and M-x imail-copy-folder.

	* imail/imail-top.scm[1.246]:
	Fix a few minor bugs from the recent changes.

2001-05-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.129], imail/imail-file.scm[1.70],
	  imail/imail-imap.scm[1.158], imail/imail-rmail.scm[1.66],
	  imail/imail-top.scm[1.245], imail/imail-umail.scm[1.47]:
	Generalize folder operations:
	
		open-folder	=>	open-resource
		close-folder	=>	close-resource
		save-folder	=>	save-resource
	
	Add methods to each of these renamed operations so that they can
	handle containers.

	* imail/imail-core.scm[1.128], imail/imail-file.scm[1.69],
	  imail/imail-imap.scm[1.157]:
	Eliminate CONTAINER-URL-CONTENTS in favor of CONTAINER-CONTENTS.

	* imail/imail-core.scm[1.127], imail/imail-file.scm[1.68],
	  imail/imail-imap.scm[1.156], imail/imail-top.scm[1.244]:
	Rename URL-CONTAINER to CONTAINER-URL to better reflect its meaning.

	* imail/imail-core.scm[1.126]:
	Fix bug in previous change: the object being modified is the
	container, not the URL for the container.

	* imail/imail-core.scm[1.125], imail/imail-file.scm[1.67],
	  imail/imail-imap.scm[1.155], imail/imail-rmail.scm[1.65],
	  imail/imail-summary.scm[1.42], imail/imail-top.scm[1.243],
	  imail/imail-umail.scm[1.46]:
	Generalize implementations of properties and modification events so
	that they can be mixed in to arbitrary classes.  Simplify property
	implementation to use an alist.  This saves 4 words of memory, which
	is important for message objects.
	
	Create generalized resources, which are the referents of URLs.  Use
	these as the base for folders, and create a new container type.
	
	Change CREATE-FOLDER, DELETE-FOLDER, RENAME-FOLDER, and APPEND-MESSAGE
	to signal appropriate events to the container of the folders being
	manipulated.  This will allow folder browsers to automatically update
	themselves as their contents are changed.
	
	Add hooks to folder and container prompts, which allow the folder
	browser to use some of the standard server commands.  The browser
	can supply the appropriate URL string without prompting.
	
	Don't let M-x imail-copy-folder copy from a folder to itself.

	* imail/todo.txt[1.120]:
	Note that RENAME-FOLDER must change the URL the target folder refers
	to.

2001-05-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/struct.scm[1.94]:
	Implement WITHOUT-TEXT-CLIPPED.

	* runtime/make.scm[14.69], runtime/runtime.pkg[14.367]:
	Duh.  Can't delete DOS pathname support; that is used by Win32 and
	OS/2.

	* microcode/ntio.c[1.24]:
	Fix longstanding bug: must send WM_PAINT after SCREEN_WRITE so that
	messages appear on screen even when no input is being read.

	* microcode/ntfs.c[1.28]:
	Fix thinko in previous change.

2001-05-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.242]:
	Fix bug: missing alternative in conditional was causing prompt to have
	random default value.

2001-05-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.154]:
	Change IMAP-URL-SERVER-MAILBOX to accept container URLs and strip the
	trailing delimiter off of them.

	* imail/imail.pkg[1.82]:
	Add package for folder browser.

	* imail/imail-summary.scm[1.41]:
	Fix typo in previous change.

	* imail/imail-top.scm[1.241]:
	Change M-x imail-delete-message to accept a prefix argument, which
	means to repeat just like imail-delete-forward.

	* imail/imail-summary.scm[1.40]:
	In REBUILD-IMAIL-SUMMARY-BUFFER, SELECTED-FOLDER can return #F, but
	the code wasn't allowing for that possibility.

	* imail/imail-top.scm[1.240]:
	If ERROR? argument to SELECTED-FOLDER and SELECTED-MESSAGE is false,
	don't signal an error even if the associated property isn't bound.
	The old behavior has caused too many problems in weird places, and has
	no real benefits.

	* edwin/curren.scm[1.144]:
	Implement RUN-BUFFER-HOOKS to capture code that runs the hooks list.
	Fix potential problem by copying the hooks list.

2001-05-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.124]:
	Eliminate legacy file URL protocol names.  These can only cause
	confusion when writing to output files that don't already exist.

	* imail/imail-core.scm[1.123], imail/imail-file.scm[1.66],
	  imail/imail-imap.scm[1.153], imail/imail-rmail.scm[1.64],
	  imail/imail-top.scm[1.239], imail/imail-umail.scm[1.45]:
	Eliminate MAKE-PEER-URL in favor of MAKE-CHILD-URL.

	* imail/imail-imap.scm[1.152]:
	Split the IMAP URL type into two types: one for IMAP folders, and the
	other for IMAP containers.  The two are distinguished solely by the
	form of their mailbox names: a trailing slash (or null mailbox) means
	it's a container, otherwise it's a folder.

2001-05-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.122], imail/imail-file.scm[1.65],
	  imail/imail-imap.scm[1.151], imail/imail-rmail.scm[1.63],
	  imail/imail-umail.scm[1.44], imail/imail-util.scm[1.38]:
	New operation CONTAINER-URL-CONTENTS.
	
	Reimplemented URL-IS-SELECTABLE? for file folders.  New implementation
	probes the file to determine if it is a known type.
	
	File-folder completion now only considers files of known type and
	directories.  It also doesn't consider "." and ".." directories.
	
	Code that mapped IMAP heirarchy delimiters was broken, although this
	caused no practical consequences.  It has been reimplemented to make
	it both correct and simpler.
	
	IMAP-folder completion used to probe subfolders of a folder to
	determine if a folder should have a "/" at the end.  This was wasteful
	of network bandwidth and had no practical consequences, so it has been
	changed to not do this.

2001-05-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-util.scm[1.37]:
	Restructure directory-reading code to clean up the interface a bit.

2001-05-13  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.121], imail/imail-file.scm[1.64],
	  imail/imail-imap.scm[1.150], imail/imail-rmail.scm[1.62],
	  imail/imail-top.scm[1.238], imail/imail-umail.scm[1.43]:
	* Implement container URLs, which are separate from folder URLs.
	  These are implemented as directories for file-based folders.  IMAP
	  folders are also containers.
	
	* Eliminate URL-CONTAINER-STRING; now there is URL-CONTAINER that
	  returns a container URL.
	
	* Rename URL-SELECTABLE? to URL-IS-SELECTABLE?.
	
	* Eliminate "rmail" and "umail" protocols in favor of "file".  This
	  now covers both Rmail and unix-mail folders, as well as directories.
	  The actual file type is determined by probing the first few bytes of
	  the file for known patterns.  The names "rmail" and "umail" are now
	  treated as equivalent to "file" for upwards compatibility.
	
	* Change prompting code in front end so that it is possible to specify
	  that the returned folder satisfies URL-IS-SELECTABLE?.  Also add a
	  procedure to prompt for a container.

2001-05-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/filcom.scm[1.217], edwin/print.scm[1.20],
	  imail/imail-util.scm[1.36], runtime/dosdir.scm[1.10],
	  runtime/unxdir.scm[14.12]:
	Use new predicate DIRECTORY-PATHNAME? to replace various ad-hoc
	mechanisms previously used to detect the same thing.

	* runtime/dospth.scm[1.41], runtime/pathnm.scm[14.34],
	  runtime/runtime.pkg[14.366], runtime/unxpth.scm[14.26]:
	Implement DIRECTORY-PATHNAME?.  Change implementation of
	DIRECTORY-PATHNAME and FILE-PATHNAME to be host-specific.

2001-05-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/filcom.scm[1.216]:
	Minor code clean-up for FILENAME-COMPLETE-STRING.

	* edwin/autosv.scm[1.34], edwin/dired.scm[1.184],
	  edwin/filcom.scm[1.215], edwin/fileio.scm[1.154],
	  edwin/utils.scm[1.48], edwin/vc.scm[1.77]:
	Simplify CATCH-FILE-ERRORS so that the error-handling procedure always
	gets the condition as an argument.

	* imail/imail-file.scm[1.63]:
	Fix bug: don't merge name of default pathname into partial URL string.

	* runtime/sfile.scm[14.26]:
	Fix bug: FILE-SYMBOLIC-LINK? is supposed to return the link contents
	if the result is true.  My rewrite returned #t in that case.

	* edwin/prompt.scm[1.196]:
	Fix thinko in previous fix.

2001-05-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/dired.scm[1.183]:
	Fix bug in M-x dired-create-directory: PROMPT-FOR-DIRECTORY recently
	changed so that it always returns the result as a directory pathname
	with no file part.  The code here was assuming that the name part was
	always present.

	* edwin/prompt.scm[1.195]:
	In PROMPT-FOR-STRING-TABLE-NAME, verifier must no assume that
	STRING-TABLE-GET will return false value only when key isn't in table.

	* imail/imail-core.scm[1.120], imail/imail-file.scm[1.62],
	  imail/imail-imap.scm[1.149]:
	Add new procedure URL-SELECTABLE?.

	* runtime/sfile.scm[14.25]:
	Implement FILE-REGULAR?.

	* runtime/ntprm.scm[1.36], runtime/os2prm.scm[1.47],
	  runtime/sfile.scm[14.24], runtime/unxprm.scm[1.61]:
	Implement new procedures FILE-TYPE-DIRECT and FILE-TYPE-INDIRECT.
	Several procedures in the OS-dependent files were identical for all
	operating-systems; move them to "sfile.scm".

	* microcode/ntfs.c[1.27], microcode/ntfs.h[1.5],
	  microcode/os2fs.c[1.13], microcode/osfs.h[1.10],
	  microcode/prntfs.c[1.17], microcode/prosfs.c[1.16],
	  microcode/uxfs.c[1.21]:
	Implement new primitives FILE-TYPE-DIRECT and FILE-TYPE-INDIRECT.

	* runtime/make.scm[14.68], runtime/make.scm[14.67],
	  runtime/runtime.pkg[14.365]:
	Delete DOS stuff.

2001-05-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/prompt.scm[1.194]:
	Fix problem: COMPLETE-INPUT-STRING should not return NO-MATCH when
	VERIFY-FINAL-VALUE fails on an exact match, because this match might
	not be the final value.  Instead, just do the verification and return
	the information to the caller.

2001-05-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/prompt.scm[1.193]:
	Change logic to retain REQUIRE-MATCH? option for later use when
	verifying values.

	* edwin/prompt.scm[1.192]:
	Revert broken change to VERIFY-FINAL-VALUE.

	* edwin/filcom.scm[1.214]:
	Change directory prompts to be more regular.

	* imail/load.scm[1.27]:
	Update version number to reflect changes.

	* imail/todo.txt[1.119]:
	Add note about implementation of FOLDER-LENGTH for IMAP folders.
	Remove note about URL-EXISTS? which is now implemented.

	* imail/imail-core.scm[1.119]:
	Don't unmemoize a folder when URL-EXISTS? signals an error; it might
	be a transitory error.
	
	It's not obvious to me that we need to unmemoize here.  Maybe we
	should just delete the call to URL-EXISTS? altogether.

	* imail/imail-top.scm[1.237]:
	VERIFY-FINAL-VALUE is always executed in a context that handles
	errors, so there's no need for us to do this.

	* imail/imail-imap.scm[1.148]:
	Change URL-EXISTS? to use the LIST command, and to filter out NOSELECT
	mailboxes.

	* edwin/prompt.scm[1.191]:
	Attempt to get VERIFY-FINAL-VALUE to work correctly for completing
	reads.  It appears to be used for two different things; perhaps we
	need to redesign this.

	* edwin/compile.scm[1.14]:
	Compilations must use a PTY so that kill-compilation can work.

2001-05-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.118]:
	URL-EXISTS? should not use IMAP STATUS command.

2001-05-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/uxproc.c[1.27]:
	Fix problem that crops up when compiling on OpenBSD.

2001-04-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* etc/optiondb.scm[1.7], etc/optiondb.scm[1.6]:
	Fix bug: previous loader depended on MITSCHEME_INF_DIRECTORY being
	set.  I used to set this and didn't notice, but these days I don't set
	it.

2001-04-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* configure.in[1.3], microcode/configure.in[11.12]:
	Add option to preserve timestamps when installing programs, if the
	install program supports it.

	* imail/imail-top.scm[1.236], imail/todo.txt[1.117]:
	Fix bug: toggling of raw headers and raw body should be more separate.

	* imail/todo.txt[1.116]:
	Add item re M-x imail-toggle-header affecting body presentation.

2001-04-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/sendmail.scm[1.78]:
	Revert previous change -- it's not so simple.

	* edwin/sendmail.scm[1.77]:
	Allow attachments to have MESSAGE type.

	* imail/imail-top.scm[1.235], imail/todo.txt[1.115]:
	Fix bug: must preserve MIME headers in forwarded messages, otherwise
	the encapsulated message won't be interpreted correctly by the
	receiver.

	* edwin/sendmail.scm[1.76]:
	Fix bug: header names are case-insensitive.

2001-04-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/uxenv.c[1.21]:
	Add call to tzset to initialize _timezone if building under cygwin.

	* microcode/configure.in[11.11]:
	Add test for _timezone variable, needed for cygwin.  Change preference
	of timezone variables to this order: __timezone, _timezone, timezone.

	* imail/todo.txt[1.114]:
	Add item about forwarded MIME messages.  Add note about possible fix
	for network wedging.

2001-04-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.113]:
	Add suggestion from hal to allow sorting of summary buffer.

2001-04-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/uxio.c[1.46], microcode/version.h[11.180]:
	Fix bug: examination of results from `poll' was ignoring file
	descriptors on which there were error conditions but no input.

	* runtime/thread.scm[1.34]:
	Always start the thread timer when there are any input registrations.
	The timer is necessary even if no threads are currently running.

2001-03-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/make.scm[3.108], runtime/version.scm[14.195]:
	Update version to reflect recent changes.

	* edwin/abbrev.scm[1.6], edwin/autold.scm[1.57],
	  edwin/comman.scm[1.85], edwin/comtab.scm[1.72],
	  edwin/debug.scm[1.56], edwin/modes.scm[1.34], edwin/modlin.scm[1.23],
	  edwin/process.scm[1.59], edwin/rmail.scm[1.72],
	  edwin/schmod.scm[1.49], edwin/sendmail.scm[1.75],
	  edwin/xterm.scm[1.66], runtime/Attic/syntax.scm[14.33],
	  runtime/dbgutl.scm[14.19], runtime/gensym.scm[14.6],
	  runtime/infstr.scm[1.10], runtime/infutl.scm[1.64],
	  runtime/pp.scm[14.41], runtime/uerror.scm[14.47],
	  runtime/unpars.scm[14.47], runtime/unsyn.scm[14.21]:
	Change many references of SYMBOL->STRING to use SYMBOL-NAME instead.
	These are all situations where copying the returned string is
	unnecessary and wasteful.

	* runtime/io.scm[14.63], runtime/output.scm[14.23]:
	Allow WRITE-SUBSTRING output-port operation to accept external
	strings.

	* runtime/dbgutl.scm[14.18], runtime/emacs.scm[14.29],
	  runtime/infutl.scm[1.63], runtime/krypt.scm[1.12],
	  runtime/ntprm.scm[1.35], runtime/os2graph.scm[1.18],
	  runtime/os2prm.scm[1.46], runtime/rgxcmp.scm[1.113],
	  runtime/strout.scm[14.15]:
	Use SUBSTRING-MOVE! in preference to SUBSTRING-MOVE-LEFT! and
	SUBSTRING-MOVE-RIGHT!.

	* runtime/string.scm[14.41]:
	Further optimize string-copying code.

	* runtime/rgxcmp.scm[1.114], runtime/string.scm[14.42],
	  runtime/string.scm[14.40]:
	Fix typo.

2001-03-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-rmail.scm[1.61]:
	Minimize consing in READ-RMAIL-ATTRIBUTES-LINE.

2001-03-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-file.scm[1.61], imail/imail-rmail.scm[1.60],
	  imail/imail-umail.scm[1.42]:
	Change file folders to store their messages in a vector rather than a
	list.  The linear-time lookup was killing performance on large
	folders.

	* imail/imail-rmail.scm[1.59]:
	Slow down the progress messages a bit; the parsing is now fast enough
	that we were doing too much work updating the screen.

	* imail/imail-util.scm[1.35]:
	Add DISCARD-CHARS and READ-STRING operations to xstring input port.
	Change SKIP-TO-LINE-START to use DISCARD-CHARS.

	* imail/imail-rmail.scm[1.58]:
	Fix problem: there's not necessarily a blank line between the
	alternate headers and the separator line.

	* runtime/string.scm[14.39]:
	Add LENGTH member to external-string structure.  It turns out that
	it's important that fetching the length be fast.

	* imail/imail-rmail.scm[1.57]:
	Fix thinko in previous change.

	* imail/imail-util.scm[1.34]:
	Add support for DISCARD-CHAR operation.

	* imail/imail-file.scm[1.60], imail/imail-rmail.scm[1.56],
	  imail/imail-umail.scm[1.41], imail/imail-util.scm[1.33]:
	Extend use of external-string storage to all file folders.  Don't
	pre-compute message headers; compute them on the fly from the external
	string when needed.

	* imail/imail-top.scm[1.234]:
	Generalize IMAIL-UI:PROGRESS-METER to be able to show progress when
	total number of items isn't known.  Memoize value computed by
	COUNT-UNSEEN-MESSAGES, to speed up navigation in very large folders.

	* imail/imail-core.scm[1.118], imail/imail.pkg[1.81]:
	Move MESSAGE-TIME into core.

2001-03-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-rmail.scm[1.55], imail/imail-rmail.scm[1.54],
	  imail/imail-rmail.scm[1.53], imail/imail-util.scm[1.32],
	  imail/load.scm[1.26]:
	Change implementation of Rmail folders to keep a copy of the Rmail
	file in an external string, and to refer to the message bodies using
	index pairs into the string.  This change should allow Scheme to
	handle much larger Rmail folders.

2001-03-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/edwin.pkg[1.271], edwin/sendmail.scm[1.74],
	  edwin/snr.scm[1.60]:
	Rewrite to generate the finished message into a temporary file rather
	than a buffer.  This allows the sending of attachments that are too
	large to fit into memory.
	
	Also rework the attachment interface slightly to simplify the choices
	presented to the user when the MIME type of a file can't be determined
	automatically.

	* runtime/unxprm.scm[1.60]:
	Make sure temporary files aren't readable or writeable by anyone other
	than the owner.

	* edwin/make.scm[3.107], runtime/version.scm[14.194]:
	Update for next release.

	* runtime/option.scm[14.37], runtime/runtime.pkg[14.364]:
	Rewrite debugging-info directory on option files; they are sometimes
	loaded while building the system but must refer to debugging info in
	it's installed location.

2001-03-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/schmod.scm[1.48]:
	Add more CALL-WITH-*-FILE entries to indentation table.

	* runtime/fileio.scm[1.19], runtime/runtime.pkg[14.363],
	  runtime/runtime.pkg[14.362]:
	Implement CALL-WITH-APPEND-FILE and CALL-WITH-BINARY-APPEND-FILE.

	* edwin/edwin.pkg[1.270]:
	Export RUN-SYNCHRONOUS-PROCESS-1.

2001-03-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/debian-changelog.scm[1.5]:
	Fix the value of fill-prefix in debian-changelog mode.

2001-03-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/configure.in[11.10], microcode/configure.in[11.9],
	  microcode/makegen/Makefile.in.in[1.16], microcode/prbfish.c[1.12],
	  microcode/prmcrypt.c[1.3], microcode/prmd5.c[1.7],
	  microcode/prmhash.c[11.3]:
	Generalize handling of modules.  Generate position-independent code
	for modules.

2001-03-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/load.scm[14.57]:
	Handle case where "lib" directory doesn't exist.

	* runtime/blowfish.scm[1.23], runtime/crypto.scm[14.13]:
	Add code to allow the crypto primitives to be dynamically loaded.

	* runtime/load.scm[14.56], runtime/runtime.pkg[14.361]:
	Implement LOAD-LIBRARY-OBJECT-FILE for loading primitives that are
	implemented as dynamically-loaded shared libraries.

	* runtime/uerror.scm[14.46], runtime/version.scm[14.193]:
	Add interface to new generic error-signalling mechanism.  Requires
	microcode 14.3 or later.

	* microcode/utils.c[9.78], microcode/utils.c[9.77]:
	Fix problem that broke upwards compatibility.

	* microcode/makegen/Makefile.in.in[1.15]:
	Fix typo.

	* microcode/pruxdld.c[1.14]:
	Major cleanup: eliminate dead code from HP-UX and AIX; simplify
	interfaces; generate meaningful errors when possible using new
	error-signalling mechanism.

	* microcode/avltree.c[1.5], microcode/avltree.h[1.4],
	  microcode/debug.c[9.52], microcode/extern.c[9.38],
	  microcode/findprim.c[9.55], microcode/prim.h[9.46],
	  microcode/primutl.c[9.74], microcode/usrdef.h[9.44]:
	Export `declare_primitive' and `install_primitive' in "usrdef.h".
	Change declaration of name and doc-string elements to be `const'.

	* microcode/errors.h[9.43], microcode/prims.h[9.48],
	  microcode/utabmd.scm[9.78], microcode/utils.c[9.76]:
	Add mechanism to allow signalling an error with an arbitrary Scheme
	object as an argument.

	* microcode/extern.h[9.59], microcode/extern.h[9.58],
	  microcode/string.c[9.44], microcode/string.c[9.43],
	  microcode/string.c[9.42]:
	Add procedures to allocate strings without garbage collecting.

	* microcode/configure.in[11.8], microcode/makegen/Makefile.in.in[1.14],
	  microcode/prbfish.c[1.11], microcode/prmcrypt.c[1.2],
	  microcode/prmd5.c[1.6], microcode/prmhash.c[11.2],
	  microcode/version.h[11.179]:
	Add support for loading crypto code as shared libraries.  This allows
	a package to be distributed that will work even if the target machine
	doesn't have the required libraries installed.  It also allows us to
	leave MIT Scheme in Debian's "main" section while still providing
	crypto support.

2001-03-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/acconfig.h[11.4], microcode/configure.in[11.7],
	  microcode/tterm.c[1.12]:
	Don't even try to use <termcap.h>.  If we're using ncurses, don't
	override the definitions in <term.h>, but do supply definitions for
	things not defined there.  Add abstract speed_t type, which is defined
	in recent <termios.h> files.

	* microcode/terminfo.c[1.7]:
	Fix typo in previous edit.

	* microcode/tterm.c[1.11]:
	Don't use <termcap.h> for ncurses; instead use <curses.h> and <term.h>
	as specified in the documentation (doh!).  Hopefully this will
	eliminate the problem on RH7.

	* microcode/terminfo.c[1.6]:
	Rewrite procedure to provide proper ANSI prototype.

2001-03-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/acconfig.h[11.3], microcode/configure.in[11.6],
	  microcode/tterm.c[1.10]:
	Add extra compile-time flag to specify whether libncurses defines the
	`tparam' procedure.

2001-03-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/ntutl/config.h[1.4], microcode/os2utl/config.h[1.3]:
	Win32 and OS/2 need to include headers for blowfish and md5.

	* edwin/paths.scm[1.16]:
	Fix thinko in previous edit.

	* microcode/acconfig.h[11.2], microcode/configure.in[11.5],
	  microcode/prbfish.c[1.10], microcode/prmd5.c[1.5]:
	Add support for OpenSSL.

	* microcode/tterm.c[1.9]:
	Fix compilation errors from previous edit.

	* runtime/blowfish.scm[1.22]:
	Don't use mcrypt for Blowfish; it provides 8-bit CFB and our original
	code provides 64-bit CFB.

2001-02-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/configure.in[11.4], microcode/prmcrypt.c[1.1],
	  runtime/blowfish.scm[1.21], runtime/crypto.scm[14.12],
	  runtime/runtime.pkg[14.360], runtime/version.scm[14.192]:
	Add support for mcrypt library.

	* microcode/makegen/files-optional.scm[1.3]:
	Add mcrypt support.

	* microcode/version.h[11.178]:
	Updates to support dynamic linking and mcrypt.

	* edwin/info.scm[1.136], edwin/make.scm[3.106], edwin/paths.scm[1.15]:
	Don't require existence of private Info directory.

	* microcode/tterm.c[1.8], microcode/tterm.c[1.7]:
	Use <termcap.h> to define termcap interface, if available.  Some
	recent versions of ncurses appear to have changed the interface.

	* microcode/terminfo.c[1.5]:
	Eliminate unnecessary compiler warnings.

2001-02-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/intmod.scm[1.113], edwin/intmod.scm[1.112],
	  edwin/intmod.scm[1.111]:
	Fix standard prompt spacing so that it appears properly in a
	transcript file.

	* runtime/rep.scm[14.56]:
	Don't explicitly bind the standard I/O ports; let them all default to
	the cmdl port.

	* runtime/port.scm[1.20]:
	Change current I/O ports to default to cmdl port, as is done with
	other ports.

	* runtime/emacs.scm[14.28]:
	Fix initialization of console port: must notice when standard I/O
	ports are encapsulations of the console port.

2001-02-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/option.c[1.56]:
	Fix logic used to select the default band.  It wasn't working
	correctly when there was only one band.

2001-02-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* README.txt[1.2]:
	Tweak punctuation.

2001-02-13  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/debian-changelog.scm[1.4], edwin/loadef.scm[1.45]:
	Move debian-changelog-mode-hook into "loadef.scm".

2001-02-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/bchdmp.c[9.88], microcode/bchgcl.c[9.52]:
	Fix fencepost error in handling of linkage sections.

2001-02-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/x11graph.scm[1.51]:
	Coerce all coordinate arguments to flonums.  This allows ratnums and
	recnums to be used for these arguments.

	* runtime/fixart.scm[1.6]:
	Implement ->FLONUM operation to coerce real numbers to flonums.

2001-02-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/mime-codec.scm[14.9]:
	Add state to look for line starting with NON-BASE64 character, and
	stop decoding there.  This works around problem that arises when
	mail-processing agents (e.g. mailman) randomly glue text on the end of
	a MIME message.

2001-02-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/debian-changelog.scm[1.3]:
	Forgot to supply buffer in which to do local variable bindings.

	* edwin/Makefile.in[1.4], edwin/fileio.scm[1.153]:
	New code to do Debian changelogs.

2001-02-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/debian-changelog.scm[1.2], edwin/loadef.scm[1.44]:
	Add command debian-changelog-mode.  Fix bugs; code now appears to work.

	* runtime/rgxcmp.scm[1.112]:
	Grumble.  Messing around while debugging problems caused by
	incorrectly built bands.

	* runtime/rgxcmp.scm[1.111]:
	Reengineer compilation of character set notation.

	* runtime/chrset.scm[14.12]:
	CHAR-SET:NOT-01 must be first set defined so that error checks on
	other calls will work right.

	* edwin/debian-changelog.scm[1.1], edwin/decls.scm[1.70],
	  edwin/ed-ffi.scm[1.51], edwin/edwin.pkg[1.269],
	  edwin/loadef.scm[1.43]:
	New code to do Debian changelogs.

	* imail/imap-response.scm[1.43]:
	CHAR-SET:NOT-NUMERIC now defined by runtime system.

	* edwin/utils.scm[1.47]:
	CHAR-SET:NOT-GRAPHIC now defined by runtime system.

	* runtime/chrset.scm[14.11], runtime/runtime.pkg[14.359]:
	Add inversions for all standard character sets.

	* edwin/buffer.scm[1.180], edwin/edwin.pkg[1.268],
	  edwin/regexp.scm[1.75], edwin/sendmail.scm[1.73]:
	Update copyright dates.

	* edwin/edwin.pkg[1.267], edwin/regexp.scm[1.74]:
	New procedure RE-MATCH-EXTRACT-STRING.

	* edwin/edwin.pkg[1.266], edwin/sendmail.scm[1.72]:
	Add procedures to access the user's email-address info.

2001-01-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/crypto.scm[14.11]:
	Allow names vectors to be sparse.  Newer versions of mhash don't use
	the index space densely.

2001-01-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/txtprp.scm[1.23]:
	KEY<? must be able to handle Edwin variables as well as symbols.

2001-01-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/txtprp.scm[1.22]:
	Allow keys to be Edwin variables too.

	* edwin/buffer.scm[1.179]:
	Allow a variable value to be stored in a region as a text property.

	* imail/imail-top.scm[1.233]:
	Add command imail-toggle-wrap-entity.  Change all toggle commands to
	be under C-c C-t.

2001-01-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.232]:
	Use new MIME-BODY-ENCLOSED? and SPECIFIC-PROPERTY-REGION to properly
	compute the buffer region associated with a compound MIME entity.  The
	problem is that the IMAIL-MIME-INFO text property associated with
	parts of the region will be that of subentities of the entity, so it's
	necessary to use the enclosure information to determine this.

	* imail/imail-core.scm[1.117], imail/imail-core.scm[1.116],
	  imail/imail-imap.scm[1.147]:
	Modify mime-body datatypes to have a pointer to the enclosing entity.

	* edwin/simple.scm[1.54]:
	Generalize SPECIFIC-PROPERTY-REGION to allow the user to supply an
	equivalence predicate.

	* imail/imail-top.scm[1.231]:
	Don't bind mouse commands to entity regions; just use single global
	binding.

	* imail/imail-top.scm[1.230]:
	When attaching MIME info to a region, don't overwrite sub-regions that
	already have MIME info attached.

	* edwin/simple.scm[1.53]:
	Change REGION-PUT! to allow it to specify the optional argument to ADD-TEXT-PROPERTY.

	* edwin/txtprp.scm[1.21]:
	Add optional argument to ADD-TEXT-PROPERTY that allows it to add the
	property to a region without overwriting any existing sub-regions in
	which the property is already bound.  Also: invert sense of predicate
	passed to MODIFY-TEXT-PROPERTIES, so that it identifies the intervals
	to be modified rather than those not to be modified.

2001-01-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.146]:
	Fix bug: UW IMAP sometimes returns multiple FETCH responses to a
	FETCH, while we were expecting just one with multiple attributes.  So
	if there are multiple responses, merge them.

2001-01-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.145]:
	Don't fetch ranges of the form "N:*" when N is greater than the length
	of the folder.  This causes an error to be signalled on UW IMAP
	(although Cyrus accepts this and returns nothing).

2001-01-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/io.scm[14.62], runtime/runtime.pkg[14.358]:
	Strip off external-string wrapper before handing it to the microcode.

	* imail/imail-util.scm[1.31], imail/load.scm[1.25]:
	Update copyright date.

	* imail/imail-summary.scm[1.39], imail/imail-summary.scm[1.38],
	  imail/imail.pkg[1.80]:
	Implement new variable imail-summary-auto-select to allow the user to
	move around in the summary buffer without automatically selecting
	messages.  (Requested by Hal.)

	* edwin/make.scm[3.105]:
	Increment version to reflect recent changes.

	* edwin/comtab.scm[1.71]:
	Fix bug: COMTAB-KEY-BINDINGS was signalling error when the given
	command was bound to a mouse button.  Also, sort the result so that
	the simplest kinds of keys appear first; this is usually what's wanted
	when reverse-mapping a command for documentation.

	* edwin/calias.scm[1.20]:
	Kludge in support for buttons in place where they might occur for help
	commands.  Buttons should really be merged into the special-key
	mechanism.

	* edwin/comtab.scm[1.70]:
	Try a different strategy for aliasing upper-case letters to lower-case
	ones: rather than creating explicit aliases, just look up both as
	needed.

	* imail/imail-top.scm[1.229]:
	Use new mail-notification mechanism in the notifier.  This allows
	IMAIL to coexist with the notifier.

	* edwin/notify.scm[1.19]:
	Add procedure NOTIFIER:SET-MAIL-STRING! to allow an alternate mail
	reader (e.g. IMAIL) to control mail notification.

2001-01-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/string.c[9.41]:
	Fix typo in ht_delete.  Don't unnecessarily try to grow or shrink hash
	table.

	* runtime/string.scm[14.38]:
	Pass external-string descriptor to substring-move-FOO! rather than
	runtime's wrapper.

	* runtime/runtime.pkg[14.357], runtime/string.scm[14.37]:
	Add operations for XSTRING (extended string) objects.

2001-01-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-util.scm[1.30], imail/load.scm[1.24]:
	Implement input port from external string.

	* runtime/make.scm[14.66], runtime/runtime.pkg[14.356],
	  runtime/string.scm[14.36], runtime/version.scm[14.191]:
	Add interface to external strings.

	* microcode/string.c[9.40]:
	Primitive names are supposed to be upper-case.

	* microcode/prims.h[9.47], microcode/prosio.c[1.18],
	  microcode/string.c[9.39], microcode/version.h[11.177]:
	Implement external-string mechanism for storing text data outside of
	Scheme's heap.

2000-12-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/load.scm[1.23]:
	Reimplement handling of MIME entities.  Now all entities are (more or
	less) well-formed XML, using the keyword "imail-part".  Presentation
	of an entity is now consistent, whether it was originally shown inline
	or out of line.  New option allows message digests to have their
	messages show out of line.  imail-use-original-mime-boundaries
	replaced by imail-mime-boundary-style; the latter additionally
	supports a boundary that is an SGML comment.

2000-12-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.115], imail/imail-top.scm[1.228],
	  imail/imail.pkg[1.79]:
	Reimplement handling of MIME entities.  Now all entities are (more or
	less) well-formed XML, using the keyword "imail-part".  Presentation
	of an entity is now consistent, whether it was originally shown inline
	or out of line.  New option allows message digests to have their
	messages show out of line.  imail-use-original-mime-boundaries
	replaced by imail-mime-boundary-style; the latter additionally
	supports a boundary that is an SGML comment.

2000-12-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/Makefile.in[1.3], edwin/Makefile.in[1.2],
	  runtime/Makefile.in[1.3], runtime/Makefile.in[1.2]:
	Fix problem remaking symbolic links.

	* edwin/win32.scm[1.15]:
	Fix bug: C-g was not acting as interrupt character.

2000-12-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* etc/optiondb.scm[1.5]:
	Add WIN32 option.  Alphabetize options.

	* etc/optiondb.scm[1.4]:
	Update to new GUARDED-SYSTEM-LOADER.

	* microcode/bchdmp.c[9.87]:
	Must include unix-emulation header files.  These were inadvertently
	removed with the mktemp changes.

2000-12-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/configure[1.4]:
	Can't use -f test on symbolic links that point to directories.

	* etc/Clean.sh[1.5]:
	Delete configured makefile in "distclean" rule.

	* README.txt[1.1]:
	Initial revision.

	* Makefile.in[1.16], configure.in[1.2], edwin/Makefile.in[1.1],
	  etc/Setup.sh[1.6], imail/Makefile.in[1.1], runtime/Makefile.in[1.1],
	  sos/Makefile.in[1.1]:
	Define per-directory Makefiles with custom "install" rules for those
	directories that supply things to be installed.

	* imail/imail-summary.scm[1.37]:
	Change highlighting so that only the date, subject, and author are
	highlighted.  This makes it easier to see point.

	* imail/imail-top.scm[1.227]:
	Set mode-line-process to a procedure value, so that the new mode line
	is computed only by need.

	* imail/imail-summary.scm[1.36]:
	Fix problems with previous mode-line tweak by setting
	mode-line-process to a procedure value that is called whenever the
	mode line is generated.

	* imail/imail-top.scm[1.226]:
	Fix typo.

	* imail/imail-summary.scm[1.35]:
	Change imail-summary mode line to contain a connection-status
	indicator.

	* imail/imail-top.scm[1.225]:
	Fix bug: make sure that "[New Mail]" marker is removed if the default
	folder is deleted.

	* imail/imail-top.scm[1.224]:
	Fix problem with global mail notification: the code that decided
	whether to do this depended on the selected buffer.

2000-12-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.112]:
	Write down assorted things I've been thinking about.

2000-12-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* etc/compile.scm[1.2]:
	Make sure that all cref files are built.

	* Makefile.in[1.15]:
	Remove dependence of "install" on "all".  This will eliminate
	gratuitous rebuilding of bands.

	* Makefile.in[1.14]:
	Make sure that bands are written to output directory.

	* runtime/version.scm[14.190]:
	Increment release number.

	* edwin/make.scm[3.104], imail/load.scm[1.22]:
	Increment version to reflect recent changes.

2000-12-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.223]:
	Change M-x imail-quit again -- this time to reverse the meaning of the
	prefix argument.  Now the default is to quit from all folders.

	* imail/imail-top.scm[1.222]:
	Add prefix argument to M-x imail-quit that says to close _all_
	folders.

2000-12-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* compiler/Clean.sh[1.4]:
	Don't clean vax disassembler links for "distclean".

2000-12-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* Attic/Makefile[1.19], Attic/configure[1.4], Clean.sh[1.4],
	  Clean.sh[1.3], Makefile.in[1.13], Makefile.in[1.12],
	  Makefile.in[1.11], Makefile.in[1.10], Makefile.in[1.9],
	  Makefile.in[1.8], Makefile.in[1.7], Makefile.in[1.6],
	  Makefile.in[1.5], Makefile.in[1.4], Makefile.in[1.3],
	  Makefile.in[1.2], Makefile.in[1.1], Makefile.std[1.11],
	  Setup.sh[1.6], Setup.sh[1.5], Setup.sh[1.4], Setup.sh[1.3],
	  compiler/Setup.sh[1.3], configure.in[1.1], etc/Setup.sh[1.5],
	  etc/TUTORIAL[1.1], etc/functions.sh[1.1], etc/mime.types[1.1],
	  install-sh[1.1], microcode/Setup.sh[1.5], microcode/Setup.sh[1.4],
	  microcode/Setup.sh[1.3], microcode/configure.in[11.3],
	  microcode/makegen/Makefile.in.in[1.13],
	  microcode/makegen/Makefile.in.in[1.12],
	  microcode/makegen/Makefile.in.in[1.11],
	  microcode/makegen/makeinit.sh[1.8],
	  microcode/makegen/makeinit.sh[1.7], mkinstalldirs[1.1],
	  runtime-check/Setup.sh[1.3]:
	Use autoconf for top-level Makefile.

	* Clean.sh[1.2], etc/Setup.sh[1.2]:
	Fix typo.

	* Attic/Makefile[1.18], Attic/Makefile[1.17], Clean.sh[1.1],
	  Makefile.std[1.10], Makefile.std[1.9], Setup.sh[1.2], Setup.sh[1.1],
	  Tags.sh[1.1], compiler/Attic/Makefile[1.20], compiler/Clean.sh[1.3],
	  compiler/Clean.sh[1.2], compiler/Clean.sh[1.1],
	  compiler/Setup.sh[1.2], compiler/Setup.sh[1.1],
	  compiler/Stage.sh[1.1], compiler/Tags.sh[1.1],
	  cref/Attic/Clean.sh[1.2], cref/Attic/Clean.sh[1.1],
	  edwin/Clean.sh[1.2], edwin/Clean.sh[1.1],
	  etc/Attic/bootstrap-compile.scm[1.8], etc/Attic/bootstrap.sh[1.5],
	  etc/Attic/build-compiler.scm[1.2], etc/Attic/build-edwin.scm[1.2],
	  etc/Attic/build-runtime.scm[1.2], etc/Attic/build-tree.sh[1.5],
	  etc/Attic/create-dirs.sh[1.8], etc/Attic/runtime-check.cbf[1.2],
	  etc/Clean.sh[1.4], etc/Clean.sh[1.3], etc/Clean.sh[1.2],
	  etc/Clean.sh[1.1], etc/Setup.sh[1.4], etc/Setup.sh[1.3],
	  etc/Setup.sh[1.1], etc/Stage.sh[1.2], etc/Stage.sh[1.1],
	  etc/Tags.sh[1.1], microcode/Attic/Mclean.sh[1.4],
	  microcode/Clean.sh[1.1], runtime-check/Attic/Makefile[1.3],
	  runtime-check/Clean.sh[1.1], runtime-check/Setup.sh[1.2],
	  runtime-check/Setup.sh[1.1]:
	Redesign the structure for setup and clean rules.  New structure uses
	shell scripts in each directory, which the makefiles refer to.  This
	greatly simplifies the configuration code because it was getting too
	painful to put complex shell scripts inside the makefiles.

	* microcode/makegen/Makefile.in.in[1.10]:
	When "Makefile.deps" was moved to top level directory, Forgot to
	change "maintainer-clean" rule.

2000-12-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime-check/Attic/Makefile[1.2]:
	Fix typo in previous change.

	* Attic/Makefile[1.16], etc/Attic/create-dirs.sh[1.7]:
	Don't need to create "runtime-check" anymore; using a different
	strategy.

	* Attic/Makefile[1.15]:
	Fix spurious errors from deleting non-existent files.

	* Attic/Makefile[1.14]:
	Fix typo.

	* Attic/Makefile[1.13]:
	Fix up "*clean" rules to handle "runtime-check" and "lib".

	* etc/Attic/create-dirs.sh[1.6]:
	Make sure "runtime-check/Makefile" exists.

	* etc/Attic/create-dirs.sh[1.5], etc/Attic/create-dirs.sh[1.4]:
	Need to have file "runtime-check/runtime.cbf".

	* Attic/Makefile[1.12], Makefile.std[1.8],
	  etc/Attic/create-dirs.sh[1.3]:
	Fix broken test commands.

	* etc/Attic/create-dirs.sh[1.2]:
	Fix rule to create runtime-check directory.  Link rules were broken,
	and script can't assume that .bin files exist yet; we must work from
	the .scm files and transform the names.

	* Attic/Makefile[1.11]:
	Define "all" rule.

	* etc/optiondb.scm[1.3]:
	Use more powerful loader to support build process.

	* etc/Attic/create-dirs.sh[1.1], etc/Attic/runtime-check.cbf[1.1],
	  etc/build-bands.sh[1.1], etc/compile.scm[1.1],
	  runtime-check/Attic/Makefile[1.1], runtime-check/runtime.cbf[1.1]:
	Initial revision.

	* microcode/makegen/Makefile.in.in[1.9],
	  microcode/makegen/Makefile.in.in[1.8]:
	Add rules to make and install "utabmd.bin".

	* microcode/mkinstalldirs[1.1]:
	Import revision 1.13 from automake.

	* microcode/makegen/Makefile.in.in[1.7]:
	First cut at install rules.

	* edwin/wincom.scm[1.132]:
	Fix some bad interactions between buffer layouts and popped-up
	windows.

	* microcode/ntutl/config.h[1.3]:
	Watcom C/C++ and Visual C++ both have <fcntl.h>, and it must be loaded
	in order to get the definition for O_BINARY.

2000-12-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* Attic/configure[1.3], compiler/configure[1.3]:
	Fix typo.

	* Attic/Makefile[1.10], microcode/Attic/Mclean.sh[1.3],
	  microcode/Attic/Mclean.sh[1.2], microcode/Attic/Mclean.sh[1.1]:
	Move knowledge about doing "maintainer-clean" into script in microcode
	directory.

	* microcode/configure.in[11.2]:
	Don't try to link architecture files if they already exist.

	* Attic/Makefile[1.9]:
	For "maintainer-clean", treat microcode directory specially.  If
	"configure" exists but "Makefile" doesn't, run "configure".

	* microcode/Setup.sh[1.2], microcode/makegen/Makefile.in.in[1.6],
	  microcode/makegen/makeinit.sh[1.6]:
	Change "makegen/makeinit.sh" to leave the directory configured.  This
	allows "Setup.sh" to use "make setup", thus avoiding replication of
	information.

	* Attic/Makefile[1.8]:
	Add rcs and win32 directories.

	* compiler/Attic/Makefile[1.19]:
	Don't create machine-specific files in "setup" rule.  But do clean
	them in "distclean" rule.

	* Attic/configure[1.2], compiler/configure[1.2],
	  compiler/configure[1.1]:
	Move compiler configuration to a file in the compiler directory.

	* Attic/Makefile[1.7], Attic/Makefile[1.6], Attic/Makefile[1.5]:
	Don't execute "*clean" rule in subdirectory if there's no makefile.

	* compiler/Attic/Makefile[1.18]:
	Don't delete the Makefile.

	* compiler/Attic/Makefile[1.17]:
	Add code to "setup" rule to create links into machine directory.  (The
	machine link itself is created at configuration time.)

	* compiler/Attic/Makefile[1.16]:
	Don't show conditional for "machine".

	* Attic/Makefile[1.4]:
	Don't abort clean rules if one subdirectory fails.

	* compiler/Attic/Makefile[1.15]:
	Add rules to clean the directory.

	* microcode/makegen/makeinit.sh[1.5]:
	Use "make distclean" to clean up unneeded files; don't reproduce
	information that is already present in the makefile.  Add comments
	explaining what each step does.

	* Attic/Makefile[1.3], microcode/makegen/Makefile.in.in[1.5]:
	Move setup stuff to shell script.  This must be possible to do without
	a Makefile.

	* Attic/configure[1.1], compiler/config.guess[1.1],
	  microcode/Setup.sh[1.1]:
	Initial revision.

2000-12-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/makegen/makeinit.sh[1.4]:
	Do equivalent of "distclean" after building "Makefile.in".

	* compiler/Attic/Makefile[1.14]:
	Fix typo.

	* Makefile.std[1.7]:
	Fix broken logic.

	* Makefile.std[1.6]:
	Add commands to delete packaging files when appropriate.

	* Attic/Makefile[1.2]:
	When doing "setup" for microcode directory, must create Makefile in
	order to run the setup rule.

	* Attic/Makefile[1.1]:
	Initial revision.

	* Makefile.std[1.5]:
	Add "*clean" rules.

	* compiler/Attic/Makefile[1.13]:
	Don't create "machine" link in source directory; that is supposed to
	go in the target directory.

	* Makefile.std[1.4]:
	Clean up commands for staging rules.

	* compiler/Attic/Makefile[1.12]:
	Rewrite to eliminate GNU make dependencies.  Add "setup" rule.

	* Makefile.std[1.3], microcode/makegen/Makefile.in.in[1.4],
	  microcode/makegen/Makefile.in.in[1.3]:
	Add "setup" rule.

	* edwin/filcom.scm[1.213]:
	Fix bug: alternate file doesn't have to exist.  Calling
	PROMPT-FOR-ALTERNATE-FILE also prevented using this command to visit a
	directory.

	* microcode/makegen/makeinit.sh[1.3]:
	Don't write files in "makegen/"; this causes problems when the build
	directory is symlinked into the source directory.

	* microcode/Attic/config.h[9.102], microcode/Attic/dosasutl.asm[1.5],
	  microcode/Attic/dosconio.c[1.14], microcode/Attic/dosenv.c[1.11],
	  microcode/Attic/dosexcp.c[1.7], microcode/Attic/dosexcp.h[1.5],
	  microcode/Attic/dosfg.c[1.5], microcode/Attic/dosfile.c[1.5],
	  microcode/Attic/dosfs.c[1.7], microcode/Attic/dosi10.asm[1.4],
	  microcode/Attic/dosinsn.h[1.4], microcode/Attic/dosint10.c[1.10],
	  microcode/Attic/dosint10.h[1.4], microcode/Attic/dosio.c[1.10],
	  microcode/Attic/dosio.h[1.6], microcode/Attic/doskbd.c[1.14],
	  microcode/Attic/doskbd.h[1.4], microcode/Attic/doskbutl.asm[1.8],
	  microcode/Attic/dosscan.h[1.6], microcode/Attic/dosselec.h[1.4],
	  microcode/Attic/dossig.c[1.18], microcode/Attic/dossys.c[1.6],
	  microcode/Attic/dossys.h[1.4], microcode/Attic/dosterm.h[1.4],
	  microcode/Attic/dostop.c[1.14], microcode/Attic/dostop.h[1.4],
	  microcode/Attic/dostrap.c[1.8], microcode/Attic/dostrap.h[1.5],
	  microcode/Attic/dostterm.c[1.4], microcode/Attic/dostty.c[1.5],
	  microcode/Attic/dosutil.c[1.4], microcode/Attic/dosutil.h[1.4],
	  microcode/Attic/dosx32.c[1.8], microcode/Attic/dosxcutl.asm[1.9],
	  microcode/Attic/msdos.h[1.8], microcode/Attic/oscond.h[1.27],
	  microcode/Attic/posixtyp.h[1.17], microcode/Attic/prdosenv.c[1.12],
	  microcode/Attic/prdosfs.c[1.6], microcode/acconfig.h[11.1],
	  microcode/ansidecl.h[1.7], microcode/avltree.h[1.3],
	  microcode/bchdmp.c[9.86], microcode/bchdrn.c[1.10],
	  microcode/bchdrn.h[1.10], microcode/bchgcc.h[9.63],
	  microcode/bchgcl.c[9.51], microcode/bchmmg.c[9.98],
	  microcode/bchmmg.c[9.97], microcode/bchpur.c[9.70],
	  microcode/bchpur.c[9.69], microcode/bchutl.c[1.11],
	  microcode/bignum.c[9.49], microcode/bintopsb.c[9.72],
	  microcode/bitstr.c[9.63], microcode/bitstr.h[1.10],
	  microcode/boot.c[9.104], microcode/cmpauxmd/hppa.m4[1.39],
	  microcode/cmpauxmd/m4-dos[1.2], microcode/cmpauxmd/makefile[1.7],
	  microcode/cmpauxmd/mc68k.m4[1.27], microcode/cmpauxmd/vax.m4[1.4],
	  microcode/cmpgc.h[1.31], microcode/cmpint.c[1.92],
	  microcode/cmpint.h[10.7], microcode/cmpintmd/i386.h[1.32],
	  microcode/cmptype.h[1.3], microcode/config.guess[11.1],
	  microcode/config.sub[11.1], microcode/configure.in[11.1],
	  microcode/confshared.h[11.1], microcode/const.h[9.46],
	  microcode/debug.c[9.51], microcode/default.h[9.44],
	  microcode/dmpwrld.c[9.40], microcode/dosutl/Attic/bch-prm.lst[1.8],
	  microcode/dosutl/Attic/bch-ztc.lst[1.8],
	  microcode/dosutl/Attic/config.bat[1.3],
	  microcode/dosutl/Attic/float.h[1.2],
	  microcode/dosutl/Attic/limits.h[1.2],
	  microcode/dosutl/Attic/makefile[1.14],
	  microcode/dosutl/Attic/scm-prm.lst[1.8],
	  microcode/dosutl/Attic/scm-ztc.lst[1.8], microcode/error.c[1.7],
	  microcode/extern.h[9.57], microcode/fasdump.c[9.64],
	  microcode/fasload.c[9.88], microcode/findprim.c[9.54],
	  microcode/foreign.c[1.3], microcode/foreign.h[1.3],
	  microcode/gccode.h[9.57], microcode/gcloop.c[9.47],
	  microcode/hooks.c[9.59], microcode/hppacach.h[1.6],
	  microcode/hppanwca.c[1.5], microcode/install-sh[11.1],
	  microcode/intern.c[9.57], microcode/interp.c[9.90],
	  microcode/interp.h[9.42], microcode/intrpt.h[1.21],
	  microcode/liarc.h[1.15], microcode/lookprm.c[1.12],
	  microcode/lookup.c[9.58], microcode/lookup.h[9.52],
	  microcode/m/Attic/alpha.h[1.5], microcode/m/Attic/apoll68k.h[1.5],
	  microcode/m/Attic/hcx.h[1.4], microcode/m/Attic/hp9k300.h[1.14],
	  microcode/m/Attic/hp9k400.h[1.10], microcode/m/Attic/hp9k800.h[1.15],
	  microcode/m/Attic/i386.h[1.7], microcode/m/Attic/ibm032.h[1.4],
	  microcode/m/Attic/mips.h[1.11], microcode/m/Attic/next.h[1.7],
	  microcode/m/Attic/rs6000.h[1.4], microcode/m/Attic/sun3.h[1.8],
	  microcode/m/Attic/sun4.h[1.5], microcode/m/Attic/umax.h[1.4],
	  microcode/m/Attic/vax.h[1.7], microcode/makegen/Makefile.in.in[1.2],
	  microcode/makegen/files-core.scm[1.2],
	  microcode/makegen/files-gc-bch.scm[1.2],
	  microcode/makegen/files-gc-std.scm[1.2],
	  microcode/makegen/files-optional.scm[1.2],
	  microcode/makegen/files-os-prim.scm[1.2],
	  microcode/makegen/files-other.scm[1.2],
	  microcode/makegen/files-unix.scm[1.2], microcode/makegen/m4.sh[1.2],
	  microcode/makegen/makegen.scm[1.2],
	  microcode/makegen/makeinit.sh[1.2], microcode/memmag.c[9.66],
	  microcode/memmag.h[1.8], microcode/missing.c[9.33],
	  microcode/mul.c[9.35], microcode/nt.h[1.9], microcode/ntenv.c[1.19],
	  microcode/ntfs.c[1.26], microcode/ntgui.c[1.28],
	  microcode/ntio.c[1.23], microcode/ntscreen.c[1.46],
	  microcode/ntsig.c[1.22], microcode/nttop.c[1.30],
	  microcode/nttrap.c[1.18], microcode/nttterm.c[1.4],
	  microcode/ntutl/config.h[1.2], microcode/ntutl/makefile.wcc[1.16],
	  microcode/ntutl/ntgui.rc[1.10], microcode/object.h[9.50],
	  microcode/obstack.c[1.6], microcode/obstack.h[1.11],
	  microcode/option.c[1.55], microcode/os.h[1.7], microcode/os2.h[1.7],
	  microcode/os2fs.c[1.12], microcode/os2msg.c[1.14],
	  microcode/os2pm.c[1.33], microcode/os2pmcon.c[1.26],
	  microcode/os2proc.c[1.7], microcode/os2sock.c[1.15],
	  microcode/os2term.c[1.4], microcode/os2top.c[1.21],
	  microcode/os2utl/config.cmd[1.4], microcode/os2utl/config.h[1.2],
	  microcode/os2utl/makefile[1.15], microcode/os2utl/makefile.cmn[1.13],
	  microcode/os2utl/makefile.emx[1.9],
	  microcode/os2utl/makefile.gcc[1.7],
	  microcode/os2utl/makefile.vac[1.7],
	  microcode/os2utl/makefile.wcc[1.8],
	  microcode/os2utl/mkos2pm.scm[1.2], microcode/os2xcpt.c[1.8],
	  microcode/osenv.h[1.10], microcode/osfs.h[1.9],
	  microcode/osio.h[1.15], microcode/osscheme.c[1.11],
	  microcode/osscheme.h[1.11], microcode/outf.c[1.12],
	  microcode/outf.h[1.5], microcode/ppband.c[9.50],
	  microcode/prbfish.c[1.9], microcode/primutl.c[9.73],
	  microcode/prmcon.h[1.4], microcode/prntenv.c[1.10],
	  microcode/prntfs.c[1.16], microcode/prntio.c[1.13],
	  microcode/pros2fs.c[1.18], microcode/pros2io.c[1.9],
	  microcode/prosenv.c[1.17], microcode/prosfs.c[1.15],
	  microcode/prosproc.c[1.19], microcode/pruxdld.c[1.13],
	  microcode/pruxenv.c[1.19], microcode/pruxfs.c[9.56],
	  microcode/pruxio.c[1.8], microcode/pruxsock.c[1.18],
	  microcode/psbmap.h[9.44], microcode/purify.c[9.59],
	  microcode/purutl.c[9.51], microcode/regex.c[1.20],
	  microcode/s/Attic/386bsd.h[1.4], microcode/s/Attic/aix.h[1.4],
	  microcode/s/Attic/bsd4-2.h[1.9], microcode/s/Attic/bsd4-3.h[1.7],
	  microcode/s/Attic/decosf.h[1.5], microcode/s/Attic/dos.m4[1.7],
	  microcode/s/Attic/freebsd.h[1.5], microcode/s/Attic/hpux.h[1.13],
	  microcode/s/Attic/irix4.h[1.6], microcode/s/Attic/irix6.h[1.3],
	  microcode/s/Attic/linux.h[1.21], microcode/s/Attic/linuxelf.lds[1.2],
	  microcode/s/Attic/mach4-3.h[1.5], microcode/s/Attic/newsos5.h[1.6],
	  microcode/s/Attic/nextos.h[1.8], microcode/s/Attic/nt.m4[1.3],
	  microcode/s/Attic/sunos3.h[1.6], microcode/s/Attic/sunos4.h[1.9],
	  microcode/s/Attic/sysv3.h[1.6], microcode/s/Attic/sysv4.h[1.5],
	  microcode/s/Attic/ultrix.h[1.17], microcode/s/Attic/ultrix.m4[1.8],
	  microcode/s/Attic/umax.h[1.7], microcode/scheme.h[9.39],
	  microcode/storage.c[9.57], microcode/syntax.c[1.25],
	  microcode/syscall.h[1.13], microcode/sysprim.c[9.47],
	  microcode/term.c[1.15], microcode/termcap.c[1.7],
	  microcode/terminfo.c[1.4], microcode/transact.c[1.5],
	  microcode/trap.h[9.45], microcode/unxutl/Attic/cf-dist.h[1.26],
	  microcode/unxutl/Attic/config[1.32],
	  microcode/unxutl/Attic/makefile[1.29],
	  microcode/unxutl/Attic/y300.lcl[1.25],
	  microcode/unxutl/Attic/y700.lcl[1.9],
	  microcode/unxutl/Attic/y800.lcl[1.3],
	  microcode/unxutl/Attic/ymake.sed[1.2],
	  microcode/unxutl/Attic/ymkfile[1.97],
	  microcode/unxutl/Attic/ynws3250.lcl[1.4], microcode/utils.c[9.75],
	  microcode/ux.c[1.20], microcode/ux.h[1.74], microcode/uxctty.c[1.14],
	  microcode/uxenv.c[1.20], microcode/uxfile.c[1.10],
	  microcode/uxfs.c[1.20], microcode/uxio.c[1.45],
	  microcode/uxproc.c[1.26], microcode/uxsig.c[1.35],
	  microcode/uxsig.h[1.6], microcode/uxsock.c[1.26],
	  microcode/uxterm.c[1.28], microcode/uxtop.c[1.25],
	  microcode/uxtrap.c[1.30], microcode/uxtrap.h[1.29],
	  microcode/version.h[11.176], microcode/wabbit.c[1.8],
	  microcode/x11.h[1.17], microcode/x11base.c[1.76],
	  microcode/xdebug.c[9.34]:
	Merge in changes from branch ac-new-bch-gc.

	* pcsample/Makefile[1.3]:
	Add rule for making TAGS file.

	* microcode/makegen/Makefile.in.in[1.1.2.1.2.1]:
	Add rule to etags so that primitive definitions are tagged.

2000-12-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/ntfs.c[1.25.4.2], microcode/osfs.h[1.8.4.2]:
	Fix copyright date.

	* microcode/bchdmp.c[9.85.2.1.2.4], microcode/bchgcc.h[9.60.2.3.2.5],
	  microcode/bchmmg.c[9.95.2.3.2.5],
	  microcode/ntutl/makefile.wcc[1.13.2.1.2.4],
	  microcode/os2utl/makefile.cmn[1.12.2.1.2.3]:
	Eliminate use of `mktemp'; instead use portable `OS_file_touch' which
	is safer.

	* microcode/ntfs.c[1.25.4.1], microcode/os2fs.c[1.11.4.1],
	  microcode/osfs.h[1.8.4.1], microcode/prntfs.c[1.15.2.1.2.1],
	  microcode/pros2fs.c[1.17.4.1], microcode/prosfs.c[1.14.2.1.2.1],
	  microcode/pruxfs.c[9.55.2.1.2.1], microcode/uxfs.c[1.19.2.1.2.1]:
	Define standard procedure `OS_file_touch' and merge OS-specific copies
	of corresponding primitives into a OS-independent primitive.

	* microcode/bchdmp.c[9.85.2.1.2.3]:
	Finish rewriting `dump_loop'.  Finished product is very similar to
	gc_loop.

	* microcode/bchgcl.c[9.50.4.7]:
	Add some macros to abstract the process of dumping the free and scan
	buffers.

	* microcode/bchdmp.c[9.85.2.1.2.2]:
	First incomplete draft of rewrite.  File reorganized and style
	converted.  `dump_loop' is in transition but cursory testing indicates
	that it still works.

	* microcode/bchgcc.h[9.60.2.3.2.4], microcode/bchgcl.c[9.50.4.6]:
	Rename FLOAT_ALIGN_FREE to BCH_ALIGN_FLOAT.
	Define BCH_ALIGN_FLOAT_ADDRESS.

	* edwin/filcom.scm[1.212]:
	Change M-x find-alternate-file to prompt as it does in Emacs: with the
	full pathname of the current buffer's file, if any.

	* microcode/os2utl/mkos2pm.scm[1.1.2.1]:
	Initial revision.

	* microcode/os2utl/mkos2pm.scm[1.1]:
	file mkos2pm.scm was initially added on branch ac-new-bch-gc.

	* microcode/os2utl/makefile.cmn[1.12.2.1.2.2]:
	Add rule to automatically generate the os2pm-*.h files.

	* microcode/prosproc.c[1.18.2.1.2.4]:
	IBM VisualAge C/C++ doesn't need declaration of `environ'; it's
	declared by <stdlib.h>.

2000-12-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/vc.scm[1.76]:
	Add defaults to prompts for M-x vc-version-diff.

	* microcode/ntutl/makefile.wcc[1.15]:
	Clean up .map files and *def.c files.

	* microcode/ntutl/makefile.wcc[1.14],
	  microcode/ntutl/makefile.wcc[1.13.2.1.2.3]:
	Optimize code by default.

	* microcode/findprim.c[9.53.2.1.2.3]:
	Work around: FreeBSD declares incompatible `mergesort' in <stdlib.h>.

	* microcode/ux.h[1.73.2.1.2.4]:
	Declare `environ' on non-GNU systems.

	* microcode/pruxenv.c[1.18.2.1.2.1]:
	Eliminate unused unix-specific primitive UNIX-ENVIRONMENT.  This
	primitive is identical to the portable primitive SCHEME-ENVIRONMENT.

2000-12-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/interp.h[9.41.4.1], microcode/ntenv.c[1.18.4.1],
	  microcode/ntgui.c[1.27.2.1.2.1], microcode/ntscreen.c[1.45.4.1],
	  microcode/ntsig.c[1.21.2.1.2.1], microcode/nttrap.c[1.17.2.1.2.2],
	  microcode/outf.c[1.11.2.1.2.2], microcode/prntio.c[1.12.4.1]:
	Eliminate compiler warnings from Watcom C/C++ under Windows.

	* microcode/ntutl/makefile.wcc[1.13.2.1.2.2]:
	Don't forget to clean up .map files and *def.c files.

	* microcode/prosproc.c[1.18.2.1.2.3]:
	This file requires explicit declaration of `environ' because it
	doesn't include the operating-system specific files that normally
	provide it.

	* microcode/ux.h[1.73.2.1.2.3]:
	Copy include of time files here; don't depend on "config.h" doing
	this.

	* microcode/prosproc.c[1.18.2.1.2.2], microcode/ux.h[1.73.2.1.2.2],
	  microcode/uxproc.c[1.25.2.1.2.1]:
	Eliminate explicit declarations of `environ'.

	* microcode/nttrap.c[1.17.2.1.2.1]:
	Change names containing "Win32Exception" back to "WinntException".
	Apparently at least one of these names is externally defined.

	* microcode/ansidecl.h[1.6.4.1], microcode/bchmmg.c[9.95.2.3.2.4],
	  microcode/bitstr.c[9.62.4.1], microcode/cmpint.c[1.91.2.1.2.1],
	  microcode/cmpint.h[10.6.4.1],
	  microcode/cmpintmd/i386.h[1.31.2.1.2.2],
	  microcode/fasload.c[9.87.2.1.2.1],
	  microcode/findprim.c[9.53.2.1.2.2],
	  microcode/findprim.c[9.53.2.1.2.1], microcode/intern.c[9.56.4.1],
	  microcode/lookup.c[9.57.2.1.2.1], microcode/lookup.h[9.51.2.1.2.1],
	  microcode/nt.h[1.8.2.1.2.1],
	  microcode/ntutl/makefile.wcc[1.13.2.1.2.1],
	  microcode/obstack.c[1.5.4.1], microcode/obstack.h[1.10.4.1],
	  microcode/os2.h[1.6.4.1], microcode/os2msg.c[1.13.4.1],
	  microcode/os2pm.c[1.32.4.1], microcode/os2proc.c[1.6.4.1],
	  microcode/os2sock.c[1.14.4.1], microcode/os2term.c[1.3.4.1],
	  microcode/os2top.c[1.20.4.1], microcode/os2utl/config.h[1.1.2.1.2.1],
	  microcode/os2utl/makefile.cmn[1.12.2.1.2.1],
	  microcode/os2utl/makefile.vac[1.6.2.1.2.1],
	  microcode/os2xcpt.c[1.7.4.1], microcode/osenv.h[1.9.4.1],
	  microcode/outf.c[1.11.2.1.2.1], microcode/outf.h[1.4.4.1],
	  microcode/primutl.c[9.72.2.1.2.1], microcode/prmcon.h[1.3.4.1],
	  microcode/pros2io.c[1.8.4.1], microcode/prosproc.c[1.18.2.1.2.1],
	  microcode/purutl.c[9.50.4.1], microcode/regex.c[1.19.2.1.2.1],
	  microcode/sysprim.c[9.46.4.1], microcode/termcap.c[1.6.2.1.2.1],
	  microcode/transact.c[1.4.4.1], microcode/utils.c[9.74.2.1.2.1],
	  microcode/ux.h[1.73.2.1.2.1], microcode/x11.h[1.16.4.1]:
	Eliminate large number of compiler warnings from IBM VisualAge C/C++
	running under OS/2.  One specific change is to eliminate most uses of
	__STDC__ in favor of HAVE_STDC, since IBM's compiler (and Microsoft's
	Windows compiler) doesn't define this.

	* microcode/interp.c[9.89.2.1.2.1]:
	Eliminate page breaks in middle of `Interpret'.  (Most of these were
	useless anyway since they had been indented.)  Fix indentation in a
	few places.  Reindent lines that were too long.

	* microcode/cmpintmd/i386.h[1.31.2.1.2.1]:
	Fix bug: code was still referencing _OS2 and WINNT rather than __OS2__
	and __WIN32__.

2000-12-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/bchgcc.h[9.60.2.3.2.3], microcode/bchgcl.c[9.50.4.5],
	  microcode/bchmmg.c[9.95.2.3.2.3], microcode/bchpur.c[9.67.2.2.2.3]:
	Clean up the code in the two top-level GC procedures, `GC' and
	`purify'.  Mostly presentation changes, but some simplifications as
	well.  The code is still far from obvious.

	* microcode/bchgcc.h[9.60.2.3.2.2], microcode/bchmmg.c[9.95.2.3.2.2],
	  microcode/bchpur.c[9.67.2.2.2.2]:
	Fix bug: code for fixing up weak pairs at end of GC was assuming that
	Constant_Top was the same as low_heap.  But recent changes make that
	untrue in purify.

	* microcode/bchgcl.c[9.50.4.4]:
	Fix thinko: scope of C variable declaration _includes_ an initializer
	if present.  This is unlike Scheme.

	* 6001/edextra.scm[1.32]:
	X-SCREEN-AUTO-RAISE has been eliminated.

	* edwin/curren.scm[1.143]:
	Fix typo in previous change.

	* edwin/debug.scm[1.55]:
	Fix typo in recent change.

	* edwin/xcom.scm[1.17], edwin/xterm.scm[1.65]:
	Create separate fields in X screen structure to hold visibility,
	whether window is mapped, and whether window is exposed.  Synthesize
	SCREEN-VISIBILITY from these fields; previously SCREEN-VISIBILITY held
	all this information and was sometimes inaccurate.
	
	Don't attempt to give focus to an unmapped frame.  This will only
	signal an error.
	
	Don't map an unmapped frame when entering it.  Eliminate variable
	X-SCREEN-AUTO-RAISE and associated command.  Both of these things were
	window management; we shouldn't be doing that.

	* edwin/curren.scm[1.142], edwin/debug.scm[1.54],
	  edwin/edwin.pkg[1.265], edwin/os2term.scm[1.22],
	  edwin/scrcom.scm[1.8], edwin/screen.scm[1.118],
	  edwin/win32.scm[1.14], edwin/wincom.scm[1.131]:
	Change arguments to OTHER-SCREEN so that only first is required.
	
	Eliminate OTHER-SCREEN?, replacing occurrences with OTHER-SCREEN.
	
	Change meaning of SCREEN-VISIBLE? to mean "not unmapped"; this is
	almost always what was meant.
	
	Fix bug in SELECT-WINDOW: when selecting the selected window of
	another frame, must select the frame.
	
	Fix SELECT-BUFFER-OTHER-SCREEN to select the frame as well as the
	buffer if reusing an existing frame.

	* edwin/scrcom.scm[1.7]:
	Don't allow selection of frames that aren't mapped.  The user can
	unmap it first if wanted.

2000-11-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/sendmail.scm[1.71]:
	Fix bug: temporary mark was used across buffer modification.

	* edwin/xterm.scm[1.64]:
	FOCUS-IN events must not cause X-WINDOW-SET-INPUT-FOCUS to be called.
	Use dynamic binding to prevent this from happening.

	* microcode/bchgcl.c[9.50.4.3]:
	Fix termination condition for purification.  purify expects us to halt
	at any broken heart.

	* microcode/bchgcl.c[9.50.4.2]:
	Fix typo.

2000-11-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/bchdmp.c[9.85.2.1.2.1], microcode/bchgcc.h[9.60.2.3.2.1],
	  microcode/bchgcl.c[9.50.4.1], microcode/bchmmg.c[9.95.2.3.2.1],
	  microcode/bchpur.c[9.67.2.2.2.1], microcode/fasdump.c[9.63.2.1.2.1],
	  microcode/gccode.h[9.56.2.1.2.1], microcode/gcloop.c[9.46.4.1],
	  microcode/purify.c[9.58.4.1]:
	Complete rewrite of the bchscheme garbage-collector main loop.  The
	garbage collector and purify now share the main loop.  The new design
	is much more transparent: there are no variable references or control
	branches hidden inside macros.  This design should be easier to debug,
	too, since the control structure isn't hidden inside macros that can't
	be stepped.

	* edwin/vc.scm[1.75]:
	M-x vc-directory now prompts for the directory.

	* microcode/bchgcc.h[9.62], microcode/bchgcc.h[9.60.2.3]:
	Fix thinko.

	* edwin/sendmail.scm[1.70]:
	Fix typo in previous change.

2000-11-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/cmpgc.h[1.30.2.2]:
	Fix typo.

	* microcode/version.h[11.175]:
	Update to reflect bug fix to purify in bchscheme.

	* rcs/mklogs.scm[1.22]:
	Don't need separate changelogs for the documentation; just one.

	* runtime/version.scm[14.189]:
	Update release number to 7.5.11.

	* rcs/nparse.scm[1.3]:
	Handle CVS "magic branch numbers".

	* rcs/mklogs.scm[1.21]:
	Move v7 documentation from "/scheme/documentation/" to
	"/scheme/v7/doc/".

	* microcode/bchgcc.h[9.61], microcode/bchgcc.h[9.60.2.2],
	  microcode/bchmmg.c[9.96], microcode/bchmmg.c[9.95.2.3],
	  microcode/bchpur.c[9.68], microcode/bchpur.c[9.67.2.2]:
	Fix bug: purify wasn't properly saving and restoring the scan state
	around the scan of constant space.  Doing this right requires access
	to internal state of bchmmg, so I built an abstraction to do this.

	* microcode/bchpur.c[9.67.2.1]:
	Change some instances of `purify_mode' to `pure_p' to eliminate
	confusion; another variable called `purify_mode' has a completely
	different type and meaning.

	* microcode/configure.in[1.1.2.2]:
	Add new function tests needed by "bchmmg.c".

	* microcode/bchmmg.c[9.95.2.2]:
	Reconditionalize to use less idiosyncratic tests.

2000-11-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.221]:
	Fix M-x imail-save-attachment properly; previous fix didn't work right.

	* microcode/ntutl/config.h[1.1], microcode/os2utl/config.h[1.1]:
	file config.h was initially added on branch use-autoconf.

	* microcode/makegen/files-optional.scm[1.1]:
	file files-optional.scm was initially added on branch use-autoconf.

	* microcode/makegen/files-os-prim.scm[1.1]:
	file files-os-prim.scm was initially added on branch use-autoconf.

	* microcode/makegen/files-other.scm[1.1]:
	file files-other.scm was initially added on branch use-autoconf.

	* microcode/makegen/files-unix.scm[1.1]:
	file files-unix.scm was initially added on branch use-autoconf.

	* microcode/makegen/m4.sh[1.1]:
	file m4.sh was initially added on branch use-autoconf.

	* microcode/makegen/makegen.scm[1.1]:
	file makegen.scm was initially added on branch use-autoconf.

	* microcode/makegen/makeinit.sh[1.1]:
	file makeinit.sh was initially added on branch use-autoconf.

	* microcode/makegen/Makefile.in.in[1.1]:
	file Makefile.in.in was initially added on branch use-autoconf.

	* microcode/makegen/files-core.scm[1.1]:
	file files-core.scm was initially added on branch use-autoconf.

	* microcode/makegen/files-gc-bch.scm[1.1]:
	file files-gc-bch.scm was initially added on branch use-autoconf.

	* microcode/makegen/files-gc-std.scm[1.1]:
	file files-gc-std.scm was initially added on branch use-autoconf.

	* microcode/cmpauxmd/m4-dos[1.1]:
	file m4-dos was initially added on branch use-autoconf.

	* microcode/install-sh[1.1]:
	file install-sh was initially added on branch use-autoconf.

	* microcode/config.guess[1.1]:
	file config.guess was initially added on branch use-autoconf.

	* microcode/config.sub[1.1]:
	file config.sub was initially added on branch use-autoconf.

	* microcode/configure.in[1.1]:
	file configure.in was initially added on branch use-autoconf.

	* microcode/confshared.h[1.1]:
	file confshared.h was initially added on branch use-autoconf.

	* microcode/Attic/config.h[9.101.2.1],
	  microcode/Attic/dosasutl.asm[1.4.2.1],
	  microcode/Attic/dosconio.c[1.13.2.1],
	  microcode/Attic/dosenv.c[1.10.2.1],
	  microcode/Attic/dosexcp.c[1.6.2.1],
	  microcode/Attic/dosexcp.h[1.4.2.1], microcode/Attic/dosfg.c[1.4.2.1],
	  microcode/Attic/dosfile.c[1.4.2.1], microcode/Attic/dosfs.c[1.6.2.1],
	  microcode/Attic/dosi10.asm[1.3.2.1],
	  microcode/Attic/dosinsn.h[1.3.2.1],
	  microcode/Attic/dosint10.c[1.9.2.1],
	  microcode/Attic/dosint10.h[1.3.2.1],
	  microcode/Attic/dosio.c[1.9.2.1], microcode/Attic/dosio.h[1.5.2.1],
	  microcode/Attic/doskbd.c[1.13.2.1],
	  microcode/Attic/doskbd.h[1.3.2.1],
	  microcode/Attic/doskbutl.asm[1.7.2.1],
	  microcode/Attic/dosscan.h[1.5.2.1],
	  microcode/Attic/dosselec.h[1.3.2.1],
	  microcode/Attic/dossig.c[1.17.2.1],
	  microcode/Attic/dossys.c[1.5.2.1], microcode/Attic/dossys.h[1.3.2.1],
	  microcode/Attic/dosterm.h[1.3.2.1],
	  microcode/Attic/dostop.c[1.13.2.1],
	  microcode/Attic/dostop.h[1.3.2.1],
	  microcode/Attic/dostrap.c[1.7.2.1],
	  microcode/Attic/dostrap.h[1.4.2.1],
	  microcode/Attic/dostterm.c[1.3.2.1],
	  microcode/Attic/dostty.c[1.4.2.1],
	  microcode/Attic/dosutil.c[1.3.2.1],
	  microcode/Attic/dosutil.h[1.3.2.1],
	  microcode/Attic/dosx32.c[1.7.2.1],
	  microcode/Attic/dosxcutl.asm[1.8.2.1],
	  microcode/Attic/msdos.h[1.7.2.1], microcode/Attic/oscond.h[1.26.2.1],
	  microcode/Attic/posixtyp.h[1.16.2.1],
	  microcode/Attic/prdosenv.c[1.11.2.1],
	  microcode/Attic/prdosfs.c[1.5.2.1], microcode/acconfig.h[1.1.2.1],
	  microcode/avltree.h[1.2.2.1], microcode/bchdmp.c[9.85.2.1],
	  microcode/bchdrn.c[1.9.2.1], microcode/bchdrn.h[1.9.2.1],
	  microcode/bchgcc.h[9.60.2.1], microcode/bchmmg.c[9.95.2.1],
	  microcode/bchutl.c[1.10.2.1], microcode/bignum.c[9.48.2.1],
	  microcode/bintopsb.c[9.71.2.1], microcode/bitstr.h[1.9.2.1],
	  microcode/boot.c[9.103.2.1], microcode/cmpauxmd/hppa.m4[1.38.2.1],
	  microcode/cmpauxmd/m4-dos[1.1.2.1],
	  microcode/cmpauxmd/makefile[1.6.2.1],
	  microcode/cmpauxmd/mc68k.m4[1.26.2.1],
	  microcode/cmpauxmd/vax.m4[1.3.2.1], microcode/cmpgc.h[1.30.2.1],
	  microcode/cmpint.c[1.91.2.1], microcode/cmpintmd/i386.h[1.31.2.1],
	  microcode/cmptype.h[1.2.2.1], microcode/config.guess[1.1.2.1],
	  microcode/config.sub[1.1.2.1], microcode/configure.in[1.1.2.1],
	  microcode/confshared.h[1.1.2.1], microcode/const.h[9.45.2.1],
	  microcode/debug.c[9.50.2.1], microcode/default.h[9.43.2.1],
	  microcode/dmpwrld.c[9.39.2.1],
	  microcode/dosutl/Attic/bch-prm.lst[1.7.2.1],
	  microcode/dosutl/Attic/bch-ztc.lst[1.7.2.1],
	  microcode/dosutl/Attic/config.bat[1.2.2.1],
	  microcode/dosutl/Attic/float.h[1.1.2.1],
	  microcode/dosutl/Attic/limits.h[1.1.2.1],
	  microcode/dosutl/Attic/makefile[1.13.2.1],
	  microcode/dosutl/Attic/scm-prm.lst[1.7.2.1],
	  microcode/dosutl/Attic/scm-ztc.lst[1.7.2.1],
	  microcode/error.c[1.6.2.1], microcode/extern.h[9.56.2.1],
	  microcode/fasdump.c[9.63.2.1], microcode/fasload.c[9.87.2.1],
	  microcode/findprim.c[9.53.2.1], microcode/foreign.c[1.2.2.1],
	  microcode/foreign.h[1.2.2.1], microcode/gccode.h[9.56.2.1],
	  microcode/hooks.c[9.58.2.1], microcode/hppacach.h[1.5.2.1],
	  microcode/hppanwca.c[1.4.2.1], microcode/install-sh[1.1.2.1],
	  microcode/interp.c[9.89.2.1], microcode/intrpt.h[1.20.2.1],
	  microcode/liarc.h[1.14.2.1], microcode/lookprm.c[1.11.2.1],
	  microcode/lookup.c[9.57.2.1], microcode/lookup.h[9.51.2.1],
	  microcode/m/Attic/alpha.h[1.4.2.1],
	  microcode/m/Attic/apoll68k.h[1.4.2.1],
	  microcode/m/Attic/hcx.h[1.3.2.1],
	  microcode/m/Attic/hp9k300.h[1.13.2.1],
	  microcode/m/Attic/hp9k400.h[1.9.2.1],
	  microcode/m/Attic/hp9k800.h[1.14.2.1],
	  microcode/m/Attic/i386.h[1.6.2.1],
	  microcode/m/Attic/ibm032.h[1.3.2.1],
	  microcode/m/Attic/mips.h[1.10.2.1],
	  microcode/m/Attic/next.h[1.6.2.1],
	  microcode/m/Attic/rs6000.h[1.3.2.1],
	  microcode/m/Attic/sun3.h[1.7.2.1], microcode/m/Attic/sun4.h[1.4.2.1],
	  microcode/m/Attic/umax.h[1.3.2.1], microcode/m/Attic/vax.h[1.6.2.1],
	  microcode/makegen/Makefile.in.in[1.1.2.1],
	  microcode/makegen/files-core.scm[1.1.2.1],
	  microcode/makegen/files-gc-bch.scm[1.1.2.1],
	  microcode/makegen/files-gc-std.scm[1.1.2.1],
	  microcode/makegen/files-optional.scm[1.1.2.1],
	  microcode/makegen/files-os-prim.scm[1.1.2.1],
	  microcode/makegen/files-other.scm[1.1.2.1],
	  microcode/makegen/files-unix.scm[1.1.2.1],
	  microcode/makegen/m4.sh[1.1.2.1],
	  microcode/makegen/makegen.scm[1.1.2.1],
	  microcode/makegen/makeinit.sh[1.1.2.1], microcode/memmag.c[9.65.2.1],
	  microcode/memmag.h[1.7.2.1], microcode/missing.c[9.32.2.1],
	  microcode/mul.c[9.34.2.1], microcode/nt.h[1.8.2.1],
	  microcode/ntgui.c[1.27.2.1], microcode/ntio.c[1.22.2.1],
	  microcode/ntsig.c[1.21.2.1], microcode/nttop.c[1.29.2.1],
	  microcode/nttrap.c[1.17.2.1], microcode/nttterm.c[1.3.2.1],
	  microcode/ntutl/config.h[1.1.2.1],
	  microcode/ntutl/makefile.wcc[1.13.2.1],
	  microcode/ntutl/ntgui.rc[1.9.2.1], microcode/object.h[9.49.2.1],
	  microcode/option.c[1.54.2.1], microcode/os.h[1.6.2.1],
	  microcode/os2pmcon.c[1.25.2.1], microcode/os2utl/config.cmd[1.3.2.1],
	  microcode/os2utl/config.h[1.1.2.1],
	  microcode/os2utl/makefile[1.14.2.1],
	  microcode/os2utl/makefile.cmn[1.12.2.1],
	  microcode/os2utl/makefile.emx[1.8.2.1],
	  microcode/os2utl/makefile.gcc[1.6.2.1],
	  microcode/os2utl/makefile.vac[1.6.2.1],
	  microcode/os2utl/makefile.wcc[1.7.2.1], microcode/osio.h[1.14.2.1],
	  microcode/osscheme.c[1.10.2.1], microcode/osscheme.h[1.10.2.1],
	  microcode/outf.c[1.11.2.1], microcode/ppband.c[9.49.2.1],
	  microcode/prbfish.c[1.8.2.1], microcode/primutl.c[9.72.2.1],
	  microcode/prntenv.c[1.9.2.1], microcode/prntfs.c[1.15.2.1],
	  microcode/prosenv.c[1.16.2.1], microcode/prosfs.c[1.14.2.1],
	  microcode/prosproc.c[1.18.2.1], microcode/pruxdld.c[1.12.2.1],
	  microcode/pruxenv.c[1.18.2.1], microcode/pruxfs.c[9.55.2.1],
	  microcode/pruxio.c[1.7.2.1], microcode/pruxsock.c[1.17.2.1],
	  microcode/psbmap.h[9.43.2.1], microcode/regex.c[1.19.2.1],
	  microcode/s/Attic/386bsd.h[1.3.2.1],
	  microcode/s/Attic/aix.h[1.3.2.1],
	  microcode/s/Attic/bsd4-2.h[1.8.2.1],
	  microcode/s/Attic/bsd4-3.h[1.6.2.1],
	  microcode/s/Attic/decosf.h[1.4.2.1],
	  microcode/s/Attic/dos.m4[1.6.2.1],
	  microcode/s/Attic/freebsd.h[1.4.2.1],
	  microcode/s/Attic/hpux.h[1.12.2.1],
	  microcode/s/Attic/irix4.h[1.5.2.1],
	  microcode/s/Attic/irix6.h[1.2.2.1],
	  microcode/s/Attic/linux.h[1.20.2.1],
	  microcode/s/Attic/linuxelf.lds[1.1.2.1],
	  microcode/s/Attic/mach4-3.h[1.4.2.1],
	  microcode/s/Attic/newsos5.h[1.5.2.1],
	  microcode/s/Attic/nextos.h[1.7.2.1],
	  microcode/s/Attic/nt.m4[1.2.2.1],
	  microcode/s/Attic/sunos3.h[1.5.2.1],
	  microcode/s/Attic/sunos4.h[1.8.2.1],
	  microcode/s/Attic/sysv3.h[1.5.2.1],
	  microcode/s/Attic/sysv4.h[1.4.2.1],
	  microcode/s/Attic/ultrix.h[1.16.2.1],
	  microcode/s/Attic/ultrix.m4[1.7.2.1],
	  microcode/s/Attic/umax.h[1.6.2.1], microcode/scheme.h[9.38.2.1],
	  microcode/storage.c[9.56.2.1], microcode/syntax.c[1.24.2.1],
	  microcode/syscall.h[1.12.2.1], microcode/term.c[1.14.2.1],
	  microcode/termcap.c[1.6.2.1], microcode/terminfo.c[1.3.2.1],
	  microcode/trap.h[9.44.2.1],
	  microcode/unxutl/Attic/cf-dist.h[1.25.2.1],
	  microcode/unxutl/Attic/config[1.31.2.1],
	  microcode/unxutl/Attic/makefile[1.28.2.1],
	  microcode/unxutl/Attic/y300.lcl[1.24.2.1],
	  microcode/unxutl/Attic/y700.lcl[1.8.2.1],
	  microcode/unxutl/Attic/y800.lcl[1.2.2.1],
	  microcode/unxutl/Attic/ymake.sed[1.1.2.1],
	  microcode/unxutl/Attic/ymkfile[1.96.2.1],
	  microcode/unxutl/Attic/ynws3250.lcl[1.3.2.1],
	  microcode/utils.c[9.74.2.1], microcode/ux.c[1.19.2.1],
	  microcode/ux.h[1.73.2.1], microcode/uxctty.c[1.13.2.1],
	  microcode/uxenv.c[1.19.2.1], microcode/uxfile.c[1.9.2.1],
	  microcode/uxfs.c[1.19.2.1], microcode/uxio.c[1.44.2.1],
	  microcode/uxproc.c[1.25.2.1], microcode/uxsig.c[1.34.2.1],
	  microcode/uxsig.h[1.5.2.1], microcode/uxsock.c[1.25.2.1],
	  microcode/uxterm.c[1.27.2.1], microcode/uxtop.c[1.24.2.1],
	  microcode/uxtrap.c[1.29.2.1], microcode/uxtrap.h[1.28.2.1],
	  microcode/version.h[11.174.2.1], microcode/wabbit.c[1.7.2.1],
	  microcode/x11base.c[1.75.2.1], microcode/xdebug.c[9.33.2.1]:
	* Convert microcode to use autoconf in place of custom configuration
	  mechanism.  Change major version of microcode to 14 (skipping 12 and
	  13 that were used for unreleased versions).
	
	* Write Scheme program to generate "Makefile.in" from a template.
	  This program automatically generates compilation dependencies, but
	  it depends on having gcc to do this.
	
	  I tried using automake to do this, but it's not powerful enough to
	  handle definition of a program in which the component files are
	  selected at configure time.
	
	* Rename old "config.h" to "confshared.h".  New "config.h"
	  automatically generated by autoconf on unix systems; hand-written
	  for Win32 and OS/2.  Make sure all files now include "config.h".
	  Eliminate references to "oscond.h" and "posixtyp.h"; merge the
	  functionality of those files into "config.h".  "confshared.h"
	  includes "ansidecl.h" so eliminate most references to the latter.
	  Completely rewrite "ux.h"; new revision is considerably simplified
	  since autoconf takes care of most of the details.
	
	* Rename a number of preprocessor symbols:
	
		OLD NAME			NEW NAME
		========			========
		WINNT				__WIN32__
		_HPUX				__HPUX__
		_IRIX				__IRIX__
		_OS2				__OS2__
		_POSIX				_POSIX_VERSION
		_UNIX				__unix__
		__linux				__linux__
		i386				__IA32__
		HAS_FLOOR			HAVE_FLOOR
		HAS_FREXP			HAVE_FREXP
		HAS_MODF			HAVE_MODF
		HAVE_APPEND			O_APPEND
		HAVE_BSD_TTY_DRIVER		HAVE_SGTTY_H
		HAVE_ITIMER			HAVE_SETITIMER
		HAVE_SYMBOLIC_LINKS		HAVE_SYMLINK
		HAVE_SYSV3_SIGNALS		HAVE_SIGHOLD
		HAVE_SYSV_SHARED_MEMORY		USE_SYSV_SHARED_MEMORY
		HAVE_TERMIO			HAVE_TERMIO_H
		HAVE_TERMIOS			HAVE_TERMIOS_H
		RELEASE				SCHEME_RELEASE
		SUBVERSION			SCHEME_SUBVERSION
		USE_HOSTENT_ADDR		!HAVE_HOSTENT_H_ADDR_LIST
		VERSION				SCHEME_VERSION
	
	* Change names containing "winnt" to contain "win32" instead.
	  Change names containing "i386" to contain "ia32" instead.
	
	* Make numerous changes to eliminate warnings reported by "gcc -Wall".
	
	* Modify PTY code to incorporate ideas from libzvt in GNOME.  This
	  was needed to get unix98 PTYs working in GNU/Linux.  Use runtime
	  test to decide if PTYs are available (in systems that lack grantpt),
	  since there's no way to determine this at configure or compile time.
	
	* Use poll in preference to select if both are available.  Previously
	  poll was used in one place and select in another.
	
	* Use `tm_gmtoff' if it is available in `struct tm'.  GNU libc and
	  FreeBSD both support `tm_gmtoff' with the same meaning.  The
	  `timezone' variable is defined in FreeBSD, but with a completely
	  different meaning.
	
	* Change handling of baud rates to make it more portable.
	
	* Change handling of M4 files; implement new shell scripts to do
	  expansion while passing parameters on the command line.  Always use
	  these scripts, since they are portable.
	
	* Change default type-code length on systems with compiled-code
	  support to be 6 rather than 8.  This simplifies the definition of
	  those systems since we were always overriding the type-code length
	  on them.
	
	* Completely rewrite compilation dependencies for Win32 and OS/2
	  makefiles.  New dependencies are quite detailed, directly reflect
	  the source code, should now be accurate.
	
	* Eliminate all DOS files and all references to DOS.  Eliminate all
	  the code for the case where WINNT_RAW_ADDRESSES was undefined, since
	  that was DOS-specific.

	* microcode/acconfig.h[1.1]:
	file acconfig.h was initially added on branch use-autoconf.

2000-11-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-response.scm[1.42]:
	Add workaround for bug in Courier-IMAP.

	* edwin/sendmail.scm[1.69]:
	Add Emacs mail-sending feature that prompts for confirmation if user
	tries to send same mail twice.

2000-11-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/chrsyn.scm[1.3], runtime/chrsyn.scm[1.2]:
	Fix thinko.

2000-11-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-summary.scm[1.34]:
	Change IMAIL-SUMMARY-POP-UP-MESSAGE-BUFFER to use POP-UP-BUFFER again.
	This should fix the problem of over-splitting windows.  Don't use
	IMAIL-SUMMARY-POP-UP-MESSAGE-BUFFER for fixed layout; instead simplify
	that logic to use WINDOW-SPLIT-VERTICALLY!.  Eliminate
	SYNC-IMAIL-SUMMARY-BUFFER which was used in only one place.

2000-11-13  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.220], imail/imail.pkg[1.78]:
	Add variable imail-output-default at Hal's request.

2000-11-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/blowfish.scm[1.20]:
	Eliminate restriction on blowfish encryption.  New US crypto
	regulations permit us to export this code now.

2000-10-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/curren.scm[1.141]:
	Fix bug: previously, selecting one of the buffers of a visible layout
	into a window that held a different buffer of that layout would leave
	the layout marked as visible.  This fix notices this case and unmarks
	the layout.  However, the selection of the buffer causes the layout to
	be reselected, which means the operation has no net effect.

	* edwin/comwin.scm[1.146]:
	Don't delete a window if it's already deleted.

	* edwin/debug.scm[1.53]:
	Fix bug: SELECT-CONTINUATION-BROWSER-BUFFER called BROWSER-SELECT-LINE
	assuming that the buffer it had specified for selection was already
	selected; this turned out not to be true.  So modify the code to pass
	the buffer explicitly rather than depend on selection.  Also tweak
	code that prompts for X window geometry so that it re-prompts if the
	user's input isn't valid.

	* edwin/curren.scm[1.140]:
	Fix bug: UNDO-LEAVE-WINDOW! was being called on the wrong window from
	SELECT-SCREEN and SELECT-WINDOW.  Also change order of arguments to
	CHANGE-SELECTED-BUFFER to match order used most other places in this
	file.

	* edwin/basic.scm[1.140], edwin/prompt.scm[1.190]:
	Don't abort prompt when an input event arrives; process the event and
	restart the prompt.  There may be subtle problems with this strategy;
	find and fix them.

2000-10-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-summary.scm[1.33]:
	Fix fencepost error that caused the wrong number of columns to be
	allocated for the message number when the folder was exactly a power
	of ten.

2000-10-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/load.scm[1.21]:
	Update version to reflect recent changes.

	* edwin/wincom.scm[1.130]:
	Deselect any buffer layout before popping up a new window.

	* edwin/curren.scm[1.139]:
	When killing buffer, it's possible to signal an error if there are no
	other buffers.  Previously, this error could have been signalled
	_after_ the killing procedure had already killed off any buffer
	process, run the kill hooks, etc.  Now the error test is done first,
	and if the error is signalled, no other action is taken.

	* imail/imail-summary.scm[1.32]:
	In previous change, forgot to select the folder buffer after creating
	a new window to hold it.
	
	Don't create a new window to hold the folder buffer if it is already
	visible somewhere.
	
	Simplify logic of layout selector now that SELECT-BUFFER will no
	longer cause the layout selector to run again.

	* edwin/curren.scm[1.138]:
	Change MAYBE-SELECT-BUFFER-LAYOUT so that it does nothing if called
	while running a layout selector; this will prevent infinite recursions
	and that otherwise occur quite easily while instantiating the layout.
	
	Simplify MAYBE-SELECT-BUFFER-LAYOUT so that it doesn't do anything
	unless the layout is changing.  Previously indirect tests were used,
	now we just compare the current layout with the proposed layout and
	implement the changes.

	* edwin/buffer.scm[1.178]:
	Allow ->BUFFER to take a window as an argument.

2000-10-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-summary.scm[1.31]:
	Don't use POP-UP-BUFFER to split the window; use
	WINDOW-SPLIT-VERTICALLY! instead.  Also, tweak fixed layout generator
	so that it doesn't go into infinite recursion.

	* edwin/comwin.scm[1.145], edwin/curren.scm[1.137]:
	Add code to mark buffer layout inactive when one of its windows is
	deleted.

	* edwin/hlpcom.scm[1.121]:
	In WITH-OUTPUT-TO-HELP-DISPLAY, don't change window/buffer arrangement
	until after the argument thunk has been executed.

	* edwin/curren.scm[1.136]:
	Adjust interrupt locking of buffer-layout code.  When selecting buffer
	layouts, ignore buffer selections in the typein window.

	* edwin/xterm.scm[1.63]:
	Fix long-standing bug that occurred when using multiple screens with a
	window manager that supports multiple workspaces: switching workspaces
	sometimes caused an error to be signalled by X-WINDOW-SET-INPUT-FOCUS.
	The problem is that the workspace switch caused all of Edwin's windows
	to be unmapped.  Depending on the order in which the unmap events
	arrived, Edwin might have queued a request to select another screen.
	But since all of the screens were unmapped at the time the request was
	processed, the attempt to set the input focus to one of these unmapped
	screens always generated an error.
	
	The fix eliminates the code that tried to select another screen.
	Instead we depend on the window manager to tell us when another screen
	needs to be selected.

	* edwin/xterm.scm[1.62]:
	Add event-tracing facility.

	* imail/imail-top.scm[1.219]:
	M-x imail-save-attachment should also work when invoked from the
	summary buffer.

	* imail/imail-summary.scm[1.30]:
	Only create buffer-layout when summary buffer is created, not when it
	is being reused.

	* edwin/rfc822.scm[3.3]:
	Fix bugs in address parsing, reported by hal.

	* edwin/curren.scm[1.135]:
	Don't call MAYBE-SELECT-BUFFER-LAYOUT unless the selected buffer has
	really changed.

	* imail/imail-summary.scm[1.29], imail/imail-top.scm[1.218],
	  imail/imail.pkg[1.77]:
	Delete imail-auto-summary feature.  Instead implement
	imail-summary-fixed-layout feature that uses new buffer-layout
	mechanism.

	* edwin/curren.scm[1.134]:
	Move call to MAYBE-SELECT-BUFFER-LAYOUT outside of WITHOUT-INTERRUPTS.
	Also call MAYBE-SELECT-BUFFER-LAYOUT from MAKE-SCREEN.

	* edwin/curren.scm[1.133]:
	Fix indentation.

	* edwin/wincom.scm[1.129]:
	Fix thinko.

	* edwin/curren.scm[1.132]:
	Don't reselect an already-selected window or buffer.

	* edwin/wincom.scm[1.128]:
	Implement SCREEN option to POP-UP-BUFFER.

	* edwin/curren.scm[1.131]:
	Eliminate references to SELECT-BUFFER-IN-WINDOW.  Change buffer-layout
	mechanism so that it is called _after_ the initial buffer is selected.

	* edwin/buffrm.scm[1.58], edwin/bufmnu.scm[1.131],
	  edwin/debug.scm[1.52], edwin/snr.scm[1.59], edwin/vc.scm[1.74]:
	Eliminate references to SELECT-BUFFER-IN-WINDOW.

	* edwin/curren.scm[1.130]:
	Guarantee that all buffers in a buffer layout are alive at the time of
	selection.

	* edwin/curren.scm[1.129]:
	Add some interrupt locking to buffer-layout mechanism.  Fix thinko.

	* edwin/make.scm[3.103]:
	Update version to reflect new initialization mechanism.

	* imail/imail-top.scm[1.217]:
	Comment out call to ADD-PRE-SELECT-BUFFER-HOOK.  This procedure is
	about to be removed from Edwin.  It will shortly be replaced by a
	different mechanism.

	* edwin/curren.scm[1.128]:
	Eliminate pre-select-buffer-hooks mechanism from previous change.
	This turns out not to work quite right for the problem at hand.
	Instead implement a buffer-layout mechanism that should solve the
	problem more neatly.

	* edwin/comred.scm[1.121], edwin/dosproc.scm[1.5],
	  edwin/editor.scm[1.249], edwin/edwin.pkg[1.264],
	  edwin/input.scm[1.102], edwin/intmod.scm[1.110],
	  edwin/process.scm[1.58], edwin/prompt.scm[1.189]:
	Implement general mechanism for initializing editor state when editor
	is created.

2000-10-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/curren.scm[1.127]:
	Add pre-selection buffer hooks.  These hooks allow a buffer to
	intercede in its selection.

2000-10-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail.pkg[1.76]:
	Forgot to export a couple of variables to implement auto-summary.

	* imail/imail-summary.scm[1.28]:
	Implement new editor variable imail-summary-height to allow the user
	to specify the height of the summary buffer.  Normally this is set to
	1/4 making the summary 1/4 the height of the screen.

	* edwin/wincom.scm[1.127]:
	Add option to POP-UP-BUFFER to allow the argument to
	WINDOW-SPLIT-VERTICALLY! to be supplied.

	* imail/imail-top.scm[1.216], imail/imail.pkg[1.75]:
	Add new editor variable imail-auto-summary that allows a summary
	buffer to be automatically selected whenever an imail buffer is.

	* imail/imail-rmail.scm[1.52]:
	Fix bug: FLAGS->RMAIL-MARKERS was clobbering its argument to remove
	the "seen" flag.  This caused messages to be marked "unseen" when they
	were written to an RMAIL file.

	* imail/imail-core.scm[1.114], imail/imail-rmail.scm[1.51],
	  imail/imail-umail.scm[1.40]:
	Fix bug: WRITE-HEADER-FIELDS was generating the blank-line separator,
	but all of the callers assumed that it wasn't.  So messages were being
	written with an extra newline.

2000-10-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-umail.scm[1.39]:
	Deal with errors coming from CTIME-STRING->UNIVERSAL-TIME.  Add option
	to WRITE-UMAIL-MESSAGE to suppress the IMAIL flags.

	* runtime/datime.scm[14.33]:
	Allow ctime() input strings to lack seconds field.  This isn't
	strictly correct but occurs sometimes on unix-mail from lines.

2000-10-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/uxsock.c[1.25]:
	FreeBSD doesn't define socklen_t; add conditional definition.

2000-10-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* etc/Attic/bootstrap.sh[1.4]:
	Fix some typos.  Adjust script so that it can be called again on a
	partially-processed tree.

	* etc/Attic/bootstrap-compile.scm[1.7]:
	Load CREF only if not already loaded.

	* etc/Attic/build-tree.sh[1.4]:
	Add back stuff for unsupported directories.

	* etc/Attic/bootstrap.sh[1.3]:
	Extensive changes to integrate microcode compilation into the script.

	* microcode/unxutl/Attic/cf-dist.h[1.25]:
	If using gcc, optimize and generate debugging info.

	* microcode/unxutl/Attic/cf-dist.h[1.24]:
	Generate optimized code by default.

	* etc/Attic/bootstrap-compile.scm[1.6],
	  etc/Attic/bootstrap-compile.scm[1.5]:
	Forgot to load CREF.

	* etc/Attic/bootstrap-compile.scm[1.4]:
	Fix typo.

	* etc/Attic/bootstrap-compile.scm[1.3], etc/Attic/bootstrap.sh[1.2]:
	Load files using stdin redirection.

	* etc/Attic/bootstrap-compile.scm[1.2]:
	Must load CREF before compiling other stuff.

	* etc/Attic/bootstrap-compile.scm[1.1], etc/Attic/bootstrap.sh[1.1],
	  etc/Attic/build-compiler.scm[1.1], etc/Attic/build-edwin.scm[1.1],
	  etc/Attic/build-runtime.scm[1.1]:
	Initial revision.

	* etc/optiondb.scm[1.2]:
	CREF loader not needed after all.

	* etc/Attic/build-tree.sh[1.3]:
	Eliminate unsupported directories.

	* etc/Attic/build-tree.sh[1.2]:
	Add copyright notice.

	* etc/Attic/build-tree.sh[1.1]:
	Imported from /scheme/etc/.

	* etc/optiondb.scm[1.1]:
	Moved from dist directory.

	* microcode/option.c[1.54], microcode/version.h[11.174]:
	If no band is explicitly specified, and the default band doesn't
	exist, look for alternatives.

2000-10-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* runtime/version.scm[14.188]:
	Update version number of runtime system to reflect change to semantics
	of internal definitions.  Update release number because it's time to
	do another release.

	* runtime/lambda.scm[14.16], runtime/lambdx.scm[14.9]:
	Eliminate old optimization that reused lambda parameters for internal
	definitions of the same name.  This needlessly complicated the
	semantics, and the optimization is no longer interesting (if it ever
	was).
	
	Thanks to the 6.001 staff for bringing this to my attention.

2000-10-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* microcode/uxsock.c[1.24]:
	Fix bug: when a call to connect gets EINTR, one can't just restart the
	connect, because it might be waiting for a packet from the other end
	of the connection.  Instead, it's necessary to wait for the connect to
	finish (using select), and then check the SO_ERROR option to see if it
	succeeded or failed.

	* microcode/x11base.c[1.75]:
	In X-WINDOW-CLEAR, if the clip rectangle is disabled, call
	XClearWindow rather than XClearArea.  This clears pixels in internal
	border, if any.

	* microcode/x11term.c[1.27]:
	Fix bug: xterm_dump_rectangle, when given the coordinates of a window
	that wasn't exactly a multiple of the character size, would dump
	characters at the edges of the window.  Instead, it must clip the
	rectangle to the character size of the window.

	* edwin/vc.scm[1.73]:
	Fix bug: can't ever use absolute pathnames with CVS, because if
	repository is remote they don't make sense.

2000-09-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-summary.scm[1.27]:
	When using imail-summary-scroll-msg-* commands, if the message buffer
	and summary buffer have different messages selected, change the
	message buffer to match the summary buffer.

	* imail/imail-top.scm[1.215]:
	Don't count a message as unseen if it is deleted -- even if the SEEN
	flag isn't set.  It's common to delete messages without seeing them,
	and the act of deletion is an indication that the user isn't
	interested in seeing them.
	
	However, don't mark these messages as seen; they might later be
	undeleted, in which case they want to retain their unseen status.

2000-09-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.111]:
	Note regarding parsing in the presence of Rmail file corruption.

2000-09-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-rmail.scm[1.50]:
	Make sure that Rmail messages have an internal time, even if it's
	completely bogus.

	* runtime/datime.scm[14.32]:
	Compensate for old message data format that lacked seconds.

	* runtime/datime.scm[14.31]:
	Add workaround for very old arpanet message date format.

	* edwin/modefs.scm[1.160]:
	Bind VC keys only if VC is loaded.

2000-09-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.214]:
	Add UTF-8 to list of known charsets.

2000-09-06  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.213], imail/imail-top.scm[1.212]:
	Tweak adaptive-fill-regexp so that it accepts prefixes of the form "> >".

	* edwin/fill.scm[1.70], edwin/tparse.scm[1.75], edwin/tparse.scm[1.74]:
	Extensive redesign of OPERATE-ON-INDIVIDUAL-PARAGRAPHS, to treat
	regions with different fill prefixes as separate paragraphs.  This is
	similar to what Emacs does but not exactly the same: we are more
	strict about noticing prefix changes.

	* edwin/htmlmode.scm[1.4], edwin/tparse.scm[1.73],
	  edwin/tximod.scm[1.24]:
	Change paragraph-separate and paragraph-start so that they will work
	when not at a line start.  This is necessary so that they interact
	properly with fill prefixes.

	* edwin/fill.scm[1.69]:
	Undo previous change -- it wasn't equivalent code.

	* edwin/fill.scm[1.68]:
	Simplify overly-complex logic.

2000-08-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/vc.scm[1.72]:
	Change VC-BACKEND-LOCKING-USER so that it doesn't call
	VC-WORKFILE-MODIFIED?.  The problem is that the latter can call
	VC-BACKEND-DIFF, which requires access to the CVS server.  However,
	since VC-BACKEND-LOCKING-USER is called by VC-MODE-LINE, this meant
	that every time the mode-line changed, we had to probe the server.
	This patch eliminates that requirement.
	
	The patch also tries to notice the results of user-initiated diffs,
	and update the mode-line's idea of whether the file is modified.
	However, Emacs doesn't seem to behave quite the same way.  Maybe this
	is a bad idea and should be reverted.

2000-08-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* rcs/load.scm[1.2]:
	Now need regular expressions.

	* rcs/logmer.scm[1.27]:
	Add code to strip off remote-repository prefix in "CVS/Root" files.
	This assumes that the repository is actually local but is being
	accessed using a remote mechanism.
	
	The right thing to do might be to generate the log using cvs and then
	merge it, but this is quite a pain.

2000-08-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/vc.scm[1.71]:
	Eliminate use of absolute pathnames in CVS commands; this precludes
	use of remote access methods.

	* imail/imail-file.scm[1.59]:
	Fix bug: copying messages from IMAP folder to umail folder didn't
	work, because that operation depended on being able to get the message
	body as a string.  But the operation that provided the message body in
	that format was eliminated.

	* microcode/uxio.c[1.44]:
	Don't use POLLNORM; use POLLIN instead.

2000-08-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/info.scm[1.135]:
	Fix bug: directory node wasn't being correctly recorded in the info
	history, causing the l command to fail.

	* imail/load.scm[1.20]:
	Update version to reflect changes to imail-summary keyboard bindings.

	* imail/imail-summary.scm[1.26]:
	Fix scrolling in summary buffer to be more like that of Rmail.  Move
	M-x imail-summary-select-message to #\e rather than #\space, since
	#\space and #\rubout are needed by the scrolling commands.

2000-08-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-file.scm[1.58], imail/imail-imap.scm[1.144]:
	Fix over-long pages.

	* imail/imail-core.scm[1.113], imail/imail-file.scm[1.57],
	  imail/imail-imap.scm[1.143], imail/imail-summary.scm[1.25]:
	Add new folder operation, PRELOAD-FOLDER-OUTLINES, which is a hint to
	the folder implementation that the front end is about to request
	header and length information for all messages in the folder.  This
	allows the folder to choose a more-optimal download strategy.  The
	operation is invoked by the folder-summary code.
	
	Ad-hoc testing indicates that this has a qualitative effect on
	performance for folders containing about 100 or more messages.

2000-08-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.142]:
	Additional optimization: load flags with UIDs in initial download.

	* imail/imail-imap.scm[1.141]:
	Change slot reflectors: previously we loaded flags, length, and
	headers for all messages when opening a folder and displaying it.
	This took a long time for medium-sized folders.  Now, load each of
	these components separately.  In particular, only the flags are needed
	for most messages, so this considerably speeds up the initial load.

2000-07-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/abbrev.scm[1.5], edwin/bufmnu.scm[1.130],
	  edwin/debug.scm[1.51], edwin/os2.scm[1.50], edwin/sendmail.scm[1.68],
	  edwin/unix.scm[1.109], edwin/vc.scm[1.70], edwin/webster.scm[1.5],
	  edwin/wincom.scm[1.126], imail/imail-summary.scm[1.24]:
	Change POP-UP-BUFFER in several ways: (1) SELECT? argument is now
	required; (2) optional argument NOT-CURRENT-WINDOW? has been replaced
	by a list of option symbols; (3) when popping into an existing window,
	if it's the previously popped-up window, it's returned.

2000-07-21  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.211]:
	Fix bug: allow user to specify no confirmation.

2000-07-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/sendmail.scm[1.67]:
	Make sure continuation lines of mail-buffer headers are properly
	indented.

2000-07-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.210]:
	Change key binding of imail-summary-by-flags to be C-M-l for
	compatibility with Rmail.

2000-07-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* rcs/logmer.scm[1.26]:
	Another newline-convention tweak.

	* rcs/mklogs.scm[1.20]:
	Add imail documentation directory.

	* imail/imail-imap.scm[1.140]:
	Suppress user name in IMAP URL when it is same as current uname.

2000-07-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/Attic/rexp.scm[1.15], runtime/rexp.scm[1.15]:
	Fix harmless bug in REXP?

2000-07-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.139]:
	Don't fire up IMAP connection just to determine container string of
	URL.  Instead, use namespace info only if already available.
	Consequently restructure code that looks up/creates connections.

2000-07-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/sendmail.scm[1.66]:
	Read non-text attachments in binary mode.

	* imail/imail-top.scm[1.209]:
	Use new GLOBAL-MAILER-VERSION-STRING.

	* edwin/edwin.pkg[1.263], edwin/sendmail.scm[1.65]:
	Add GLOBAL-MAILER-VERSION-STRING.

	* imail/imail-file.scm[1.56]:
	Fix bug in file URL parsing for DOS-style pathnames.

	* imail/imail-file.scm[1.55]:
	Add URL encode/decode to file URLs.  Fix typo in
	HEADER-FIELDS->INTERNAL-TIME.

	* imail/imail-rmail.scm[1.49], imail/imail-umail.scm[1.38]:
	Fix bug: code to create new file folders wasn't writing the folders
	out.

	* imail/imail-file.scm[1.54], imail/imail-file.scm[1.53],
	  imail/imail-rmail.scm[1.48], imail/imail-umail.scm[1.37],
	  imail/todo.txt[1.110]:
	Change file URL syntax to obey RFC 1738.

	* runtime/pathnm.scm[14.33], runtime/runtime.pkg[14.355]:
	Define procedure HOST/TYPE-NAME.

	* imail/imail-top.scm[1.208]:
	In M-x imail-get-new-mail (and M-x imail), move to first unseen
	message even if the server probe reveals no new mail.  This is
	important because the new mail is usually fetched by the background
	probe thread.

	* imail/imail-imap.scm[1.138]:
	Reduce the traffic generated by completion code to determine if a
	mailbox has inferiors or not.

	* imail/imap-syntax.scm[1.16]:
	Fix thinkos in mailbox-decoding procedure.

	* imail/imap-syntax.scm[1.15]:
	Fix thinko in previous change.

	* imail/imap-syntax.scm[1.14]:
	Fix some bugs in the IMAP URL parser.

	* imail/imail-top.scm[1.207]:
	When examining prompt history, ignore malformed URLs that generate
	errors during parsing.

	* imail/imap-syntax.scm[1.13]:
	Fix bugs in IMAP mailbox encode/decode procedures.

	* imail/imail-imap.scm[1.137]:
	Add calls to mailbox encode/decode procedures.  These should have been
	put in long ago.

	* imail/imail.pkg[1.73]:
	Export mailbox-name encode/decode procedures.

	* imail/imap-syntax.scm[1.12]:
	Change mailbox-name encode/decode to accept either string or substring.

	* imail/ed-ffi.scm[1.13]:
	Adjust to reflect new packaging structure.

	* imail/imail.pkg[1.74], imail/imail.pkg[1.72]:
	"imail-umail" and "imail-rmail" should be in subfolders of
	"imail-file".

2000-07-04  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.206]:
	Fix infinite loop that occurs when expunging all messages in folder.

2000-07-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-response.scm[1.41], imail/imap-response.scm[1.40]:
	Seriously simplify READ-LITERAL-TO-PORT by eliminating extra layer of
	buffering.

	* imail/imap-response.scm[1.39]:
	Tweak.

	* imail/imap-response.scm[1.38]:
	Canonicalize argument order to list-reading procedures.

	* imail/imap-response.scm[1.37]:
	Fix two typos in READ-SET.

2000-07-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/url.scm[1.8], runtime/Attic/url.scm[1.8]:
	Fix two typos.

	* imail/todo.txt[1.109]:
	Trim some unnecessary items.

2000-07-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail.pkg[1.71], imail/todo.txt[1.108]:
	Redesign packaging to break up the monolithic core.  There isn't very
	much cross-reference between these files.

2000-06-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/load.scm[1.19], runtime/version.scm[14.187]:
	Update version to reflect impending release.

	* edwin/make.scm[3.102]:
	Update version to reflect changes to support IMAIL.

	* imail/imail-top.scm[1.205], imail/imail-top.scm[1.204]:
	Don't inline text/plain entities that have disposition ATTACHMENT.

	* edwin/sendmail.scm[1.64]:
	File attachments should always have a disposition of ATTACHMENT.

	* imail/imail-imap.scm[1.136], imail/imail.pkg[1.70],
	  imail/imap-response.scm[1.36], imail/todo.txt[1.107]:
	Integrate MIME decoding into reading of MIME body parts.
	Large attachments are now read directly into files.

	* imail/imail-imap.scm[1.135], imail/imail-top.scm[1.203]:
	Change definition of CACHE? argument to WRITE-MIME-MESSAGE-BODY-PART.
	Now it may take the following values:
	
	#F	don't cache
	#T	cache
	<n>	conditionally cache; length of part is <n>

	* imail/imail-imap.scm[1.134]:
	Generalize IMAP:CATCH-NO-RESPONSE and use it in %APPEND-MESSAGE.

	* imail/imail-core.scm[1.112], imail/imail-file.scm[1.52],
	  imail/imail-imap.scm[1.133]:
	Eliminate unused AVAILABLE-FOLDER-NAMES.  This capability is available
	from the completion operations.

	* imail/imail-imap.scm[1.132]:
	Fix bug that caused server greeting to be thrown away.  Change
	handling of delimiter and namespace information, so that they are
	set by the front end rather than that back end.

	* imail/imail-imap.scm[1.131]:
	Now that IMAP URLs use a slash delimiter, I think it looks better to
	use the base name as the name of the buffer.

	* imail/todo.txt[1.106]:
	Reprioritize list.  Change category of APPEND-MESSAGES.  Eliminate
	proposed option to quote original in replies using MIME.

	* imail/todo.txt[1.105]:
	Don't bother with support for compressed mail files.  This isn't as
	important as I thought it was.

	* imail/todo.txt[1.104]:
	Don't do anything special with "flagged" flag.

	* imail/imail-file.scm[1.51]:
	Fix bug: file completion wasn't working right if the pathname being
	completed ended in a directory separator.

	* imail/imail-file.scm[1.50], imail/imail-rmail.scm[1.47],
	  imail/imail-umail.scm[1.36]:
	Simplify handling of file-URL completion: this is now identical for
	all file URLs, so have only one method for that class.

	* imail/imail-rmail.scm[1.46], imail/imail-umail.scm[1.35],
	  imail/todo.txt[1.103]:
	Modify RMAIL file reader to handle mixed RMAIL/umail files, as does
	the real RMAIL.  We don't bother with MMDF format, since that isn't
	used by any real systems any longer.

2000-06-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/print.sh[1.8]:
	Change presentation order to place IMAP implementation ahead of file
	implementation.

	* imail/imail-core.scm[1.111], imail/imail-rmail.scm[1.45],
	  imail/imail-top.scm[1.202], imail/imail-util.scm[1.29],
	  imail/todo.txt[1.102]:
	Revise representation of header-field objects, so that RFC-822 quoting
	mechanism isn't part of the representation.  Value string of a header
	is now arbitrary text, and there is an explicit mechanism for
	converting the header value to RFC-822 format, by prepending tabs onto
	continuation lines.
	
	Additionally, there should no longer be any possibility of a low-level
	error being generating when parsing header fields of incoming messages.

	* imail/imail-imap.scm[1.130]:
	Change IMAP URLs to use / instead of server delimiter.

	* imail/imail-imap.scm[1.129]:
	Assume that heirarchy delimiter and NAMESPACE information never
	change.  Once information is cached, never erase it.

	* imail/imail-imap.scm[1.128]:
	Reduce extent of a few calls to WITH-OPEN-IMAP-CONNECTION.  Fix
	missing method specialization.

	* imail/imail-top.scm[1.201]:
	Clarify selector-interpretation logic in SELECT-MESSAGE.

	* imail/imail-top.scm[1.200]:
	Fix pagination.

	* imail/imail-imap.scm[1.127], imail/todo.txt[1.101]:
	Fix IMAP URL completion so that folders that both are selectable and
	have subfolders appear twice in the completions list, once with the
	hierarchy delimiter, and once without.

	* imail/todo.txt[1.100]:
	Note about making IMAP URL completion handle folders that contain both
	messages and subfolders.

2000-06-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.199], imail/imail.pkg[1.69]:
	Restrict M-x imail-save-attachment to work only on attachments, not on
	in-line MIME parts.  Implement M-x imail-mouse-save-mime-entity and
	M-x imail-save-mime-entity.  Rename M-x imail-toggle-attachment to M-x
	imail-toggle-mime-entity.

	* imail/imail-top.scm[1.198], imail/imail-top.scm[1.197]:
	Decode BinHex 4.0 attachments.

	* runtime/mime-codec.scm[14.8]:
	Add code to extract the data fork from a BinHex 4.0 input stream.
	BinHex support is now complete.

	* runtime/mime-codec.scm[14.7]:
	Implement more flexible rule for matching initial comment and colon of
	BinHex input.

	* runtime/mime-codec.scm[14.6]:
	Change terminology: BinHex "decompression" -> "run-length decoding".

	* imail/imail-top.scm[1.196]:
	Change behavior of M-x imail-forward so that negative argument means
	send with raw headers.  Eliminate MIME-ONLY value of
	imail-forward-all-headers, as it's no longer needed.

	* imail/imail-top.scm[1.195]:
	Fix bug: key binding for M-x imail-toggle-message was already in use.

2000-06-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.194]:
	Move MIME-decoding output ports to runtime system.

	* runtime/mime-codec.scm[14.5], runtime/runtime.pkg[14.354]:
	Implement BinHex decompressor.

	* imail/imail-top.scm[1.193], imail/imail.pkg[1.68],
	  imail/todo.txt[1.99]:
	Show message in modeline of all buffers when there is unseen mail.
	Variable imail-global-mail-notification controls this feature.

	* imail/imail-top.scm[1.192], imail/imail-top.scm[1.191]:
	When prompting for MIME info, if there's only one choice, don't bother
	prompting.

	* imail/imail-top.scm[1.190], imail/imail.pkg[1.67],
	  imail/todo.txt[1.98]:
	Implement M-x imail-toggle-attachment, which allows any part of a
	MIME-encoded message to be toggled between "in-line" and "out-of-line"
	format.  This is most useful for expanding small text attachments
	without writing them to a file first.

	* edwin/simple.scm[1.52], edwin/simple.scm[1.51]:
	Add additional procedures for searching through the space of text
	properties.

	* imail/imail-top.scm[1.189], imail/imail.pkg[1.66],
	  imail/todo.txt[1.97]:
	Implement variable imail-mime-show-alternatives.

2000-06-24  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.110], imail/imail-imap.scm[1.126],
	  imail/imail-top.scm[1.188]:
	Fix bug: when current message and subsequent messages simultaneously
	deleted, was signalling an error, because the EXPUNGE responses were
	being processed one at a time, and the local model of the folder was
	out of sync with the server's model.  New strategy defers dealing with
	all of these changes until all of the responses have been processed,
	at which time both models are again synchronized.

	* imail/imail-top.scm[1.187], imail/imail-top.scm[1.186]:
	Fix problem with previous change: shouldn't automatically select new
	message when folder grows.  Instead, stay on current message unless
	it is deleted.

2000-06-23  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-file.scm[1.49], imail/imail-file.scm[1.48],
	  imail/imail-rmail.scm[1.44], imail/todo.txt[1.96]:
	Preserve internal time when copying to rmail folder from any other
	type of folder, by writing a distinguished header field into the rmail
	file.

	* imail/imail-imap.scm[1.125], imail/imail-top.scm[1.185],
	  imail/todo.txt[1.95]:
	Fix bug: when IMAP mailbox simultaneously accessed from two places,
	IMAIL wouldn't correctly update the message buffer under a variety of
	circumstances.  This turned out to be a confluence of several bugs in
	the code.

	* imail/imail-imap.scm[1.124]:
	Fix fencepost error.

	* imail/imail-core.scm[1.109]:
	Add folder events to IMAP trace facility.

	* imail/imail-top.scm[1.184]:
	Extend imail-forward-all-headers to have value MIME-ONLY.

2000-06-22  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.183]:
	Mail buffer must have adaptive-fill regexps adjusted so that C-M-y
	works right.

	* imail/imail-top.scm[1.182], imail/todo.txt[1.94]:
	Use new hook to modify the "User-Agent" header.

	* edwin/sendmail.scm[1.63]:
	Change "X-Mailer" to "User-Agent"; add hook to allow mail reader to
	modify this string.

	* runtime/ed-ffi.scm[1.24]:
	Add missing entry for mime-codec.

	* runtime/mime-codec.scm[14.4], runtime/runtime.pkg[14.353],
	  runtime/runtime.pkg[14.352], runtime/runtime.pkg[14.351]:
	First cut at BinHex support.  This just does the decoding, without
	understanding the structure of the data stream.

2000-06-20  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.93]:
	Note regarding bug with multiple simultaneous access.

	* imail/imail-rmail.scm[1.43]:
	Tweak layout.

	* imail/imail-core.scm[1.108], imail/imail-file.scm[1.47]:
	Define HEADER-FIELD-LENGTH.

	* imail/imail-file.scm[1.46], imail/imail-rmail.scm[1.42],
	  imail/imail-umail.scm[1.34], imail/todo.txt[1.92]:
	Allow file completion to complete to any file.

	* imail/imail-core.scm[1.107]:
	Repaginate.

	* imail/imail-core.scm[1.106]:
	Allow arbitrary whitespace in IMAIL flags header, so that flags lines
	can be folded.

	* imail/todo.txt[1.91], imail/todo.txt[1.90]:
	Expand on note regarding header-field representation.

	* imail/imail-summary.scm[1.23]:
	Fix some thinkos.

	* imail/imail-top.scm[1.181]:
	Simplify decision tree in CALL-WITH-AUTO-WRAPPED-OUTPUT-MARK.

	* imail/imail-top.scm[1.180]:
	Share similar code from IMAIL-YANK-ORIGINAL and SELECT-MESSAGE.

	* imail/imail.pkg[1.65]:
	Export M-x imail-toggle-header.

	* imail/imail-top.scm[1.179]:
	Redefine variable imail-mime-attachment-directory to be an override of
	the default behavior, which is to track the last directory written to.

	* imail/imail-top.scm[1.178]:
	Share code that copies all messages from one folder to another.

	* imail/imail-top.scm[1.177]:
	Fix typo.

	* imail/imail-top.scm[1.176]:
	Change binding of imail-toggle-message to #\c-t.

	* imail/imail-top.scm[1.175]:
	Fix bug: last change to IMAIL-MODE-LINE-SUMMARY-STRING had thinko that
	caused an error when viewing an empty mailbox.

2000-06-19  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.89]:
	Add some new ideas from one of the reviews.

	* imail/imail-top.scm[1.174]:
	Always show message counts and folder length in modeline.  It's
	confusing to omit this.

	* imail/imail-core.scm[1.105], imail/imail-top.scm[1.173]:
	Change definition of GET-ALL-HEADER-FIELD-VALUES to return a list of
	strings, rather than a comma-separated string.

	* edwin/pwedit.scm[1.8]:
	Rework handling of buffer properties so that command to toggle
	password field works anywhere in the field.

	* imail/imail-imap.scm[1.123]:
	Fix bug: when fetching MIME message part, must guarantee that the
	connection is open.

	* imail/imail-top.scm[1.172], imail/todo.txt[1.88]:
	Reimplement M-x imail-toggle-header (in addition to
	imail-toggle-message).

	* imail/imail-top.scm[1.171], imail/todo.txt[1.87]:
	Fix code that yanks original message into reply buffer.  Now the
	yanked code looks just like the formatted code in the original
	buffer, except that there are no attachments, and the line wrapping is
	adjusted to account for the indentation.

	* imail/clean.sh[1.2]:
	Fix typo.

	* imail/todo.txt[1.86]:
	New strategy for yanking MIME messages into reply buffer.

	* imail/imail-core.scm[1.104], imail/imail-file.scm[1.45],
	  imail/imail-imap.scm[1.122], imail/imail-rmail.scm[1.41],
	  imail/imail-umail.scm[1.33]:
	Change interface for retrieving message bodies so that the body isn't
	always returned as a string, but instead is written to a port.  This
	will allow IMAP message to write their bodies directly to files, which
	is especially important for bodies that are too large to fit in memory.

	* imail/imail-top.scm[1.170]:
	Fix bug: empty folder wasn't noticing new messages being added.

	* imail/imail-top.scm[1.169]:
	Fix bug: when expunging last message in folder, IMAIL was generating
	an error.

	* imail/imail-util.scm[1.28]:
	Simplify implementation of broken-pipe handler so that parts can be
	reused.

	* imail/imail-imap.scm[1.121]:
	Redo previous fix; was shutting down connection in cases where it
	shouldn't have.

2000-06-18  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-core.scm[1.103], imail/imail-top.scm[1.168],
	  imail/imail.pkg[1.64]:
	A handful of bug fixes, plus some clarifications.

	* edwin/prompt.scm[1.188], edwin/prompt.scm[1.187]:
	Change PROMPT-HISTORY-STRINGS and SET-PROMPT-HISTORY-STRINGS! so that
	the history name may be #F, meaning use the default history.

2000-06-17  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.85]:
	Note re imail-toggle-headers.

2000-06-16  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.167]:
	Fix thinko.

	* imail/imail-summary.scm[1.22], imail/imail-top.scm[1.166],
	  imail/imail-top.scm[1.165], imail/imail-top.scm[1.164],
	  imail/imail.pkg[1.63], imail/load.scm[1.18]:
	Large-scale editing pass over the front-end code.  Code should now be
	clearer and better organized.

	* imail/imail-core.scm[1.102], imail/imail-file.scm[1.44],
	  imail/imail-rmail.scm[1.40]:
	Eliminate notes that have been moved to todo file.

	* edwin/sendmail.scm[1.62]:
	Set NAME parameter on MIME file attachments.  Change key bindings in
	attachment browser; shouldn't use #\- for a command.

	* imail/imail-core.scm[1.101], imail/imail-file.scm[1.43]:
	Change status symbol FOLDER-MODIFIED to CACHE-MODIFIED.

2000-06-15  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/print.sh[1.7]:
	Remove rfc822.scm from printout.

	* imail/imail-top.scm[1.163]:
	Don't add gratuitous newlines to message presentation.

	* edwin/sendmail.scm[1.60]:
	Add attachments in time order; previous was reversed.

	* imail/imap-response.scm[1.35]:
	Be very careful not to read beyond the end of a literal, as this might
	hang.

	* imail/imail-imap.scm[1.120]:
	If IMAP command doesn't complete normally, close the connection.

	* edwin/edwin.pkg[1.262], edwin/sendmail.scm[1.59]:
	Implement MIME attachment browser, with commands to add and delete
	attachments.

	* edwin/sendmail.scm[1.58]:
	Implement mime-attachments buffer for editing message attachments.

	* imail/imail-top.scm[1.162]:
	Respect INLINE disposition if present.

	* imail/imail-imap.scm[1.119]:
	Fix bug: don't try to send LOGOUT command when socket is closed.

	* imail/imail-summary.scm[1.21]:
	Fix harmless typo.

	* imail/imail-top.scm[1.161], imail/imail-top.scm[1.160],
	  imail/imail.pkg[1.62], imail/todo.txt[1.84]:
	Implement variable imail-inline-mime-text-subtypes.

	* imail/imail-top.scm[1.159], imail/imail.pkg[1.61]:
	Implement M-x imail-first-unseen-message.

	* imail/todo.txt[1.83]:
	Made changes to mime-codec to improve speed of quoted-printable
	decoder.

	* runtime/mime-codec.scm[14.3]:
	Use substring search to speed up quoted-printable decoder.

	* imail/todo.txt[1.82]:
	Potpourri of notes, and new section on MIME conformance.

	* imail/todo.txt[1.81]:
	Note regarding integration of MIME decoding into the MIME body reader.

	* edwin/fill.scm[1.67], edwin/fill.scm[1.66]:
	Fix fencepost error.

	* imail/imail-top.scm[1.158]:
	Use new line-wrapping facility in Edwin.  Hopefully this will be fast
	enough to eliminate tedious delay of previous implementation.

	* edwin/fill.scm[1.65]:
	Implement procedures to wrap lines in paragraphs.

	* edwin/sendmail.scm[1.61], imail/imail-summary.scm[1.20]:
	Fix typo.

	* imail/imail-summary.scm[1.19], imail/imail-top.scm[1.157],
	  imail/imail.pkg[1.60], imail/imail.pkg[1.59]:
	Implement new commands:
		imail-bury
		imail-next-same-subject
		imail-previous-same-subject

	* imail/imail-summary.scm[1.18], imail/imail-top.scm[1.156],
	  imail/imail.pkg[1.58]:
	Implement M-x imail-summary-by-regexp and M-x imail-summary-by-topic.
	Latter doesn't support WHOLE-MESSAGE option of Emacs because that
	would be dreadfully inefficient using IMAP.

	* imail/imail-top.scm[1.155]:
	In description for imail-mode, don't show variables for
	imail-summary-mode.  Also, show value for each variable.

	* imail/imail-top.scm[1.154]:
	Reconcile the key bindings with those of RMAIL in Emacs version 20.
	Use new dynamically-generated help string feature of Edwin to generate
	the mode description for imail-mode.

	* edwin/hlpcom.scm[1.118]:
	Extend help output procedures to accept a port as an argument.

	* edwin/comman.scm[1.84], edwin/docstr.scm[1.5], edwin/docstr.scm[1.4],
	  edwin/edwin.ldr[1.72], edwin/edwin.ldr[1.71],
	  edwin/hlpcom.scm[1.120], edwin/hlpcom.scm[1.119],
	  edwin/hlpcom.scm[1.117], edwin/modes.scm[1.33],
	  edwin/prompt.scm[1.186]:
	Allow description of a command, variable, or mode to be a thunk that
	evaluates to a string.

2000-06-14  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.80]:
	Add two suggestions from radhi.

	* imail/imail-top.scm[1.153], imail/imail.pkg[1.57]:
	Always inline top-level MIME text parts, even if the subtype isn't
	"plain".  Also, define new variable imail-known-mime-charsets, to
	allow the user to add other character sets that may be inlined.

	* imail/imail-imap.scm[1.118]:
	Change IMAP URL completion to work more like filename completion:
	completion shows only the elements at the top level of the mailbox
	being completed on.  Furthermore, non-selectable mailboxes are
	suffixed with the heirarchy delimiter to cue the user.

	* edwin/sendmail.scm[1.57]:
	Don't abbreviate MIME header fields in the header; only in subparts of
	a multipart message.

	* imail/imail-top.scm[1.152], imail/imail.pkg[1.56],
	  imail/todo.txt[1.79]:
	Implement variable imail-forward-using-mime to allow the user to
	disable the use of MIME for message forwarding.

	* imail/imail-core.scm[1.100], imail/imail-file.scm[1.42],
	  imail/imail-imap.scm[1.117], imail/imail-rmail.scm[1.39],
	  imail/imail-top.scm[1.151], imail/imail-umail.scm[1.32],
	  imail/todo.txt[1.78]:
	When renaming a folder, the default for the target is the container
	for the source.  When copying a folder, the default for the target is
	the base name of the source, merged into the container of the most
	recent copy target.

2000-06-13  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.150], imail/todo.txt[1.77]:
	Change M-x imail-get-new-mail so that it selects the first unseen
	message, or does nothing otherwise.  This will be more robust when
	resynchronizing the folder, and will also provide a command to move to
	the first unseen message.

2000-06-12  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.149], imail/imail.pkg[1.55]:
	Implement variable imail-forward-all-headers.

	* edwin/edwin.pkg[1.261], edwin/sendmail.scm[1.56]:
	Add new variable mail-abbreviate-mime to control verbosity of MIME
	headers generated.

	* edwin/sendmail.scm[1.55]:
	Fix typo: "Content-Encoding" -> "Content-Transfer-Encoding".

	* edwin/edwin.pkg[1.260], edwin/sendmail.scm[1.54],
	  edwin/snr.scm[1.58], imail/todo.txt[1.76]:
	Insert X-Mailer and Organization fields after user finished editing
	message, rather than cluttering up the user's buffer with them.

	* imail/imail-top.scm[1.148]:
	Fix bug: imail-resend not selecting buffer.

2000-06-11  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/mousecom.scm[1.5]:
	Use recommended scrolling of 5 lines rather than 10.

	* edwin/modefs.scm[1.159], edwin/mousecom.scm[1.4]:
	Add hack to utilize mouse wheel under X.

	* imail/imail-summary.scm[1.17]:
	Add bindings for up/down arrow keys, for mouse button one, and for
	mouse buttons 4 and 5 (scroll buttons on wheel mice).

2000-06-10  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.116], imail/todo.txt[1.75]:
	Use NAMESPACE information to setup prefix to URL prompts.

	* imail/imail-imap.scm[1.115], imail/imail.pkg[1.54],
	  imail/imap-response.scm[1.34]:
	If server supports the NAMESPACE extension, use it to get namespace
	information and store it in the connection object.

	* imail/todo.txt[1.74]:
	Note re: NAMESPACE feature.

2000-06-09  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/todo.txt[1.73]:
	Potpourri.

	* imail/todo.txt[1.72]:
	Note to change handling of "informational" headers in sent mail.

	* imail/imail-top.scm[1.147], imail/imail.pkg[1.53]:
	Eliminate variable imail-receive-mime.  User can toggle message to raw
	form to get similar effect.

	* imail/imail-top.scm[1.146]:
	Take advantage of new MIME support in the mail-sending code.  Forward
	messages as attachments, and disable all MIME processing when
	resending messages.

	* edwin/edwin.pkg[1.259], edwin/sendmail.scm[1.53]:
	Another pass at the MIME stuff.  This one seems to work OK, by
	providing a way for imail-resend to disable MIME processing.  (Also,
	all MIME headers are stripped out before building up the MIME
	framework.)  This code now supports MIME attachments, although there
	needs to be a command to allow the user to attach a file or the
	original mail message (if any), and also there needs to be an
	attachment browser.

2000-06-08  Chris Hanson <cph@zurich.ai.mit.edu>

	* edwin/sendmail.scm[1.52]:
	Disable MIME-compliance checks.  There are strange interactions
	between them and forwarding/resending that cause trouble, and I don't
	have time to fix it right now.

	* imail/imail-top.scm[1.145]:
	Don't allow user to edit resent mail.

	* edwin/sendmail.scm[1.51], edwin/sendmail.scm[1.50]:
	Initial attempt to guarantee MIME compliance when sending messages.

	* runtime/mime-codec.scm[14.2]:
	Fix bug: MIME requires that quoted-printable encodings use upper-case
	characters for hex digits.

	* imail/imail-top.scm[1.143]:
	Fix typo.

	* edwin/edwin.pkg[1.258], edwin/occur.scm[1.5]:
	Create new interface for programmatic invocation of M-x occur.

	* imail/todo.txt[1.71]:
	Notes regarding insertion of messages into outgoing mail.

	* imail/imail-top.scm[1.142]:
	Change sending of mail so that insertion of original mail into sent
	mail doesn't just use the formatted text from the IMAIL buffer, but
	instead uses the original message body.

	* imail/imail-core.scm[1.99]:
	Extend ->HEADER-FIELDS to accept a string.

	* edwin/sendmail.scm[1.49], edwin/sendmail.scm[1.48]:
	Add hook to allow custom hook to run when yanking original message
	into reply buffer.

	* imail/imail-top.scm[1.141]:
	Fix typo in previous change.

	* imail/Attic/rfc822.scm[1.10], imail/compile.scm[1.10],
	  imail/ed-ffi.scm[1.12], imail/fake-env.scm[1.4],
	  imail/imail.pkg[1.52], imail/load.scm[1.17]:
	Move RFC-822 support to Edwin proper.

	* edwin/decls.scm[1.69], edwin/ed-ffi.scm[1.50], edwin/edwin.ldr[1.70],
	  edwin/edwin.pkg[1.257], edwin/rfc822.scm[3.2], edwin/rfc822.scm[3.1],
	  edwin/rmail.scm[1.71], edwin/sendmail.scm[1.47], edwin/snr.scm[1.57]:
	Import RFC-822 support from IMAIL.

	* imail/imail-top.scm[1.140], imail/todo.txt[1.70]:
	Show alternative forms as attachments in MIME multipart/alternative.
	Don't show text messages with unknown encodings.

	* imail/Attic/mime-codec.scm[1.11], imail/compile.scm[1.9],
	  imail/ed-ffi.scm[1.11], imail/imail.pkg[1.51], imail/load.scm[1.16],
	  imail/load.scm[1.15], runtime/mime-codec.scm[14.1],
	  runtime/optiondb.scm[1.9], runtime/runtime.pkg[14.350]:
	Move MIME codecs from IMAIL into the runtime system.

	* imail/imail-top.scm[1.139], imail/todo.txt[1.69],
	  imail/todo.txt[1.68]:
	Restrict set of recognized character sets to US-ASCII, ISO-8859, and
	Windows-<n>.  Messages in other sets are treated as unknowns;
	character set appears in attachment descriptor.

	* imail/imail-top.scm[1.138]:
	Change key binding of imail-copy-folder to C to be consistent with
	Dired.

	* imail/imail-top.scm[1.137]:
	Fix documentation for M-x imail-rename-folder.

	* imail/imail-top.scm[1.136], imail/imail.pkg[1.50]:
	Implement M-x imail-rename-folder.

	* imail/Attic/mime-codec.scm[1.10], imail/imail-top.scm[1.144]:
	Fix compiler warning.

	* imail/imail-top.scm[1.135], imail/imail.pkg[1.49],
	  imail/todo.txt[1.67]:
	Rewrite to use new MIME codecs.  Merge two auto-wrap variables into
	one.  Trailing newline no longer part of attachment's marked region.

	* imail/Attic/mime-codec.scm[1.9]:
	Rewrite the quoted-printable decoder, again.  This one is much simpler
	and works.

2000-06-07  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/Attic/mime-codec.scm[1.8], imail/imail.pkg[1.48]:
	Complete redesign of the MIME codecs.  This design is mostly working,
	except for the quoted-printable decoder, which is too complicated and
	still has some subtle bugs.

	* imail/todo.txt[1.66]:
	Notes re incorrect selection by M-x imail-get-new-mail.

	* imail/todo.txt[1.65]:
	Various notes regarding handling of MIME type and encoding.

	* runtime/advice.scm[14.17]:
	Fix another place still using the old newline convention.

2000-06-05  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.114]:
	Undo previous change.  This was being handled elsewhere and was never
	removed from the to-do list.

	* imail/imail-imap.scm[1.113], imail/imail-top.scm[1.134],
	  imail/todo.txt[1.64]:
	Generate message "No changes to save." from SAVE-FOLDER on an IMAP
	folder.

	* imail/imail-imap.scm[1.112], imail/imail-top.scm[1.133],
	  imail/todo.txt[1.63]:
	Rename the procedures that form the UI callback interface to make it
	clear what their role is.

	* imail/imail-top.scm[1.132]:
	When auto-wrap enabled, wrap at right margin rather than at
	fill-column.  Also, don't set truncate-lines.

	* imail/imail-core.scm[1.98], imail/imail-imap.scm[1.111],
	  imail/imail-rmail.scm[1.38], imail/imail-top.scm[1.131],
	  imail/imail-umail.scm[1.31], imail/imail.pkg[1.47]:
	Unify handling of body cache.  Add editor variable to control the
	caching.

	* imail/imail-top.scm[1.130], imail/imail.pkg[1.46],
	  imail/todo.txt[1.62]:
	Replace imail-toggle-headers with imail-toggle-message, which toggles
	between the standard and raw formats of a message.

	* imail/imail-top.scm[1.129]:
	Update imail-mode help.

	* edwin/hlpcom.scm[1.116]:
	Make help buffers read-only.

	* imail/imail-imap.scm[1.110]:
	Fix bug: a couple of places explicitly referenced the flag "\\recent"
	which was changed to "recent".

	* imail/imail-imap.scm[1.109]:
	When reading entire body of MIME message, use MESSAGE-BODY.

	* imail/imail-top.scm[1.128], imail/todo.txt[1.61]:
	Fix bug: When message was selected in IMAIL and deleted by a different
	user agent, IMAIL would end up in state where there is no selected
	message.  Now, it selects another message.

	* imail/imail-core.scm[1.97], imail/imail-imap.scm[1.108],
	  imail/imail-top.scm[1.127]:
	Change interface to MESSAGE-MIME-BODY-PART to specify whether to cache
	the part.

	* edwin/basic.scm[1.139]:
	Fix thinko from last change.

	* imail/imail-imap.scm[1.107], imail/todo.txt[1.60]:
	Store bodystructure in IMAP message in converted form, so conversion
	only happens once.

	* imail/imail-top.scm[1.126], imail/todo.txt[1.59]:
	Change attachment tag to show length of attachment.

	* imail/imail-imap.scm[1.106], imail/todo.txt[1.58]:
	Add cache for MIME body parts.

	* imail/imail-imap.scm[1.105]:
	Save server capabilities for later reference.

	* imail/imail-imap.scm[1.104]:
	Map all IMAP system flags to names without leading backslash.

	* imail/todo.txt[1.57]:
	Add some new items.

	* imail/imail-top.scm[1.125]:
	Fix bug: don't signal error if attachment lacks a filename parameter.

2000-06-03  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.103]:
	Fix bug: STATUS command returns a response!  (Duh)

	* imail/imail-top.scm[1.124]:
	When saving attachment, check to see if file exists before blindly
	overwriting it.

	* imail/Attic/mime-codec.scm[1.7]:
	Change decoders to decode to a port rather than to a string.  This is
	almost always more efficient.

	* imail/imail-top.scm[1.123]:
	Implement mechanism to save MIME attachments.  Reorganize this file a
	little to make sections more coherent.

2000-06-02  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.122]:
	Add workaround for broken Netscape mailer.

	* imail/imail-core.scm[1.96]:
	Change MIME bodystructure objects to have properties.

	* imail/imail-top.scm[1.121]:
	Tweak attachment syntax slightly.

	* edwin/things.scm[1.88]:
	Eliminate usage of MARK-PERMANENT!.

	* imail/todo.txt[1.56]:
	Ideas about MIME stuff.

	* imail/imail-top.scm[1.120]:
	Fix bug in how message/rfc822 entities were presented (headers were
	being shown twice).  Change text representation of attachments, and
	binding information to the buffer so that the attachment can later be
	saved.

	* imail/imail-imap.scm[1.102]:
	Fix bug: MIME disposition wasn't being converted to canonical form.

	* imail/imail-core.scm[1.95]:
	Add MIME-BODY-PARAMETER.

	* imail/install.sh[1.4]:
	Update to reflect new organization.

	* imail/todo.txt[1.55]:
	Remove two suggestions prompted by Julie's problems with automatic
	conversion to quoted-printable.

	* imail/imail-top.scm[1.119]:
	Show "text/plain" entities regardless of character set.  There are
	some pretty broken mailers out there (e.g. Outlook Express) that claim
	random character sets when they should be claiming "us-ascii".

	* imail/imail-core.scm[1.94]:
	Print out <MIME-BODY> instances in more intelligible form.

	* imail/imail.pkg[1.45], imail/load.scm[1.14]:
	Move Edwin variable exports back to "imail.pkg".  Add subsystem ID
	string for IMAIL.

	* imail/imail-top.scm[1.118]:
	Refine the auto-wrap feature to have separate controlling variables
	for encoded and unencoded parts.
	
	Fix URL completion so that it verifies values correctly by calling
	URL-EXISTS?, and change callers to specify when the URL they are
	prompting for must exist.

	* imail/imail-imap.scm[1.101], imail/todo.txt[1.54]:
	Implement URL-EXISTS? for IMAP folders.

	* imail/imail-top.scm[1.117]:
	Add automatic wrapping of long lines in decoded MIME entities.

	* imail/imail-imap.scm[1.100]:
	Show progress when reading MIME body parts.

	* edwin/basic.scm[1.138], edwin/fill.scm[1.64]:
	Change AUTO-FILL-BREAK so that it accepts a mark as an argument, and
	returns a boolean indicating whether it broke the line.

2000-06-01  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.116], imail/imail.pkg[1.44],
	  imail/load.scm[1.13]:
	Initial cut at MIME decoding support.

	* imail/imail-imap.scm[1.99]:
	Generalize MESSAGE-MIME-BODY-PART to allow passing selector ending in
	HEADER or TEXT.

	* imail/imail.pkg[1.43]:
	Load "mime-codec" after "imail-util" due to load-time dependencies.

	* imail/imap-response.scm[1.33]:
	Signal an error if unable to parse BODY section in FETCH response.

	* imail/Attic/parser.scm[1.4]:
	Fix two bugs in LIST-PARSER.

	* imail/imail-imap.scm[1.98]:
	Store MIME multipart components in a list rather than a vector.

	* imail/Attic/mime-codec.scm[1.6]:
	When decoding BASE64 text strings, must return two values.

	* imail/imail-core.scm[1.93], imail/imail-imap.scm[1.97]:
	Implement MESSAGE-MIME-BODY-PART.

	* imail/imail.pkg[1.42], imail/imap-response.scm[1.32]:
	Implement IMAP:RESPONSE:FETCH-BODY-PART.

	* imail/Attic/mime-codec.scm[1.5]:
	Fix compiler warnings.

	* imail/compile.scm[1.8], imail/ed-ffi.scm[1.10],
	  imail/imail.pkg[1.41]:
	Add "mime-codec" to package.

	* imail/Attic/mime-codec.scm[1.4]:
	Add newline translation to BASE64 decoder for case where the data
	being decoded is text.

	* imail/imail-core.scm[1.92], imail/imail-file.scm[1.41],
	  imail/imail-imap.scm[1.96]:
	Add generic interface to access MIME BODYSTRUCTURE information.

	* imail/imap-response.txt[1.6]:
	Fix two bugs in syntax.

	* imail/Attic/imail-imap-url.scm[1.11], imail/Attic/test-imap.scm[1.2]:
	Removing files no longer in use.

2000-05-31  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/install.sh[1.3]:
	Copy entire contents of directory to installation point.  This now
	matters so that copy in my directory will act as a branch for
	development.

	* imail/imail-top.scm[1.115]:
	Fix typo.

2000-05-30  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-top.scm[1.114]:
	When showing progress meter, don't show percentage when amount read is
	either zero or the total amount.  This causes the display to flicker
	and provides no useful information.

	* imail/imail-imap.scm[1.95]:
	Use STRING->HEADER-FIELDS.

	* imail/imail-util.scm[1.27]:
	Fix bug: STRING->LINES must not return an empty list.

	* imail/imail-top.scm[1.113], imail/load.scm[1.12]:
	Change M-x imail-input, M-x imail, and M-x imail-get-new-mail to more
	closely mimic their RMAIL counterparts.

	* imail/Attic/mime-codec.scm[1.3]:
	Fix typo in DECODE-QP-HEX-OCTET.

	* imail/todo.txt[1.53]:
	Need command to move to first unseen message in folder.

	* imail/imap-response.scm[1.31]:
	Rewrite READ-LITERAL with two aims: (1) to make the newline
	translation more efficient, and (2) to generalize it so that MIME
	decoding can be directly hooked in.

	* runtime/strout.scm[14.14]:
	GET-OUTPUT-FROM-ACCUMULATOR should return the internal accumulator
	string, rather than copying the string to a new one.  Since the
	internal accumulator is discarded, this is not a problem, and offers
	significant efficiency gains.

2000-05-29  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-response.scm[1.30]:
	Fix typo.

	* imail/imap-response.scm[1.29]:
	Pull transcript handling from READ-LITERAL to new
	READ-SUBSTRING!-INTERNAL.

2000-05-28  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-response.scm[1.28]:
	Tweak conditions under which literal progress hook is called.

	* imail/imap-response.scm[1.27]:
	Modularize line-ending translator.

	* imail/imap-response.scm[1.26], imail/imap-response.txt[1.5]:
	Disambiguate the "section" form of the BODY response from the
	"bodystructure" form.

	* imail/imail-imap.scm[1.94]:
	Don't remove IMAP connections from the memoized list when they are
	closed.  Each folder retains a pointer to its connection after closing
	it, and may reopen the connection later.  When this happens, it
	defeats the purpose of the memoization.

2000-05-27  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imap-response.txt[1.4]:
	Fix minor bug in description of FETCH BODY responses.

	* imail/Attic/mime-codec.scm[1.2]:
	Implement BASE64 decoder.

	* imail/imail-util.scm[1.26]:
	Implement SKIP-LWSP-BACKWARDS.

2000-05-26  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/install.sh[1.2]:
	Only install required files.

	* imail/imail-top.scm[1.112]:
	Set truncate-lines to #t in buffer that pops up to show messages to be
	expunged.

	* imail/Attic/mime-codec.scm[1.1]:
	Initial registration.

	* imail/imail-imap.scm[1.93]:
	Add ability to obtain envelope and bodystructure information from the
	server.

2000-05-25  Chris Hanson <cph@zurich.ai.mit.edu>

	* imail/imail-imap.scm[1.92]:
	Reorganize login code so that login errors are properly signalled.

	* imail/imail-top.scm[1.111], imail/todo.txt[1.52]:
	If M-x imail finds existing buffer visiting the folder, it just
	selects it and runs M-x imail-get-new-mail.

	* imail/imail-top.scm[1.110], imail/todo.txt[1.51]:
	Generalize imail-expunge-confirmation to make the type of prompt and
	the showing of message independently selectable.

